CREATE TABLE HISTORY
(
  ID                             NUMERIC(16)         NOT NULL,
  OPERATION                      NUMERIC(3)          NOT NULL,
  STATUS                         NUMERIC(16)         DEFAULT 0 NOT NULL,
  ENT_TYPE                       NUMERIC(16)         NOT NULL,
  ENT_ID                         NUMERIC(16)         NOT NULL,
  ENT_DESC                       VARCHAR(512),
  ENT_NAME                       VARCHAR(256),
  ENT_VAL1                       VARCHAR(512),
  ENT_VAL2                       VARCHAR(512),
  ENT_VAL3                       VARCHAR(512),
  ENT_VAL4                       VARCHAR(512),
  ENT_VAL5                       VARCHAR(512),
  OLD_VAL                        VARCHAR(512),
  OLD_VAL_EXT1                   VARCHAR(512),
  OLD_VAL_EXT2                   VARCHAR(512),
  OLD_VAL_EXT3                   VARCHAR(512),
  OLD_VAL_EXT4                   VARCHAR(512),
  OLD_VAL_EXT5                   VARCHAR(512),
  NEW_VAL                        VARCHAR(512),
  NEW_VAL_EXT1                   VARCHAR(512),
  NEW_VAL_EXT2                   VARCHAR(512),
  NEW_VAL_EXT3                   VARCHAR(512),
  NEW_VAL_EXT4                   VARCHAR(512),
  NEW_VAL_EXT5                   VARCHAR(512),
  FIELD                          VARCHAR(512),
  FIELD_LBL                      VARCHAR(512),
  NOTE                           VARCHAR(4000),
  ATTR1                          VARCHAR(256),
  ATTR2                          VARCHAR(256),
  ATTR3                          VARCHAR(256),
  ATTR4                          VARCHAR(256),
  ATTR5                          VARCHAR(256),
  LAST_MOD_USER                  VARCHAR(128),
  LAST_MOD_TIME                  DATE                DEFAULT CURRENT_DATE,
  REVISION                       NUMERIC(16)         DEFAULT 0 NOT NULL
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE HISTORY ADD
  CONSTRAINT HISTORY_PK
 PRIMARY KEY (ID);

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE HISTORY' );

CREATE SEQUENCE HISTORY_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

CREATE OR REPLACE TRIGGER TRG_ENTITLEMENT_HISTORY
  AFTER INSERT OR UPDATE OR DELETE ON ENTITLEMENT
  FOR EACH ROW
declare
begin
  null;
end TRG_ENTITLEMENT_HISTORY;
/

CREATE OR REPLACE TRIGGER TRG_ENT_HIER_HISTORY
  BEFORE INSERT OR DELETE ON ENTITLEMENT_HIER
  FOR EACH ROW
declare
begin
  null;
end TRG_ENT_HIER_HISTORY;
/
