CREATE TABLE PWDSYNC_CFG
(
  ID                             NUMBER(16)           NOT NULL,
  NAME                           VARCHAR2(256)        NOT NULL,
  DESCRIPTION                    VARCHAR2(512),
  ATTR1                          VARCHAR2(256),
  ATTR2                          VARCHAR2(256),
  ATTR3                          VARCHAR2(256),
  ATTR4                          VARCHAR2(256),
  ATTR5                          VARCHAR2(256),
  CREATION_USER                  VARCHAR2(128),
  CREATION_DATE                  DATE                DEFAULT SYSDATE,
  LAST_MOD_USER                  VARCHAR2(128),
  LAST_MOD_TIME                  DATE                DEFAULT SYSDATE
)
TABLESPACE &DATA_TABLESPACE
;

ALTER TABLE PWDSYNC_CFG
  ADD CONSTRAINT PWDSYNC_CFG_PK PRIMARY KEY (ID)
  USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

GRANT ALL ON PWDSYNC_CFG TO IDEAS;
GRANT ALL ON PWDSYNC_CFG TO IDEAS_CONNECTOR;

CREATE SEQUENCE PWDSYNC_CFG_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER;

GRANT ALL ON PWDSYNC_CFG_SEQ TO IDEAS;
GRANT ALL ON PWDSYNC_CFG_SEQ TO IDEAS_CONNECTOR;

ALTER TABLE PWDCFG
  ADD PWDSYNC_CFG NUMBER(16);

ALTER TABLE PWDCFG
 ADD CONSTRAINT PWDCFG_PWDSYNC_CFG_FK
 FOREIGN KEY (PWDSYNC_CFG)
 REFERENCES PWDSYNC_CFG (ID)
 ON DELETE SET NULL;
