declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE TABLE PWDSYNC_CFG
  (
    ID                             NUMBER(16)           NOT NULL,
    NAME                           VARCHAR2(256)        NOT NULL,
    DESCRIPTION                    VARCHAR2(512),
    ATTR1                          VARCHAR2(256),
    ATTR2                          VARCHAR2(256),
    ATTR3                          VARCHAR2(256),
    ATTR4                          VARCHAR2(256),
    ATTR5                          VARCHAR2(256),
    CREATION_USER                  VARCHAR2(128),
    CREATION_DATE                  DATE                DEFAULT SYSDATE,
    LAST_MOD_USER                  VARCHAR2(128),
    LAST_MOD_TIME                  DATE                DEFAULT SYSDATE
  )
  TABLESPACE &DATA_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE PWDSYNC_CFG
    ADD CONSTRAINT PWDSYNC_CFG_PK PRIMARY KEY (ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON PWDSYNC_CFG TO IDEAS;
GRANT ALL ON PWDSYNC_CFG TO IDEAS_CONNECTOR;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE PWDSYNC_CFG_SEQ
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999999999999
    NOCACHE
    NOCYCLE
    NOORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON PWDSYNC_CFG_SEQ TO IDEAS;
GRANT ALL ON PWDSYNC_CFG_SEQ TO IDEAS_CONNECTOR;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-01430); -- column being added already exists in table

begin
  stat := '
  ALTER TABLE PWDCFG
    ADD PWDSYNC_CFG NUMBER(16)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02275); -- such a referential constraint already exists in the table

begin
  stat := '
  ALTER TABLE PWDCFG
   ADD CONSTRAINT PWDCFG_PWDSYNC_CFG_FK
   FOREIGN KEY (PWDSYNC_CFG)
   REFERENCES PWDSYNC_CFG (ID)
   ON DELETE SET NULL
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/
