declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE PWDSYNC_CFG
  (
    ID                             NUMERIC(16)         NOT NULL,
    NAME                           VARCHAR(256)        NOT NULL,
    DESCRIPTION                    VARCHAR(512),
    ATTR1                          VARCHAR(256),
    ATTR2                          VARCHAR(256),
    ATTR3                          VARCHAR(256),
    ATTR4                          VARCHAR(256),
    ATTR5                          VARCHAR(256),
    CREATION_USER                  VARCHAR(128),
    CREATION_DATE                  DATE                DEFAULT CURRENT_DATE,
    LAST_MOD_USER                  VARCHAR(128),
    LAST_MOD_TIME                  DATE                DEFAULT CURRENT_DATE
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  LONG IN &LOB_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
  ALTER TABLE PWDSYNC_CFG
    ADD CONSTRAINT PWDSYNC_CFG_PK
    PRIMARY KEY (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE PWDSYNC_CFG' );

GRANT ALL ON PWDSYNC_CFG TO IGA;
GRANT ALL ON PWDSYNC_CFG TO IGACONN;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE SEQUENCE PWDSYNC_CFG_SEQ
    AS NUMERIC(18)
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999
    NO CACHE
    NO CYCLE
    NO ORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/
  
GRANT USAGE ON SEQUENCE PWDSYNC_CFG_SEQ TO IGA;
GRANT USAGE ON SEQUENCE PWDSYNC_CFG_SEQ TO IGACONN;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42711'); -- duplicate name

begin
  stat := '
  ALTER TABLE PWDCFG
    ADD PWDSYNC_CFG NUMERIC(16)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  ALTER TABLE PWDCFG
    ADD CONSTRAINT PWDCFG_PWDSYNC_CFG_FK
    FOREIGN KEY (PWDSYNC_CFG)
    REFERENCES PWDSYNC_CFG (ID)
    ON DELETE SET NULL
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/
