declare
  im_id         numeric(16);
  im_name       varchar(256) := 'AGC';

  fc_id         numeric(16);
  fc_name       varchar(256) := 'hiddenSharedSpace';

  r_fc_id       numeric(16);
  r_fc_name     varchar(256) := 'password';
  
  fevt_id       numeric(16);
  fevt_name     varchar(256) := '<Empty>';

  r_fevt_id     numeric(16);
  r_fevt_name   varchar(256) := '<Empty>';
  
  f_id          numeric(16);
  f_name        varchar(256) := 'PasswordSharedRules';

  counter       numeric(16);
begin
  select count(1) into counter from ideas_module t where lower ( t.code ) = lower ( im_name );
  if ( counter = 1 ) then
    select t.id into im_id from ideas_module t where lower ( t.code ) = lower ( im_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO IDEAS MODULE FOUND');
  end if;

  select count(1) into counter from flow_context t where lower ( t.name ) = lower ( fc_name );
  if ( counter = 1 ) then
    select t.id into fc_id from flow_context t where lower ( t.name ) = lower ( fc_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW CONTEXT FOUND');
  end if;

  select count(1) into counter from flow_event_type t
  where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevt_name );
  if ( counter = 0 ) then
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW EVENT TYPE FOUND');
  else
    select t.id into fevt_id from flow_event_type t
    where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevt_name );
  end if;
  
  select count(1) into counter from flow t
  where t.ideas_module = im_id and t.flow_event_type = fevt_id and lower ( t.name ) = lower ( f_name ); 
  if ( counter = 0 ) then
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW FOUND');
  else
    select t.id into f_id from flow t
    where t.ideas_module = im_id and t.flow_event_type = fevt_id and lower ( t.name ) = lower ( f_name );
  end if;

  select count(1) into counter from flow_context t where lower ( t.name ) = lower ( r_fc_name );
  if ( counter = 1 ) then
    select t.id into r_fc_id from flow_context t where lower ( t.name ) = lower ( r_fc_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW CONTEXT FOUND');
  end if;

  select count(1) into counter from flow_event_type t
  where t.flow_context = r_fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( r_fevt_name );
  if ( counter = 0 ) then
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW EVENT TYPE FOUND');
  else
    select t.id into r_fevt_id from flow_event_type t
    where t.flow_context = r_fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( r_fevt_name );
    update flow_event_type set shared_flow = f_id where id = r_fevt_id;
  end if;

end;
/
commit;
