CREATE OR REPLACE function event_11_funct_rem
(
  v_eventpm in eventpm%rowtype,
  v_user_erc_id in numeric(31),
  v_state in numeric(31),
  v_trace in varchar(4000),
  v_cod_operation in varchar(4000),
  v_priority in numeric(31)
)
return numeric(31) is
-- **** OPERATION 2 - REMOVE FUNCTIONALITY **** --

  -- cursore temporaneo
  cur_tmp           sys_refcursor;

  v_operation       numeric(2);
  v_functionality   varchar(256);
  v_functionality_real   varchar(256);  
  v_prof_type       varchar(256);
  v_target          varchar(256);
  v_application     varchar(256);

  v_current_aut     numeric(16);
  v_counter         numeric(16);
  v_id_profile      numeric(16);
  v_id_represented  numeric(16);

  --delegato
  v_user_erc_repres numeric(16);

  v_acc_user_code   varchar(256);

  v_funct_ext_type  varchar(256);
  v_funct_code      varchar(256);

  v_event_out       numeric(16);

  v_attr_perm       varchar(256);
begin
  v_operation := 2;

  open cur_tmp for select count(id) from person p where p.id = v_eventpm.person;
  fetch cur_tmp into v_counter;
  close cur_tmp;

  if ( v_counter <= 0 ) then
    -- user not found
    return 99;
  end if;

  open cur_tmp for
    select t.profile, t.represented
      from authorizations t
     where t.id = v_eventpm.authorizations;

  fetch cur_tmp into v_id_profile, v_id_represented;
  close cur_tmp;

  -- max authorizations
  open cur_tmp for
    select max(t.id) from authorizations t;

  fetch cur_tmp into v_current_aut;
  close cur_tmp;

  open cur_tmp for
    select t.functionality, e.name,t.profile_type, t.application, t.target, t.functionality_ext_type, t.functionality_code, t.attribute_based
      from authorizations t left join entitlement e
        on e.id = t.profile
    where t.id = v_eventpm.authorizations;

  fetch cur_tmp into v_functionality, v_functionality_real, v_prof_type, v_application, v_target, v_funct_ext_type, v_funct_code, v_attr_perm;
  close cur_tmp;
  
  if ( v_functionality_real is not null ) then
    v_functionality := v_functionality_real;
  end if;

  if ( v_target is null ) then
     return 99;
  end if;

  open cur_tmp for
    select
      distinct auth.account_code
    from
      authorizations auth
    where auth.id = v_eventpm.authorizations;

    fetch cur_tmp into v_acc_user_code;
  close cur_tmp;

  open cur_tmp for
    select count(1)
      from authorizations t
     where t.person = v_eventpm.person
       and t.profile = v_id_profile
       and t.id <= v_current_aut;

  fetch cur_tmp into v_counter;
  close cur_tmp;

  if ( v_counter = 1 ) then

    update feedback
       set user_erc          = v_user_erc_id,
           application       = v_target,
           funct             = v_functionality,
           funct_type        = v_prof_type,
           funct_application = v_application
     where authorizations = v_eventpm.authorizations
       and operation = v_operation;

    select event_out_seq.nextval into v_event_out from dual;
    -- notifico rimozione
    insert into event_out
      (id, user_erc, person, state, trace, target, cod_operation, operation,
       attr1, attr2, application, last_mod_time, last_mod_user, priority, user_id,
       attr3, attr4, attr5)
    values
      (v_event_out, v_user_erc_id, v_eventpm.person, v_state, v_trace, v_target, v_cod_operation, '2',
       v_functionality, v_prof_type, v_application, sysdate, user, v_priority, v_acc_user_code,
       v_funct_code, v_attr_perm, v_funct_ext_type);

    delete from person_profile t
    where t.person = v_eventpm.person and t.profile = v_id_profile and t.status in (0, 14);

    update person_profile set ext_id = v_event_out, status = 0, verify_date = sysdate 
    where person = v_eventpm.person and profile = v_id_profile;
  else
    delete from feedback t
     where t.authorizations = v_eventpm.authorizations
       and t.operation = v_operation;
  end if;

  -- verifico presenza delega
  if ( v_id_represented is not null ) then

    open cur_tmp for
      select p.user_erc
        from person p, user_erc ue
       where p.user_erc = ue.id
         and p.id = v_id_represented;

    fetch cur_tmp into v_user_erc_repres;
    close cur_tmp;

    if ( v_user_erc_repres is null ) then
      return 1;
    end if;

    open cur_tmp for
      select count(1)
        from authorizations t
       where t.person = v_eventpm.person
         and t.represented = v_id_represented
         and t.id <= v_current_aut;

    fetch cur_tmp into v_counter;
    close cur_tmp;

    if ( v_counter = 1 ) then
      select event_out_seq.nextval into v_event_out from dual;
      -- notifico rimozione delega
      insert into event_out
        (id, user_erc, person, state, trace, target, cod_operation, operation,
         application, last_mod_time, last_mod_user, user_id)
      values
        (v_event_out, v_user_erc_id, v_eventpm.person, v_state, v_trace, v_target, v_cod_operation, '5',
         v_application, sysdate, user, v_acc_user_code);

      delete from person_profile t
      where t.person = v_eventpm.person and t.profile = v_id_profile and t.status in (0, 14);

      update person_profile set ext_id = v_event_out, status = 0, verify_date = sysdate 
      where person = v_eventpm.person and profile = v_id_profile;
    end if;

  end if;

  return v_operation;
end event_11_funct_rem;
/
