CREATE TABLE PWDMANAGEMENT_TYPE
(
  ID                             NUMERIC(16)         NOT NULL,
  NAME 							 VARCHAR(256)        NOT NULL,
  DESCRIPTION                    VARCHAR(512),
  PWD_SYNC						 NUMERIC(1)			 DEFAULT 0 NOT NULL,	
  STATE                          NUMERIC(16)         DEFAULT 0,
  ATTR1                          VARCHAR(256),
  ATTR2                          VARCHAR(256),
  ATTR3                          VARCHAR(256),
  ATTR4                          VARCHAR(256),
  ATTR5                          VARCHAR(256),
  LAST_MOD_USER                  VARCHAR(128),
  LAST_MOD_TIME                  DATE                DEFAULT CURRENT_DATE
) 
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE PWDMANAGEMENT_TYPE ADD
  CONSTRAINT PWDMANAGEMENT_TYPE_PK
 PRIMARY KEY (ID);

GRANT ALL ON PWDMANAGEMENT_TYPE TO IGA;
GRANT ALL ON PWDMANAGEMENT_TYPE TO IGACONN;
GRANT ALL ON PWDMANAGEMENT_TYPE TO REP;
GRANT ALL ON PWDMANAGEMENT_TYPE TO AA;

CREATE SEQUENCE EMPLOYMENT_PWDMANAGEMENT_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

GRANT USAGE ON SEQUENCE PWDMANAGEMENT_TYPE_SEQ TO IGA;
GRANT USAGE ON SEQUENCE PWDMANAGEMENT_TYPE_SEQ TO IGACONN;
GRANT USAGE ON SEQUENCE PWDMANAGEMENT_TYPE_SEQ TO REP;
GRANT USAGE ON SEQUENCE PWDMANAGEMENT_TYPE_SEQ TO AA;

CREATE UNIQUE INDEX PWDMANTYPE_LNAME_IDX ON PWDMANAGEMENT_TYPE
(LOWER(NAME));

CREATE UNIQUE INDEX PWDMANTYPE_LNAME_ID_IDX ON PWDMANAGEMENT_TYPE
(LOWER(NAME), ID);

ALTER TABLE PWDMANAGEMENT ADD COLUMN PWDMANAGEMENT_TYPE NUMERIC(16);

CREATE INDEX PWDMANAGEMENT_PWDMAN_TYPE_IDX ON PWDMANAGEMENT
(PWDMANAGEMENT_TYPE);

ALTER TABLE PWDMANAGEMENT ADD
  CONSTRAINT PWDMANAGEMENT_PWDMAN_TYPE_FK
 FOREIGN KEY (PWDMANAGEMENT_TYPE)
 REFERENCES PWDMANAGEMENT_TYPE (ID)
    ON DELETE SET NULL;
