  CREATE TABLE PWDMANAGEMENT_TYPE
  (
    ID                             NUMBER(16)          NOT NULL,
    NAME 						   VARCHAR2(256)       NOT NULL,
    DESCRIPTION                    VARCHAR2(512),
    PWD_SYNC				       NUMBER(1)		   DEFAULT 0 NOT NULL,	
    STATE                          NUMBER(16)          DEFAULT 0,
    ATTR1                          VARCHAR2(256),
    ATTR2                          VARCHAR2(256),
    ATTR3                          VARCHAR2(256),
    ATTR4                          VARCHAR2(256),
    ATTR5                          VARCHAR2(256),
    LAST_MOD_USER                  VARCHAR2(128),
    LAST_MOD_TIME                  DATE                DEFAULT SYSDATE
  ) 
  TABLESPACE &DATA_TABLESPACE
  ;

ALTER TABLE PWDMANAGEMENT_TYPE ADD
  CONSTRAINT PWDMANAGEMENT_TYPE_PK
 PRIMARY KEY (ID)
 USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
 ;

GRANT ALL ON PWDMANAGEMENT_TYPE TO IDEAS;
GRANT ALL ON PWDMANAGEMENT_TYPE TO IDEAS_CONNECTOR;
GRANT ALL ON PWDMANAGEMENT_TYPE TO IDEAS_REPORT;
GRANT ALL ON PWDMANAGEMENT_TYPE TO AA;

CREATE SEQUENCE EMPLOYMENT_PWDMANAGEMENT_SEQ
  CREATE SEQUENCE PWDMANAGEMENT_TYPE_SEQ
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999999999999
    NOCACHE
    NOCYCLE
    NOORDER;

GRANT ALL ON PWDMANAGEMENT_TYPE_SEQ TO IDEAS;
GRANT ALL ON PWDMANAGEMENT_TYPE_SEQ TO IDEAS_CONNECTOR;
GRANT ALL ON PWDMANAGEMENT_TYPE_SEQ TO IDEAS_REPORT;
GRANT ALL ON PWDMANAGEMENT_TYPE_SEQ TO AA;

CREATE UNIQUE INDEX PWDMANTYPE_LNAME_IDX ON PWDMANAGEMENT_TYPE
(LOWER(NAME))
 NOLOGGING
 NOPARALLEL
 TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

CREATE UNIQUE INDEX PWDMANTYPE_LNAME_ID_IDX ON PWDMANAGEMENT_TYPE
(LOWER(NAME), ID)
 NOLOGGING
 NOPARALLEL
 TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

ALTER TABLE PWDMANAGEMENT ADD PWDMANAGEMENT_TYPE NUMBER (16);

CREATE INDEX PWDMANAGEMENT_PWDMAN_TYPE_IDX ON PWDMANAGEMENT
(PWDMANAGEMENT_TYPE)
 NOLOGGING
 NOPARALLEL
 TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

ALTER TABLE PWDMANAGEMENT ADD
  CONSTRAINT PWDMANAGEMENT_PWDMAN_TYPE_FK
 FOREIGN KEY (PWDMANAGEMENT_TYPE)
 REFERENCES PWDMANAGEMENT_TYPE (ID)
    ON DELETE SET NULL;
