declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE PWDMANAGEMENT_TYPE
  (
    ID                             NUMERIC(16)         NOT NULL,
    NAME 						   VARCHAR(256)        NOT NULL,
    DESCRIPTION                    VARCHAR(512),
    PWD_SYNC				       NUMERIC(1)			 NOT NULL DEFAULT 0,	
    STATE                          NUMERIC(16)         DEFAULT 0,
    ATTR1                          VARCHAR(256),
    ATTR2                          VARCHAR(256),
    ATTR3                          VARCHAR(256),
    ATTR4                          VARCHAR(256),
    ATTR5                          VARCHAR(256),
    LAST_MOD_USER                  VARCHAR(128),
    LAST_MOD_TIME                  DATE                DEFAULT CURRENT_DATE
  ) 
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  LONG IN &LOB_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
  ALTER TABLE PWDMANAGEMENT_TYPE
    ADD CONSTRAINT PWDMANAGEMENT_TYPE_PK
    PRIMARY KEY (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE UNIQUE INDEX PWDMANTYPE_LNAME_IDX ON PWDMANAGEMENT_TYPE
  (LOWER(NAME))
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE UNIQUE INDEX PWDMANTYPE_LNAME_ID_IDX ON PWDMANAGEMENT_TYPE
  (LOWER(NAME), ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE PWDMANAGEMENT_TYPE' );

GRANT ALL ON PWDMANAGEMENT_TYPE TO IGA;
GRANT ALL ON PWDMANAGEMENT_TYPE TO IGACONN;
GRANT ALL ON PWDMANAGEMENT_TYPE TO REP;
GRANT ALL ON PWDMANAGEMENT_TYPE TO AA;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE SEQUENCE PWDMANAGEMENT_TYPE_SEQ
    AS NUMERIC(18)
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999
    NO CACHE
    NO CYCLE
    NO ORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/
  
GRANT USAGE ON SEQUENCE PWDMANAGEMENT_TYPE_SEQ TO IGA;
GRANT USAGE ON SEQUENCE PWDMANAGEMENT_TYPE_SEQ TO IGACONN;
GRANT USAGE ON SEQUENCE PWDMANAGEMENT_TYPE_SEQ TO REP;
GRANT USAGE ON SEQUENCE PWDMANAGEMENT_TYPE_SEQ TO AA;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42711'); -- duplicate name

begin
  stat := '
  ALTER TABLE PWDMANAGEMENT
    ADD COLUMN PWDMANAGEMENT_TYPE NUMERIC(16)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  ALTER TABLE PWDMANAGEMENT ADD
    CONSTRAINT PWDMANAGEMENT_PWDMAN_TYPE_FK
   FOREIGN KEY (PWDMANAGEMENT_TYPE)
   REFERENCES PWDMANAGEMENT_TYPE (ID)
      ON DELETE SET NULL
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/
