declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE TABLE PWDMANAGEMENT_TYPE
  (
    ID                             NUMBER(16)          NOT NULL,
    NAME 						   VARCHAR2(256)       NOT NULL,
    DESCRIPTION                    VARCHAR2(512),
    PWD_SYNC				       NUMBER(1)		   DEFAULT 0 NOT NULL,	
    STATE                          NUMBER(16)          DEFAULT 0,
    ATTR1                          VARCHAR2(256),
    ATTR2                          VARCHAR2(256),
    ATTR3                          VARCHAR2(256),
    ATTR4                          VARCHAR2(256),
    ATTR5                          VARCHAR2(256),
    LAST_MOD_USER                  VARCHAR2(128),
    LAST_MOD_TIME                  DATE                DEFAULT SYSDATE
  ) 
  TABLESPACE &DATA_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE PWDMANAGEMENT_TYPE
    ADD CONSTRAINT PWDMANAGEMENT_TYPE_PK
    PRIMARY KEY (ID)
	USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE UNIQUE INDEX PWDMANTYPE_LNAME_IDX ON PWDMANAGEMENT_TYPE
  (LOWER(NAME))
  NOLOGGING
  NOPARALLEL
  TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE UNIQUE INDEX PWDMANTYPE_LNAME_ID_IDX ON PWDMANAGEMENT_TYPE
  (LOWER(NAME), ID)
  NOLOGGING
  NOPARALLEL
  TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/


GRANT ALL ON PWDMANAGEMENT_TYPE TO IDEAS;
GRANT ALL ON PWDMANAGEMENT_TYPE TO IDEAS_CONNECTOR;
GRANT ALL ON PWDMANAGEMENT_TYPE TO IDEAS_REPORT;
GRANT ALL ON PWDMANAGEMENT_TYPE TO AA;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE PWDMANAGEMENT_TYPE_SEQ
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999999999999
    NOCACHE
    NOCYCLE
    NOORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/
  
GRANT ALL ON PWDMANAGEMENT_TYPE_SEQ TO IDEAS;
GRANT ALL ON PWDMANAGEMENT_TYPE_SEQ TO IDEAS_CONNECTOR;
GRANT ALL ON PWDMANAGEMENT_TYPE_SEQ TO IDEAS_REPORT;
GRANT ALL ON PWDMANAGEMENT_TYPE_SEQ TO AA;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-01430); -- name is already used by an existing object

begin
  stat := '
  ALTER TABLE PWDMANAGEMENT
    ADD PWDMANAGEMENT_TYPE NUMBER(16)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02275); -- such a referential constraint already exists in the table

begin
  stat := '
  ALTER TABLE PWDMANAGEMENT ADD
    CONSTRAINT PWDMANAGEMENT_PWDMAN_TYPE_FK
   FOREIGN KEY (PWDMANAGEMENT_TYPE)
   REFERENCES PWDMANAGEMENT_TYPE (ID)
      ON DELETE SET NULL
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/
