CREATE TABLE EMPLOYMENT_PWDMANAGEMENT
(
  ID                             NUMBER(16)         NOT NULL,
  EMPLOYMENT					 NUMBER(16)         NOT NULL,
  PWDMANAGEMENT					 NUMBER(16)         NOT NULL,
  STATE                          NUMBER(16)         DEFAULT 0,
  ATTR1                          VARCHAR2(256),
  ATTR2                          VARCHAR2(256),
  ATTR3                          VARCHAR2(256),
  ATTR4                          VARCHAR2(256),
  ATTR5                          VARCHAR2(256),
  LAST_MOD_USER                  VARCHAR2(128),
  LAST_MOD_TIME                  DATE                DEFAULT SYSDATE
)
TABLESPACE &DATA_TABLESPACE
;

CREATE UNIQUE INDEX EMP_PWDMGMT_IDX ON EMPLOYMENT_PWDMANAGEMENT
(EMPLOYMENT, PWDMANAGEMENT)
 NOLOGGING
 NOPARALLEL
 TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

CREATE UNIQUE INDEX PWDMGMT_EMP_IDX ON EMPLOYMENT_PWDMANAGEMENT
(PWDMANAGEMENT, EMPLOYMENT)
 NOLOGGING
 NOPARALLEL
 TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

ALTER TABLE EMPLOYMENT_PWDMANAGEMENT
  ADD CONSTRAINT EMPLOYMENT_PWDMANAGEMENT_PK
  PRIMARY KEY (ID)
  USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

GRANT ALL ON EMPLOYMENT_PWDMANAGEMENT TO IDEAS;
GRANT ALL ON EMPLOYMENT_PWDMANAGEMENT TO IDEAS_CONNECTOR;
GRANT ALL ON EMPLOYMENT_PWDMANAGEMENT TO IDEAS_REPORT;
GRANT ALL ON EMPLOYMENT_PWDMANAGEMENT TO AA;

  
CREATE SEQUENCE EMPLOYMENT_PWDMANAGEMENT_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER;


GRANT ALL ON EMPLOYMENT_PWDMANAGEMENT_SEQ TO IDEAS;
GRANT ALL ON EMPLOYMENT_PWDMANAGEMENT_SEQ TO IDEAS_CONNECTOR;
GRANT ALL ON EMPLOYMENT_PWDMANAGEMENT_SEQ TO IDEAS_REPORT;
GRANT ALL ON EMPLOYMENT_PWDMANAGEMENT_SEQ TO AA;

    
ALTER TABLE EMPLOYMENT_PWDMANAGEMENT ADD
  CONSTRAINT EMPLOY_PWDMGMT_EMP_FK
 FOREIGN KEY (EMPLOYMENT)
 REFERENCES EMPLOYMENT (ID)
    ON DELETE CASCADE;
	
ALTER TABLE EMPLOYMENT_PWDMANAGEMENT ADD
  CONSTRAINT EMPLOY_PWDMGMT_PWDMGMT_FK
 FOREIGN KEY (PWDMANAGEMENT)
 REFERENCES PWDMANAGEMENT (ID)
    ON DELETE CASCADE;

