declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := 
  'CREATE TABLE EMPLOYMENT_PWDMANAGEMENT
  (
    ID                             NUMERIC(16)         NOT NULL,
    EMPLOYMENT					   NUMERIC(16)         NOT NULL,
    PWDMANAGEMENT			       NUMERIC(16)         NOT NULL,
    STATE                          NUMERIC(16)         DEFAULT 0,
    ATTR1                          VARCHAR(256),
    ATTR2                          VARCHAR(256),
    ATTR3                          VARCHAR(256),
    ATTR4                          VARCHAR(256),
    ATTR5                          VARCHAR(256),
    LAST_MOD_USER                  VARCHAR(128),
    LAST_MOD_TIME                  DATE                DEFAULT CURRENT_DATE
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  LONG IN &LOB_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined
begin
  stat := '
  ALTER TABLE EMPLOYMENT_PWDMANAGEMENT
    ADD CONSTRAINT EMPLOYMENT_PWDMANAGEMENT_PK
    PRIMARY KEY (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE UNIQUE INDEX EMP_PWDMGMT_IDX ON EMPLOYMENT_PWDMANAGEMENT
  (EMPLOYMENT, PWDMANAGEMENT)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE UNIQUE INDEX PWDMGMT_EMP_IDX ON EMPLOYMENT_PWDMANAGEMENT
  (PWDMANAGEMENT, EMPLOYMENT)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE EMPLOYMENT_PWDMANAGEMENT' );

GRANT ALL ON EMPLOYMENT_PWDMANAGEMENT TO IGA;
GRANT ALL ON EMPLOYMENT_PWDMANAGEMENT TO IGACONN;
GRANT ALL ON EMPLOYMENT_PWDMANAGEMENT TO REP;
GRANT ALL ON EMPLOYMENT_PWDMANAGEMENT TO AA;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE SEQUENCE EMPLOYMENT_PWDMANAGEMENT_SEQ
    AS NUMERIC(18)
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999
    NO CACHE
    NO CYCLE
    NO ORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/


GRANT USAGE ON SEQUENCE EMPLOYMENT_PWDMANAGEMENT_SEQ TO IGA;
GRANT USAGE ON SEQUENCE EMPLOYMENT_PWDMANAGEMENT_SEQ TO IGACONN;
GRANT USAGE ON SEQUENCE EMPLOYMENT_PWDMANAGEMENT_SEQ TO REP;
GRANT USAGE ON SEQUENCE EMPLOYMENT_PWDMANAGEMENT_SEQ TO AA;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  ALTER TABLE EMPLOYMENT_PWDMANAGEMENT ADD
    CONSTRAINT EMPLOY_PWDMGMT_EMP_FK
   FOREIGN KEY (EMPLOYMENT)
   REFERENCES EMPLOYMENT (ID)
      ON DELETE CASCADE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  ALTER TABLE EMPLOYMENT_PWDMANAGEMENT ADD
    CONSTRAINT EMPLOY_PWDMGMT_PWDMGMT_FK
   FOREIGN KEY (PWDMANAGEMENT)
   REFERENCES PWDMANAGEMENT (ID)
      ON DELETE CASCADE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/
