CREATE TABLE PERSON_PWDSYNC
(
  ID                             NUMBER(16)           NOT NULL,
  PERSON                         NUMBER(16),
  PASSWORD                       VARCHAR2(128),
  LASTCHANGEPWD                  TIMESTAMP(6),
  ALGORITHMPWD                   VARCHAR2(16),
  STATE                          NUMBER(16),
  ATTR1                          VARCHAR2(256),
  ATTR2                          VARCHAR2(256),
  ATTR3                          VARCHAR2(256),
  ATTR4                          VARCHAR2(256),
  ATTR5                          VARCHAR2(256),
  LAST_MOD_USER                  VARCHAR2(128),
  LAST_MOD_TIME                  TIMESTAMP(6)         DEFAULT systimestamp
)
TABLESPACE &DATA_TABLESPACE
;

ALTER TABLE PERSON_PWDSYNC
  ADD CONSTRAINT PERSON_PWDSYNC_PK PRIMARY KEY (ID)
  USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

GRANT ALL ON PERSON_PWDSYNC TO IDEAS;
GRANT ALL ON PERSON_PWDSYNC TO IDEAS_CONNECTOR;
GRANT ALL ON PERSON_PWDSYNC TO IDEAS_REPORT;
GRANT ALL ON PERSON_PWDSYNC TO AA;

CREATE SEQUENCE PERSON_PWDSYNC_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER;

GRANT ALL ON PERSON_PWDSYNC_SEQ TO IDEAS;
GRANT ALL ON PERSON_PWDSYNC_SEQ TO IDEAS_CONNECTOR;
GRANT ALL ON PERSON_PWDSYNC_SEQ TO IDEAS_REPORT;
GRANT ALL ON PERSON_PWDSYNC_SEQ TO AA;

ALTER TABLE PERSON_PWDSYNC
 ADD CONSTRAINT PERSON_PWDSYNC_PERSON_FK
 FOREIGN KEY (PERSON)
 REFERENCES PERSON (ID)
 ON DELETE CASCADE;
