declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE PERSON_PWDSYNC
  (
    ID                             NUMERIC(16)           NOT NULL,
    PERSON                         NUMERIC(16),
    PASSWORD                       VARCHAR(128),
    LASTCHANGEPWD                  TIMESTAMP(6),
    ALGORITHMPWD                   VARCHAR(16),
    STATE                          NUMERIC(16),
    ATTR1                          VARCHAR(256),
    ATTR2                          VARCHAR(256),
    ATTR3                          VARCHAR(256),
    ATTR4                          VARCHAR(256),
    ATTR5                          VARCHAR(256),
    LAST_MOD_USER                  VARCHAR(128),
    LAST_MOD_TIME                  TIMESTAMP(6)         DEFAULT CURRENT_TIMESTAMP
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  LONG IN &LOB_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
  ALTER TABLE PERSON_PWDSYNC
    ADD CONSTRAINT PERSON_PWDSYNC_PK
    PRIMARY KEY (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE PERSON_PWDSYNC' );

GRANT ALL ON PERSON_PWDSYNC TO IGA;
GRANT ALL ON PERSON_PWDSYNC TO IGACONN;
GRANT ALL ON PERSON_PWDSYNC TO REP;
GRANT ALL ON PERSON_PWDSYNC TO AA;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE SEQUENCE PERSON_PWDSYNC_SEQ
    AS NUMERIC(18)
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999
    NO CACHE
    NO CYCLE
    NO ORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT USAGE ON SEQUENCE PERSON_PWDSYNC_SEQ TO IGA;
GRANT USAGE ON SEQUENCE PERSON_PWDSYNC_SEQ TO IGACONN;
GRANT USAGE ON SEQUENCE PERSON_PWDSYNC_SEQ TO REP;
GRANT USAGE ON SEQUENCE PERSON_PWDSYNC_SEQ TO AA;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  ALTER TABLE PERSON_PWDSYNC
   ADD CONSTRAINT PERSON_PWDSYNC_PERSON_FK
   FOREIGN KEY (PERSON)
   REFERENCES PERSON (ID)
   ON DELETE CASCADE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/
