declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE TABLE PERSON_PWDSYNC
  (
    ID                             NUMBER(16)           NOT NULL,
    PERSON                         NUMBER(16),
    PASSWORD                       VARCHAR2(128),
    LASTCHANGEPWD                  TIMESTAMP(6),
    ALGORITHMPWD                   VARCHAR2(16),
    STATE                          NUMBER(16),
    ATTR1                          VARCHAR2(256),
    ATTR2                          VARCHAR2(256),
    ATTR3                          VARCHAR2(256),
    ATTR4                          VARCHAR2(256),
    ATTR5                          VARCHAR2(256),
    LAST_MOD_USER                  VARCHAR2(128),
    LAST_MOD_TIME                  TIMESTAMP(6)         DEFAULT systimestamp
  )
  TABLESPACE &DATA_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE PERSON_PWDSYNC
    ADD CONSTRAINT PERSON_PWDSYNC_PK PRIMARY KEY (ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON PERSON_PWDSYNC TO IDEAS;
GRANT ALL ON PERSON_PWDSYNC TO IDEAS_CONNECTOR;
GRANT ALL ON PERSON_PWDSYNC TO IDEAS_REPORT;
GRANT ALL ON PERSON_PWDSYNC TO AA;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE PERSON_PWDSYNC_SEQ
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999999999999
    NOCACHE
    NOCYCLE
    NOORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON PERSON_PWDSYNC_SEQ TO IDEAS;
GRANT ALL ON PERSON_PWDSYNC_SEQ TO IDEAS_CONNECTOR;
GRANT ALL ON PERSON_PWDSYNC_SEQ TO IDEAS_REPORT;
GRANT ALL ON PERSON_PWDSYNC_SEQ TO AA;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02275); -- such a referential constraint already exists in the table

begin
  stat := '
  ALTER TABLE PERSON_PWDSYNC
   ADD CONSTRAINT PERSON_PWDSYNC_PERSON_FK
   FOREIGN KEY (PERSON)
   REFERENCES PERSON (ID)
   ON DELETE CASCADE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/
