declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE USER_PREFERENCES
  (
    USERID                         VARCHAR(128)        NOT NULL,
    PID                            VARCHAR(128)        NOT NULL,
    PREFERENCES                    CLOB(1M)
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  LONG IN &LOB_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
  ALTER TABLE USER_PREFERENCES
    ADD CONSTRAINT USER_PREFERENCES_PK
    PRIMARY KEY (USERID, PID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE USER_PREFERENCES' );

GRANT ALL ON USER_PREFERENCES TO IGA;
GRANT ALL ON USER_PREFERENCES TO IGACONN;
GRANT ALL ON USER_PREFERENCES TO REP;
GRANT ALL ON USER_PREFERENCES TO AA;
