declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE TABLE USER_PREFERENCES
  (
    USERID                         VARCHAR2(128)        NOT NULL,
    PID                            VARCHAR2(128)        NOT NULL,
    PREFERENCES                    CLOB
  )
  TABLESPACE &DATA_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE USER_PREFERENCES
    ADD CONSTRAINT USER_PREFERENCES_PK PRIMARY KEY (USERID, PID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON USER_PREFERENCES TO IDEAS;
GRANT ALL ON USER_PREFERENCES TO IDEAS_CONNECTOR;
GRANT ALL ON USER_PREFERENCES TO IDEAS_REPORT;
GRANT ALL ON USER_PREFERENCES TO AA;
