CREATE TABLE PWDPOLICY
(
  ID                             NUMERIC(16)          NOT NULL,
  NAME                           VARCHAR(256)         NOT NULL,
  DESCRIPTION                    VARCHAR(512),
  IS_PWD_SYNC                    NUMERIC(1,0),
  IS_ACCOUNTCFG_POLICY           NUMERIC(1,0),
  ATTR1                          VARCHAR(256),
  ATTR2                          VARCHAR(256),
  ATTR3                          VARCHAR(256),
  ATTR4                          VARCHAR(256),
  ATTR5                          VARCHAR(256),
  CREATION_USER                  VARCHAR(128),
  CREATION_DATE                  DATE                 DEFAULT CURRENT_DATE,
  LAST_MOD_USER                  VARCHAR(128),
  LAST_MOD_TIME                  DATE                 DEFAULT CURRENT_DATE
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE PWDPOLICY
  ADD CONSTRAINT PWDPOLICY_PK
  PRIMARY KEY (ID);

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE PWDPOLICY' );

GRANT ALL ON PWDPOLICY TO IGA;
GRANT ALL ON PWDPOLICY TO IGACONN;
GRANT ALL ON PWDPOLICY TO REP;
GRANT ALL ON PWDPOLICY TO AA;

CREATE SEQUENCE PWDPOLICY_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

GRANT USAGE ON SEQUENCE PWDPOLICY_SEQ TO IGA;
GRANT USAGE ON SEQUENCE PWDPOLICY_SEQ TO IGACONN;
GRANT USAGE ON SEQUENCE PWDPOLICY_SEQ TO REP;
GRANT USAGE ON SEQUENCE PWDPOLICY_SEQ TO AA;

ALTER TABLE PWDCFG
  ADD PWDPOLICY NUMERIC(16);

ALTER TABLE PWDCFG
  ADD CONSTRAINT PWDCFG_PWDPOLICY_FK
  FOREIGN KEY (PWDPOLICY)
  REFERENCES PWDPOLICY (ID)
  ON DELETE SET NULL;

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE PWDCFG' );
