CREATE TABLE PWDPOLICY
(
  ID                             NUMBER(16)           NOT NULL,
  NAME                           VARCHAR2(256)        NOT NULL,
  DESCRIPTION                    VARCHAR2(512),
  IS_PWD_SYNC                    NUMBER(1,0),
  IS_ACCOUNTCFG_POLICY           NUMBER(1,0),
  ATTR1                          VARCHAR2(256),
  ATTR2                          VARCHAR2(256),
  ATTR3                          VARCHAR2(256),
  ATTR4                          VARCHAR2(256),
  ATTR5                          VARCHAR2(256),
  CREATION_USER                  VARCHAR2(128),
  CREATION_DATE                  DATE                 DEFAULT SYSDATE,
  LAST_MOD_USER                  VARCHAR2(128),
  LAST_MOD_TIME                  DATE                 DEFAULT SYSDATE
)
TABLESPACE &DATA_TABLESPACE
;

ALTER TABLE PWDPOLICY
  ADD CONSTRAINT PWDPOLICY_PK PRIMARY KEY (ID)
  USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

GRANT ALL ON PWDPOLICY TO IDEAS;
GRANT ALL ON PWDPOLICY TO IDEAS_CONNECTOR;
GRANT ALL ON PWDPOLICY TO IDEAS_REPORT;
GRANT ALL ON PWDPOLICY TO AA;

CREATE SEQUENCE PWDPOLICY_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER;

GRANT ALL ON PWDPOLICY_SEQ TO IDEAS;
GRANT ALL ON PWDPOLICY_SEQ TO IDEAS_CONNECTOR;
GRANT ALL ON PWDPOLICY_SEQ TO IDEAS_REPORT;
GRANT ALL ON PWDPOLICY_SEQ TO AA;

ALTER TABLE PWDCFG
  ADD PWDPOLICY NUMBER(16);

ALTER TABLE PWDCFG
 ADD CONSTRAINT PWDCFG_PWDPOLICY_FK
 FOREIGN KEY (PWDPOLICY)
 REFERENCES PWDPOLICY (ID)
 ON DELETE SET NULL;
 