CREATE TABLE PWDPOLICY_PROPS
(
  ID                             NUMERIC(16)          NOT NULL,
  NAME                           VARCHAR(128),
  DESCRIPTION                    VARCHAR(512),
  VALUE                          VARCHAR(128),
  STATE                          NUMERIC(16),
  PWDPOLICY                      NUMERIC(16)          NOT NULL,
  LAST_MOD_USER                  VARCHAR(128),
  LAST_MOD_TIME                  DATE                 DEFAULT CURRENT_DATE
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE PWDPOLICY_PROPS
  ADD CONSTRAINT PWDPOLICY_PROPS_PK
  PRIMARY KEY (ID);

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE PWDPOLICY_PROPS' );

GRANT ALL ON PWDPOLICY_PROPS TO IGA;
GRANT ALL ON PWDPOLICY_PROPS TO IGACONN;
GRANT ALL ON PWDPOLICY_PROPS TO REP;
GRANT ALL ON PWDPOLICY_PROPS TO AA;

CREATE SEQUENCE PWDPOLICY_PROPS_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

GRANT USAGE ON SEQUENCE PWDPOLICY_PROPS_SEQ TO IGA;
GRANT USAGE ON SEQUENCE PWDPOLICY_PROPS_SEQ TO IGACONN;
GRANT USAGE ON SEQUENCE PWDPOLICY_PROPS_SEQ TO REP;
GRANT USAGE ON SEQUENCE PWDPOLICY_PROPS_SEQ TO AA;

ALTER TABLE PWDPOLICY_PROPS
  ADD CONSTRAINT PWDPOLICY_PROPS_PWDPOLICY_FK
  FOREIGN KEY (PWDPOLICY)
  REFERENCES PWDPOLICY (ID)
  ON DELETE CASCADE;