declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE TABLE PWDPOLICY_PROPS
  (
    ID                             NUMBER(16)           NOT NULL,
    NAME                           VARCHAR2(128),
    DESCRIPTION                    VARCHAR2(512),
    VALUE                          VARCHAR2(128),
    STATE                          NUMBER(16),
    PWDPOLICY                      NUMBER(16)           NOT NULL,
    LAST_MOD_USER                  VARCHAR2(128),
    LAST_MOD_TIME                  DATE                 DEFAULT SYSDATE
  )
  TABLESPACE &DATA_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE PWDPOLICY_PROPS
    ADD CONSTRAINT PWDPOLICY_PROPS_PK PRIMARY KEY (ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON PWDPOLICY_PROPS TO IDEAS;
GRANT ALL ON PWDPOLICY_PROPS TO IDEAS_CONNECTOR;
GRANT ALL ON PWDPOLICY_PROPS TO IDEAS_REPORT;
GRANT ALL ON PWDPOLICY_PROPS TO AA;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE PWDPOLICY_PROPS_SEQ
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999999999999
    NOCACHE
    NOCYCLE
    NOORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON PWDPOLICY_PROPS_SEQ TO IDEAS;
GRANT ALL ON PWDPOLICY_PROPS_SEQ TO IDEAS_CONNECTOR;
GRANT ALL ON PWDPOLICY_PROPS_SEQ TO IDEAS_REPORT;
GRANT ALL ON PWDPOLICY_PROPS_SEQ TO AA;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02275); -- such a referential constraint already exists in the table

begin
  stat := '
  ALTER TABLE PWDPOLICY_PROPS
    ADD CONSTRAINT PWDPOLICY_PROPS_PWDPOLICY_FK
    FOREIGN KEY (PWDPOLICY)
    REFERENCES PWDPOLICY (ID)
    ON DELETE CASCADE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/
