CREATE TABLE PWDPOLICY_WORDS
(
  ID                             NUMBER(16)           NOT NULL,
  NAME                           VARCHAR2(128),
  DESCRIPTION                    VARCHAR2(512),
  VALUE                          VARCHAR2(128),
  EXACTMATCH                     NUMBER(1,0),
  STATE                          NUMBER(16),
  PWDPOLICY                      NUMBER(16)           NOT NULL,
  LAST_MOD_USER                  VARCHAR2(128),
  LAST_MOD_TIME                  DATE                 DEFAULT SYSDATE
)
TABLESPACE &DATA_TABLESPACE
;

ALTER TABLE PWDPOLICY_WORDS
  ADD CONSTRAINT PWDPOLICY_WORDS_PK PRIMARY KEY (ID)
  USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

GRANT ALL ON PWDPOLICY_WORDS TO IDEAS;
GRANT ALL ON PWDPOLICY_WORDS TO IDEAS_CONNECTOR;
GRANT ALL ON PWDPOLICY_WORDS TO IDEAS_REPORT;
GRANT ALL ON PWDPOLICY_WORDS TO AA;

CREATE SEQUENCE PWDPOLICY_WORDS_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER;

GRANT ALL ON PWDPOLICY_WORDS_SEQ TO IDEAS;
GRANT ALL ON PWDPOLICY_WORDS_SEQ TO IDEAS_CONNECTOR;
GRANT ALL ON PWDPOLICY_WORDS_SEQ TO IDEAS_REPORT;
GRANT ALL ON PWDPOLICY_WORDS_SEQ TO AA;

ALTER TABLE PWDPOLICY_WORDS
 ADD CONSTRAINT PWDPOLICY_WORDS_PWDPOLICY_FK
 FOREIGN KEY (PWDPOLICY)
 REFERENCES PWDPOLICY (ID)
 ON DELETE CASCADE;
