CREATE TABLE PWDPOLICY_WORDS
(
  ID                             NUMERIC(16)          NOT NULL,
  NAME                           VARCHAR(128),
  DESCRIPTION                    VARCHAR(512),
  VALUE                          VARCHAR(128),
  EXACTMATCH                     NUMERIC(1,0),
  STATE                          NUMERIC(16),
  PWDPOLICY                      NUMERIC(16)          NOT NULL,
  LAST_MOD_USER                  VARCHAR(128),
  LAST_MOD_TIME                  DATE                 DEFAULT CURRENT_DATE
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE PWDPOLICY_WORDS
  ADD CONSTRAINT PWDPOLICY_WORDS_PK
  PRIMARY KEY (ID);

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE PWDPOLICY_WORDS' );

GRANT ALL ON PWDPOLICY_WORDS TO IGA;
GRANT ALL ON PWDPOLICY_WORDS TO IGACONN;
GRANT ALL ON PWDPOLICY_WORDS TO REP;
GRANT ALL ON PWDPOLICY_WORDS TO AA;

CREATE SEQUENCE PWDPOLICY_WORDS_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

GRANT USAGE ON SEQUENCE PWDPOLICY_WORDS_SEQ TO IGA;
GRANT USAGE ON SEQUENCE PWDPOLICY_WORDS_SEQ TO IGACONN;
GRANT USAGE ON SEQUENCE PWDPOLICY_WORDS_SEQ TO REP;
GRANT USAGE ON SEQUENCE PWDPOLICY_WORDS_SEQ TO AA;

ALTER TABLE PWDPOLICY_WORDS
  ADD CONSTRAINT PWDPOLICY_WORDS_PWDPOLICY_FK
  FOREIGN KEY (PWDPOLICY)
  REFERENCES PWDPOLICY (ID)
  ON DELETE CASCADE;