set define off
declare
  im_id         number(16);
  im_name       varchar2(256) := 'AGC';

  fc_id         number(16);
  fc_name       varchar2(256) := 'system';
  
  fevt_id       number(16);
  fevt_name     varchar2(256) := 'TARGET';
  
  f_id          number(16);
  f_name        varchar2(256) := 'PERMISSION_ADD';

  f_lob         clob := 'package tADD_FUN;
'||'
'||'import com.engiweb.logger.impl.Log4JImpl;
'||'import com.engiweb.pm.entity.BeanList;
'||'import com.engiweb.profilemanager.backend.business.direct.ExternalRoleDirect;
'||'import com.engiweb.profilemanager.backend.dao.db.SQLH;
'||'import com.engiweb.profilemanager.common.bean.AccountBean;
'||'import com.engiweb.profilemanager.common.bean.Block;
'||'import com.engiweb.profilemanager.common.bean.OrgUnitBean;
'||'import com.engiweb.profilemanager.common.bean.UserBean;
'||'import com.engiweb.profilemanager.common.bean.entitlement.EntitlementBean;
'||'import com.engiweb.profilemanager.common.bean.FunctionalityTypeBean;
'||'import com.engiweb.profilemanager.common.bean.event.EntStateBean;
'||'import com.engiweb.profilemanager.common.bean.event.EventTargetBean;
'||'import com.engiweb.profilemanager.common.bean.rule.SyncStateBean;
'||'import com.engiweb.profilemanager.common.ruleengine.action.EntitlementAction;
'||'import com.engiweb.profilemanager.common.ruleengine.action.OrgUnitAction;
'||'import com.engiweb.profilemanager.common.ruleengine.action.UserAction;
'||'import com.engiweb.profilemanager.common.ruleengine.action.ApplicationAction;
'||'import com.engiweb.toolkit.common.DBMSException;
'||'import com.engiweb.profilemanager.backend.business.direct.UserDirect
'||'import java.util.Map
'||'import java.util.HashMap
'||'import java.util.List
'||'import java.util.ArrayList
'||'
'||'global com.engiweb.profilemanager.backend.dao.db.SQLH sql;
'||'global com.engiweb.logger.impl.Log4JImpl logger;
'||'
';
 
  fr_id         number(16);
  fr_name       varchar2(256) := 'Add Permission to User Account';
  fr_desc       varchar2(512) := '[ V1.6 - 2018-02-13 ]'; 
  
  fr_lob        clob := 'rule "Add Permission to User Account"
'||'when
'||'    userBean : UserBean(  )  
'||'    orgUnitBean : OrgUnitBean(  )  
'||'    event : EventTargetBean(  )  
'||'    syncBean : SyncStateBean(  )  
'||'    accountBean : AccountBean(  )
'||'then
'||'// [ V1.6 - 2018-02-13 ]
'||'
'||'  if (event.getLevel() == EventTargetBean.USER_NOT_FOUND) {
'||'    throw new Exception("Account " + accountBean.getCode() + " does not exist");
'||'  }
'||'
'||'  EntitlementBean entBean = syncBean.getProfile();
'||'
'||'  String pName = entBean.getName();
'||'  String uCode = userBean.getCode();
'||'
'||'  // User already has the profile
'||'  if (event.getLevel() == EventTargetBean.USER_PROFILE_FOUND) {
'||'
'||'    logger.debug("Permission " + pName + " already assigned to User " + uCode);
'||'
'||'    return;
'||'  }
'||'
'||'  // User does not has the profile
'||'  if (event.getLevel() == EventTargetBean.USER_PROFILE_NOT_FOUND) {
'||'        UserDirect userDirect = new UserDirect();
'||'  	Map<Long, AccountBean> accountsMap = null;
'||'	if(accountBean != null && accountBean.getId() != 0L) {
'||'		accountsMap = new HashMap<Long, AccountBean>();
'||'		accountsMap.put(accountBean.getPwdcfg_id(), accountBean);
'||'	}
'||'    List<EntitlementBean> bl = new ArrayList<EntitlementBean>();
'||'    bl.add(entBean);	
'||'	userDirect.addEntitlementByGroup(bl, accountsMap, null,null, userBean, null, false, true, "1", sql);
'||'
'||'    logger.debug("Permission " + pName + " assigned to User " + uCode);
'||'
'||'    return;
'||'
'||'  }
'||'
'||'  throw new Exception("Unexpected sync level: " + event.getLevel());
'||'
'||'end
'||'
';

  counter       number(16);
begin
  select count(1) into counter from ideas_module t where lower ( t.code ) = lower ( im_name );
  if ( counter = 1 ) then
    select t.id into im_id from ideas_module t where lower ( t.code ) = lower ( im_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO IDEAS MODULE FOUND' );
  end if;

  select count(1) into counter from flow_context t where lower ( t.name ) = lower ( fc_name );
  if ( counter = 1 ) then
    select t.id into fc_id from flow_context t where lower ( t.name ) = lower ( fc_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW CONTEXT FOUND' );
  end if;

  select count(1) into counter from flow_event_type t
  where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevt_name );
  if ( counter = 1 ) then
    select t.id into fevt_id from flow_event_type t
    where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevt_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW EVENT TYPE FOUND' );
  end if;
  
  select count(1) into counter from flow t
  where t.ideas_module = im_id and t.flow_event_type = fevt_id and lower ( t.name ) = lower ( f_name ); 
  if ( counter = 1 ) then
    select t.id into f_id from flow t
    where t.ideas_module = im_id and t.flow_event_type = fevt_id and lower ( t.name ) = lower ( f_name );
	
	update flow set flow_lob = f_lob where id = f_id;
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW FOUND' );
  end if;

  select count(1) into counter from flow_rule t where t.flow = f_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fr_name );
  if ( counter = 0 ) then
    select flow_rule_seq.nextval into fr_id from dual;
    insert into flow_rule ( id, flow, name, description, rule_lob, ideas_module )
    values ( fr_id, f_id, fr_name, fr_desc, fr_lob, im_id );
  else
    select t.id into fr_id from flow_rule t where t.flow = f_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fr_name );

    update flow_rule set description = fr_desc where id = fr_id;

    update flow_rule set rule_lob = fr_lob where id = fr_id;
  end if;

end;
/
commit;
set define on
