CREATE OR REPLACE TRIGGER TRG_USER_EVENT_ERC_SERVICE
  AFTER UPDATE OR DELETE ON USER_EVENT_ERC
  FOR EACH ROW
declare

begin
  if ( updating and ( :new.status is null OR ( :new.status = :old.status ) OR :new.event_out is null ) ) then
    return;
  end if;

  if ( deleting and ( :old.status is null OR :old.event_out is null ) ) then
    return;
  end if;

  if ( updating ) then
    update event_out set erc_status = :new.status, trace = :new.trace where id = :new.event_out;
  elsif ( deleting ) then
    update event_out set erc_status = :old.status, trace = :old.trace where id = :old.event_out;
  end if;

end TRG_USER_EVENT_ERC_SERVICE;
/
