declare
  pwdmgmt_id      numeric(16);
  emp_id          numeric(16);
  emp_entitlement numeric(16);
  emp_person      numeric(16);
  perm_id         numeric(16);
  counter         numeric(16);

  cur_services    sys_refcursor;
  cur_pwdmgmt     sys_refcursor;
  cur_emp         sys_refcursor;
  var_ret        numeric(1);

begin
  var_ret := db2_trg_disable ( 'trg_ins_empl_pwdman' );

  open cur_emp for
    select emp.id, emp.entitlement, emp.person
      from employment emp;
  loop
    fetch cur_emp into emp_id, emp_entitlement, emp_person;
    exit when cur_emp%NOTFOUND;
    open cur_pwdmgmt for
      select distinct pwdmgmt.id
        from pwdmanagement pwdmgmt,
             application   app,
             target        tar
       where pwdmgmt.person = emp_person
         and pwdmgmt.pwdcfg = tar.pwdcfg
		 and pwdmgmt.is_default = 1
         and app.target = tar.id
         and app.id in (select distinct child_application
                          from entitlement_flat_hier
                         where parent = emp_entitlement
                           and child_application is not null);
    loop
      fetch cur_pwdmgmt into pwdmgmt_id;
      exit when cur_pwdmgmt%NOTFOUND;
      select count(1)
        into counter
        from employment_pwdmanagement ep
       where ep.employment = emp_id
         and ep.pwdmanagement = pwdmgmt_id;
      if (counter = 0) then
        insert into employment_pwdmanagement
          (id, employment, pwdmanagement)
        values
          (employment_pwdmanagement_seq.nextval,
           emp_id,
           pwdmgmt_id);
      end if;
    end loop;
    close cur_pwdmgmt;
    
    open cur_services for
      select distinct efh.child, pwdmgmt.id
        from pwdmanagement         pwdmgmt,
             application           app,
             target                tar,
             entitlement_flat_hier efh,
             person_service        ps
       where pwdmgmt.person = emp_person
         and pwdmgmt.pwdcfg = tar.pwdcfg
         and pwdmgmt.is_default = 1
         and app.target = tar.id
         and app.id = efh.child_application
         and efh.parent = emp_entitlement
         and efh.child_int_type = 1
         and ps.profile = efh.child
         and ps.person = emp_person;
    loop
      fetch cur_services
        into perm_id, pwdmgmt_id;
      exit when cur_services%NOTFOUND;
      update person_service ps
         set pwdmanagement = pwdmgmt_id
       where ps.profile = perm_id
         and ps.person = emp_person;
    end loop;
    close cur_services;
    
  end loop;
  close cur_emp;

  var_ret := db2_trg_enable ( 'trg_ins_empl_pwdman' );
end;
/
commit;
