declare
  cur  sys_refcursor;
  cur1 sys_refcursor;
  cur2 sys_refcursor;
  cur3 sys_refcursor;

  counter numeric(16);

  pwdcfg_id   numeric(16);
  pwdcfg_name varchar(256);

  person_id   numeric(16);
  pwdman_code varchar(256);

  profile_id     numeric(16);
  profile_extref varchar(256);
  profile_type   varchar(256);
  target         varchar(256);

  personProfile_id numeric(16);

  personProfileService_id numeric(16);
  serviceAttribute_id     numeric(16);
  rigthName               varchar(256);
  rigthValue              varchar(256);

begin

  select count(1) into counter from pwdcfg where sync > 0;
  --if (counter = 0) then
  --return;
  --end if;

  open cur for
    select id, name from pwdcfg where sync = 2;

  -- for each connected target
  loop
    fetch cur
      into pwdcfg_id, pwdcfg_name;
    exit when cur%notfound;

    -- cerco account e person
    select count(1)
      into counter
      from pwdmanagement
     where pwdcfg = pwdcfg_id;

    --if (counter = 0) then
    --return;
    --end if;

    open cur1 for
      select code, person from pwdmanagement where pwdcfg = pwdcfg_id;

    -- for each accounts of target
    loop
      fetch cur1
        into pwdman_code, person_id;
      exit when cur1%notfound;

      open cur2 for
        select distinct pro.id, pro.ext_ref, pt.name, t.value
        -- into profile_id, profile_name, profile_type, target
          from employment            emp,
               entitlement           ent,
               entitlement_flat_hier efh,
               entitlement           pro,
               profile_type          pt,
               application           a,
               target                t
         where emp.person = person_id
           and ent.id = emp.entitlement
           and efh.parent = ent.id
           and efh.child = pro.id
           and pro.profile_type = pt.id
           and efh.child_application = a.id
           and a.target = t.id
           and t.pwdcfg = pwdcfg_id;

      -- for each user permission
      loop
        fetch cur2
          into profile_id, profile_extref, profile_type, target;
        exit when cur2%notfound;

        select person_profile_seq.nextval into personProfile_id from dual;
        -- per ogni account e person cerco i permessi assegnati
        insert into person_profile
          (id,
           person,
           profile,
           status,
           verify_date,
           verified_by,
           account_code,
           permission_code,
           permission_type,
           target)
        values
          (personProfile_id,
           person_id,
           profile_id,
           2,
           sysdate,
           'migration',
           pwdman_code,
           profile_extref,
           profile_type,
           target);

        -- search service
        if (person_id > 0) then
          open cur3 for
            select distinct service_attribute, name, value
              from person_service
             where person = person_id
               and profile = profile_id;
          -- for each person service
          loop
            fetch cur3
              into serviceAttribute_id, rigthName, rigthValue;
            exit when cur3%notfound;

            select person_profile_service_seq.nextval
              into personProfileService_id
              from dual;

            insert into person_profile_service
              (id,
               person_profile,
               service_attribute,
               name,
               value,
               target,
               status,
               verify_date,
               verified_by)
            values
              (personProfileService_id,
               personProfile_id,
               serviceAttribute_id,
               rigthName,
               rigthValue,
               target,
               2,
               sysdate,
               'migration');
          end loop;
		  close cur3;
        end if;
        -- end services

        -- commit each processed user
        commit;
        
      end loop;
      close cur2;
    end loop;
    close cur1;
  end loop;
  close cur;
end;
/

