--set echo on
spool va_app_perm.log

@@../00-COMMON/Module/00-common_agc.sql

DEFINE ECHO = 'ON';

alter trigger trg_entitlement_protection disable;
alter trigger trg_entitlement_validator disable;
alter trigger trg_ent_hier_protection disable;
alter trigger trg_add_remove_ent_flat_hier disable;
alter trigger trg_entitlement_history disable;
alter trigger trg_ent_hier_history disable;
alter trigger trg_modify_employment disable;
alter trigger trg_employment_cod_operation disable;

declare
  app_id         number(16);
  app_name       varchar2(256) := 'VirtualAppliance';
  app_desc       varchar2(256) := 'VirtualAppliance Module';

  pt_name        varchar2(256) := 'Access';
  pt_desc        varchar2(256) := 'Virtual Appliance profile type';
  pt_id          number(16);

  --ent_name       varchar2(256) := 'adminGroup';
  --ent_desc       varchar2(256) := 'adminGroup';
  ent_name       varchar2(256) := 'applianceAdmin';
  ent_desc       varchar2(256) := 'applianceAdmin';
  ent_int_type   number(16)    := 1;
  ent_id         number(16);

  ideas_version  varchar2(256) := '&IDEAS_VERSION';
  tmp_num        number(16)    := 1;
  counter        number(16);

begin
  app_id := inst_create_app ( null, app_name, app_desc, 'Ideas' );

  pt_id := inst_create_profile_type ( null, pt_name, pt_desc, app_id );

  ent_id := inst_create_entitlement ( null, ent_name, ent_desc, ent_int_type, app_id, pt_id, 1, ideas_version);

  update entitlement set authorized = 1 where id = ent_id;

  select count(1) into counter from entitlement_flat_hier t where t.parent = ent_id and t.child = ent_id;
  if ( counter = 0 ) then
    insert into entitlement_flat_hier (id, parent, parent_int_type, parent_application, parent_profile_type, child, child_int_type,
                                       child_application, child_profile_type, lvl, parent_ext_type, child_ext_type, ext_fulfillment_limit)
    values (entitlement_flat_hier_seq.nextval, ent_id, ent_int_type, app_id, pt_id, ent_id, ent_int_type, app_id, pt_id, 0, 3, 3, 0);
  end if;

  tmp_num := inst_ent_assign_to_user ( app_name, ent_name, ent_int_type, 'admin', 'admin', ideas_version);

  commit;
end;
/

alter trigger trg_entitlement_protection enable;
alter trigger trg_entitlement_validator enable;
alter trigger trg_ent_hier_protection enable;
alter trigger trg_add_remove_ent_flat_hier enable;
alter trigger trg_entitlement_history enable;
alter trigger trg_ent_hier_history enable;
alter trigger trg_modify_employment enable;
alter trigger trg_employment_cod_operation enable;

spool off

exit;
