--set echo on
spool va_app_perm.log

@@../00-COMMON/Module/00-common_agc.sql

DEFINE ECHO = 'ON';

declare
  app_id         numeric(16);
  app_name       varchar(256) := 'VirtualAppliance';
  app_desc       varchar(256) := 'VirtualAppliance Module';

  pt_name        varchar(256) := 'Access';
  pt_desc        varchar(256) := 'Virtual Appliance profile type';
  pt_id          numeric(16);

  --ent_name       varchar(256) := 'adminGroup';
  --ent_desc       varchar(256) := 'adminGroup';
  ent_name       varchar(256) := 'applianceAdmin';
  ent_desc       varchar(256) := 'applianceAdmin';
  ent_int_type   numeric(16)  := 1;
  ent_id         numeric(16);

  ideas_version  varchar(256) := '&IDEAS_VERSION';
  tmp_num        numeric(16)  := 1;
  var_ret        numeric(1);
  counter        numeric(16);

begin
  var_ret := db2_trg_disable ( 'trg_entitlement_protection' );
  var_ret := db2_trg_disable ( 'trg_entitlement_validator' );
  var_ret := db2_trg_disable ( 'trg_ent_hier_protection' );
  var_ret := db2_trg_disable ( 'trg_add_remove_ent_flat_hier' );
  var_ret := db2_trg_disable ( 'trg_entitlement_history' );
  var_ret := db2_trg_disable ( 'trg_ent_hier_history' );
  var_ret := db2_trg_disable ( 'trg_modify_employment' );
  var_ret := db2_trg_disable ( 'trg_employment_cod_operation' );

  app_id := inst_create_app ( null, app_name, app_desc, 'Ideas' );

  pt_id := inst_create_profile_type ( null, pt_name, pt_desc, app_id );

  ent_id := inst_create_entitlement ( null, ent_name, ent_desc, ent_int_type, app_id, pt_id, 1, ideas_version);

  update entitlement set authorized = 1 where id = ent_id;

  select count(1) into counter from entitlement_flat_hier t where t.parent = ent_id and t.child = ent_id;
  if ( counter = 0 ) then
    insert into entitlement_flat_hier (id, parent, parent_int_type, parent_application, parent_profile_type, child, child_int_type,
                                       child_application, child_profile_type, lvl, parent_ext_type, child_ext_type, ext_fulfillment_limit)
    values (entitlement_flat_hier_seq.nextval, ent_id, ent_int_type, app_id, pt_id, ent_id, ent_int_type, app_id, pt_id, 0, 3, 3, 0);
  end if;

  tmp_num := inst_ent_assign_to_user ( app_name, ent_name, ent_int_type, 'admin', 'admin', ideas_version);

  var_ret := db2_trg_enable ( 'trg_entitlement_protection' );
  var_ret := db2_trg_enable ( 'trg_entitlement_validator' );
  var_ret := db2_trg_enable ( 'trg_ent_hier_protection' );
  var_ret := db2_trg_enable ( 'trg_add_remove_ent_flat_hier' );
  var_ret := db2_trg_enable ( 'trg_entitlement_history' );
  var_ret := db2_trg_enable ( 'trg_ent_hier_history' );
  var_ret := db2_trg_enable ( 'trg_modify_employment' );
  var_ret := db2_trg_enable ( 'trg_employment_cod_operation' );

  commit;
end;
/

spool off

exit;
