declare
  counter              number(16);

  -- report
  r_id                 number(16);
  r_name               varchar2(256) := 'Accounts expiring in next x days with application scope';
  r_desc               varchar2(512) := null;
  r_code               varchar2(256) := null;
  r_i18n_mess          varchar2(256) := null;
  r_dashboard          number(1) := 1; -- 0: report, 1: dashboard

  -- localization
  r_loc_id             number(16);
  r_loc_code           varchar2(256);

  -- query
  rq_id                number(16);
  rq_name              varchar2(256) := 'Accounts expiring in next x days AM DB';
  rq_desc              varchar2(512) := null;
  rqd                  clob;

  rqf_type_def         varchar2(256) := 'java.lang.String';
  rqf_width_def        number(16) := 300;

  rqf_name_old         varchar2(256);
  rqf_name             varchar2(256);
  rqf_type             varchar2(256);
  rqf_width            number(16);
  rqf_ord_by           number(1);
  rqf_ord_by_clau      varchar2(256);
  loc_code_old         varchar2(256);
  loc_code             varchar2(256);
  loc_rename           boolean;
  i18n_msg             varchar2(256);
  repf_pos_id          number(16);
  repf_pos_id_old      number(16);

  v_ret                number(16);

begin
  rqd := 'select distinct
'||'  --t.name as target_name,
'||'  --a.name as application_name,
'||'  p.code as user_code,
'||'  pwdm.code as account_code,
'||'  case
'||'     when pwdm.is_default = 0 then ''''
'||'     when pwdm.is_default = 1 then ''Default''
'||'  end as ACCOUNT_IS_DEFAULT,
'||'  pwdmType.name as ACCOUNT_TYPE,
'||'  --case
'||'  --  when pwdm.name is null then p.name
'||'  --end as user_name,
'||'  --case
'||'  --  when pwdm.surname is null then p.surname
'||'  --end as user_surname,
'||'  --case
'||'  --  when pwdm.email is null then p.email
'||'  --end as user_email,
'||'  pwdc.name as pwdconfig_name,
'||'  pwdm.expire as account_expiry_date
'||'from
'||'  #schema_tmp#.tmp_rep_application tmpa,
'||'  #pmschema#.application a,
'||'  #pmschema#.target t,
'||'  #pmschema#.pwdcfg pwdc,
'||'  #pmschema#.pwdmanagement pwdm
'||'  left join #pmschema#.pwdmanagement_type pwdmType
'||'    on pwdm.pwdmanagement_type = pwdmType.id,
'||'  #pmschema#.person p
'||'where tmpa.id = a.id
'||'  and a.target = t.id
'||'  and t.pwdcfg = pwdc.id
'||'  and pwdc.id = pwdm.pwdcfg
'||'  and pwdm.person = p.id
'||'  and pwdm.expire is not null
'||'  and pwdm.expire >= sysdate
'||'  and pwdm.expire <=
'||'       to_date(extract(year from sysdate + #day_number#) || ''/'' ||
'||'               extract(month from sysdate + #day_number#) || ''/'' ||
'||'               extract(day from sysdate + #day_number#) || '' 00:00:01'',  ''yyyy/mm/dd hh24:mi:ss'')
'||'order by pwdm.expire asc
';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name ) and t.product = 1;
  if ( counter = 0 ) then
    select max(id) + 1 into rq_id from r_query t;

    insert into r_query ( id, name, description, product )
    values ( rq_id, rq_name, rq_desc, 1 );

    insert into r_query_data ( r_query, query )
    values ( rq_id, rqd );
  else
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name ) and t.product = 1;

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
							  
  -- Report FIELD 1
  rqf_name_old    := null;
  rqf_name        := 'ACCOUNT_IS_DEFAULT';
  rqf_type        := rqf_type_def;
  rqf_width       := rqf_width_def;
  rqf_ord_by      := 0;
  rqf_ord_by_clau := null;
  loc_code_old    := null;
  loc_code        := 'account.is_default';
  loc_rename      := true;
  i18n_msg        := 'Is Default';
  repf_pos_id_old := null;
  repf_pos_id     := 3;

  v_ret := inst_rep_add_col ( rq_id, rqf_name_old, rqf_name, rqf_type, rqf_width, rqf_ord_by, rqf_ord_by_clau,
                              loc_code_old, loc_code, loc_rename, i18n_msg, repf_pos_id_old, repf_pos_id );
							  
   -- Report FIELD 2
  rqf_name_old    := null;
  rqf_name        := 'ACCOUNT_TYPE';
  rqf_type        := rqf_type_def;
  rqf_width       := rqf_width_def;
  rqf_ord_by      := 0;
  rqf_ord_by_clau := null;
  loc_code_old    := null;
  loc_code        := 'account.type';
  loc_rename      := true;
  i18n_msg        := 'Account Type';
  repf_pos_id_old := null;
  repf_pos_id     := 4;							
  
   v_ret := inst_rep_add_col ( rq_id, rqf_name_old, rqf_name, rqf_type, rqf_width, rqf_ord_by, rqf_ord_by_clau,
                               loc_code_old, loc_code, loc_rename, i18n_msg, repf_pos_id_old, repf_pos_id );

end;
/
commit;

