declare
  rq_id            number(16);
  rq_name          varchar2(256) := 'Account matching status DB';
  rqd              clob;
  counter          number(16);

begin


  rqd :='SELECT pwdcfg_name,
'||'  count(1) as account_count,
'||'  case
'||'    when state = 0 then ''Identity Matched''
'||'    when state = 1 then ''Orphan''
'||'    when state = 2 then ''Unmatched''
'||'  end as account_status
'||'FROM
'||'(
'||'    SELECT
'||'      DISTINCT pwdc.name as pwdcfg_name,
'||'      pwdm.id,
'||'      pwdm.state AS state
'||'    FROM
'||'    #schema_tmp#.tmp_rep_application tmpa,
'||'    #pmschema#.application a,
'||'    #pmschema#.target t,
'||'    #pmschema#.pwdcfg pwdc,
'||'    #pmschema#.pwdmanagement pwdm
'||'    where
'||'      tmpa.id = a.id
'||'      and a.target = t.id
'||'      and t.pwdcfg = pwdc.id
'||'      and pwdc.id = pwdm.pwdcfg
'||'     and lower ( pwdc.name ) like lower ( ''#pwdconfig_name#'' )
'||')   
'||'group by
'||'   pwdcfg_name, state
';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );
    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/
commit;
