declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE TABLE SURVEY_PAGES
  (
	ID                             NUMBER(16)           NOT NULL,
    SURVEY_ID                      NUMBER(16)           NOT NULL,
    URI                            VARCHAR2(1028),
    NAME                           VARCHAR2(128)        NOT NULL,
    ENABLED                        NUMBER(1)            DEFAULT 0 NOT NULL
  )
  TABLESPACE &DATA_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE SURVEY_PAGES
    ADD CONSTRAINT SURVEY_PAGES_PK PRIMARY KEY (ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE INDEX SURVEY_PAGES_NAME_IDX ON SURVEY_PAGES
  (NAME, SURVEY_ID)
  NOLOGGING
  NOPARALLEL
  TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON SURVEY_PAGES TO IDEAS;
GRANT ALL ON SURVEY_PAGES TO IDEAS_CONNECTOR;
GRANT ALL ON SURVEY_PAGES TO IDEAS_REPORT;
GRANT ALL ON SURVEY_PAGES TO AA;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE SURVEY_PAGES_SEQ
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999999999999
    NOCACHE
    NOCYCLE
    NOORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON SURVEY_PAGES_SEQ TO IDEAS;
GRANT ALL ON SURVEY_PAGES_SEQ TO IDEAS_CONNECTOR;
GRANT ALL ON SURVEY_PAGES_SEQ TO IDEAS_REPORT;
GRANT ALL ON SURVEY_PAGES_SEQ TO AA;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02275); -- such a referential constraint already exists in the table

begin
  stat := '
  ALTER TABLE SURVEY_PAGES
   ADD CONSTRAINT SURVEY_PAGES_SURVEY_CONFIG_FK
   FOREIGN KEY (SURVEY_ID)
   REFERENCES SURVEY_CONFIG (ID)
   ON DELETE CASCADE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  counter  number(16);
begin
  select count(1) into counter from survey_pages where id = 1;
  if ( counter = 0 ) then
    insert into survey_pages (ID, SURVEY_ID, NAME, ENABLED)
    values (1, 1, 'admin console', 1);
  end if;
  select count(1) into counter from survey_pages where id = 2;
  if ( counter = 0 ) then
    insert into survey_pages (ID, SURVEY_ID, NAME, ENABLED)
    values (2, 1, 'service center', 1);
  end if;
  commit;
end;
/
