declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE SURVEY_PAGES
  (
	ID                             NUMERIC(16)          NOT NULL,
    SURVEY_ID                      NUMERIC(16)          NOT NULL,
    URI                            VARCHAR(1028),
    NAME                           VARCHAR(128)         NOT NULL,
    ENABLED                        NUMERIC(1)           DEFAULT 0 NOT NULL
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  LONG IN &LOB_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
  ALTER TABLE SURVEY_PAGES
    ADD CONSTRAINT SURVEY_PAGES_PK
    PRIMARY KEY (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE INDEX SURVEY_PAGES_NAME_IDX ON SURVEY_PAGES
  (NAME, SURVEY_ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON SURVEY_PAGES TO IGA;
GRANT ALL ON SURVEY_PAGES TO IGACONN;
GRANT ALL ON SURVEY_PAGES TO REP;
GRANT ALL ON SURVEY_PAGES TO AA;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE SEQUENCE SURVEY_PAGES_SEQ
    AS NUMERIC(18)
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999
    NO CACHE
    NO CYCLE
    NO ORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT USAGE ON SEQUENCE SURVEY_PAGES_SEQ TO IGA;
GRANT USAGE ON SEQUENCE SURVEY_PAGES_SEQ TO IGACONN;
GRANT USAGE ON SEQUENCE SURVEY_PAGES_SEQ TO REP;
GRANT USAGE ON SEQUENCE SURVEY_PAGES_SEQ TO AA;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  ALTER TABLE SURVEY_PAGES
    ADD CONSTRAINT SURVEY_PAGES_SURVEY_CONFIG_FK
    FOREIGN KEY (SURVEY_ID)
    REFERENCES SURVEY_CONFIG (ID)
    ON DELETE CASCADE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE SURVEY_PAGES' );

declare
  counter  numeric(16);
begin
  select count(1) into counter from survey_pages where id = 1;
  if ( counter = 0 ) then
    insert into survey_pages (ID, SURVEY_ID, NAME, ENABLED)
    values (1, 1, 'admin console', 1);
  end if;
  select count(1) into counter from survey_pages where id = 2;
  if ( counter = 0 ) then
    insert into survey_pages (ID, SURVEY_ID, NAME, ENABLED)
    values (2, 1, 'service center', 1);
  end if;
  commit;
end;
/
