declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE TABLE SURVEY_CONFIG_EXT
  (
	ID                             NUMBER(16)           NOT NULL,
    SURVEY_ID                      NUMBER(16)           NOT NULL,
    PROP_NAME                      VARCHAR2(256)        NOT NULL,
    PROP_VALUE                     VARCHAR2(1028)
  )
  TABLESPACE &DATA_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE SURVEY_CONFIG_EXT
    ADD CONSTRAINT SURVEY_CONFIG_EXT_PK PRIMARY KEY (ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON SURVEY_CONFIG_EXT TO IDEAS;
GRANT ALL ON SURVEY_CONFIG_EXT TO IDEAS_CONNECTOR;
GRANT ALL ON SURVEY_CONFIG_EXT TO IDEAS_REPORT;
GRANT ALL ON SURVEY_CONFIG_EXT TO AA;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE SURVEY_CONFIG_EXT_SEQ
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999999999999
    NOCACHE
    NOCYCLE
    NOORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON SURVEY_CONFIG_EXT_SEQ TO IDEAS;
GRANT ALL ON SURVEY_CONFIG_EXT_SEQ TO IDEAS_CONNECTOR;
GRANT ALL ON SURVEY_CONFIG_EXT_SEQ TO IDEAS_REPORT;
GRANT ALL ON SURVEY_CONFIG_EXT_SEQ TO AA;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02275); -- such a referential constraint already exists in the table

begin
  stat := '
  ALTER TABLE SURVEY_CONFIG_EXT
   ADD CONSTRAINT SURVEYCFGEXT_SURVEY_CONFIG_FK
   FOREIGN KEY (SURVEY_ID)
   REFERENCES SURVEY_CONFIG (ID)
   ON DELETE CASCADE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  counter  number(16);
begin
  select count(1) into counter from survey_config_ext where id = 1;
  if ( counter = 0 ) then
    insert into survey_config_ext (ID, SURVEY_ID, PROP_NAME, PROP_VALUE)
    values (1, 1, 'isEnabled', 'true');
  end if;
  select count(1) into counter from survey_config_ext where id = 2;
  if ( counter = 0 ) then
    insert into survey_config_ext (ID, SURVEY_ID, PROP_NAME, PROP_VALUE)
    values (2, 1, 'productLink', 'https://www.ibm.com/us-en/marketplace/identity-governance-and-intelligence');
  end if;
  select count(1) into counter from survey_config_ext where id = 3;
  if ( counter = 0 ) then
    insert into survey_config_ext (ID, SURVEY_ID, PROP_NAME, PROP_VALUE)
    values (3, 1, 'productName', 'IBM Security Identity Governance and Intelligence');
  end if;
  commit;
end;
/
