declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE SURVEY_CONFIG_EXT
  (
	ID                             NUMERIC(16)          NOT NULL,
    SURVEY_ID                      NUMERIC(16)          NOT NULL,
    PROP_NAME                      VARCHAR(256)         NOT NULL,
    PROP_VALUE                     VARCHAR(1028)
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  LONG IN &LOB_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
  ALTER TABLE SURVEY_CONFIG_EXT
    ADD CONSTRAINT SURVEY_CONFIG_EXT_PK
    PRIMARY KEY (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON SURVEY_CONFIG_EXT TO IGA;
GRANT ALL ON SURVEY_CONFIG_EXT TO IGACONN;
GRANT ALL ON SURVEY_CONFIG_EXT TO REP;
GRANT ALL ON SURVEY_CONFIG_EXT TO AA;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE SEQUENCE SURVEY_CONFIG_EXT_SEQ
    AS NUMERIC(18)
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999
    NO CACHE
    NO CYCLE
    NO ORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT USAGE ON SEQUENCE SURVEY_CONFIG_EXT_SEQ TO IGA;
GRANT USAGE ON SEQUENCE SURVEY_CONFIG_EXT_SEQ TO IGACONN;
GRANT USAGE ON SEQUENCE SURVEY_CONFIG_EXT_SEQ TO REP;
GRANT USAGE ON SEQUENCE SURVEY_CONFIG_EXT_SEQ TO AA;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  ALTER TABLE SURVEY_CONFIG_EXT
    ADD CONSTRAINT SURVEYCFGEXT_SURVEY_CONFIG_FK
    FOREIGN KEY (SURVEY_ID)
    REFERENCES SURVEY_CONFIG (ID)
    ON DELETE CASCADE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE SURVEY_CONFIG_EXT' );

declare
  counter  numeric(16);
begin
  select count(1) into counter from survey_config_ext where id = 1;
  if ( counter = 0 ) then
    insert into survey_config_ext (ID, SURVEY_ID, PROP_NAME, PROP_VALUE)
    values (1, 1, 'isEnabled', 'true');
  end if;
  select count(1) into counter from survey_config_ext where id = 2;
  if ( counter = 0 ) then
    insert into survey_config_ext (ID, SURVEY_ID, PROP_NAME, PROP_VALUE)
    values (2, 1, 'productLink', 'https://www.ibm.com/us-en/marketplace/identity-governance-and-intelligence');
  end if;
  select count(1) into counter from survey_config_ext where id = 3;
  if ( counter = 0 ) then
    insert into survey_config_ext (ID, SURVEY_ID, PROP_NAME, PROP_VALUE)
    values (3, 1, 'productName', 'IBM Security Identity Governance and Intelligence');
  end if;
  commit;
end;
/
