declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE TABLE SURVEY_USER
  (
	ID                             NUMBER(16)           NOT NULL,
    SURVEY_ID                      NUMBER(16)           NOT NULL,
    LOGIN_NAME                     VARCHAR2(64)         NOT NULL,
    LAST_SURVEY_TIME               TIMESTAMP(6),
    FIRST_PRODUCT_USE              TIMESTAMP(6),
    IUID                           VARCHAR2(32),
    LAST_NAME                      VARCHAR2(64),
    SAPID                          VARCHAR2(32),
    FIRST_NAME                     VARCHAR2(64),
    EMAIL                          VARCHAR2(256)
  )
  TABLESPACE &DATA_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE SURVEY_USER
    ADD CONSTRAINT SURVEY_USER_PK PRIMARY KEY (ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE UNIQUE INDEX SURVEY_USER_LOGIN_IDX ON SURVEY_USER
  (LOGIN_NAME, SURVEY_ID)
  NOLOGGING
  NOPARALLEL
  TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON SURVEY_USER TO IDEAS;
GRANT ALL ON SURVEY_USER TO IDEAS_CONNECTOR;
GRANT ALL ON SURVEY_USER TO IDEAS_REPORT;
GRANT ALL ON SURVEY_USER TO AA;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE SURVEY_USER_SEQ
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999999999999
    NOCACHE
    NOCYCLE
    NOORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON SURVEY_USER_SEQ TO IDEAS;
GRANT ALL ON SURVEY_USER_SEQ TO IDEAS_CONNECTOR;
GRANT ALL ON SURVEY_USER_SEQ TO IDEAS_REPORT;
GRANT ALL ON SURVEY_USER_SEQ TO AA;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02275); -- such a referential constraint already exists in the table

begin
  stat := '
  ALTER TABLE SURVEY_USER
   ADD CONSTRAINT SURVEY_USER_SURVEY_CONFIG_FK
   FOREIGN KEY (SURVEY_ID)
   REFERENCES SURVEY_CONFIG (ID)
   ON DELETE CASCADE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/
