declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE SURVEY_USER
  (
	ID                             NUMERIC(16)          NOT NULL,
    SURVEY_ID                      NUMERIC(16)          NOT NULL,
    LOGIN_NAME                     VARCHAR(64)          NOT NULL,
    LAST_SURVEY_TIME               TIMESTAMP(6),
    FIRST_PRODUCT_USE              TIMESTAMP(6),
    IUID                           VARCHAR(32),
    LAST_NAME                      VARCHAR(64),
    SAPID                          VARCHAR(32),
    FIRST_NAME                     VARCHAR(64),
    EMAIL                          VARCHAR(256)
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  LONG IN &LOB_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
  ALTER TABLE SURVEY_USER
    ADD CONSTRAINT SURVEY_USER_PK
    PRIMARY KEY (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE SURVEY_USER' );

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE UNIQUE INDEX SURVEY_USER_LOGIN_IDX ON SURVEY_USER
  (LOGIN_NAME, SURVEY_ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON SURVEY_USER TO IGA;
GRANT ALL ON SURVEY_USER TO IGACONN;
GRANT ALL ON SURVEY_USER TO REP;
GRANT ALL ON SURVEY_USER TO AA;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE SEQUENCE SURVEY_USER_SEQ
    AS NUMERIC(18)
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999
    NO CACHE
    NO CYCLE
    NO ORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT USAGE ON SEQUENCE SURVEY_USER_SEQ TO IGA;
GRANT USAGE ON SEQUENCE SURVEY_USER_SEQ TO IGACONN;
GRANT USAGE ON SEQUENCE SURVEY_USER_SEQ TO REP;
GRANT USAGE ON SEQUENCE SURVEY_USER_SEQ TO AA;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  ALTER TABLE SURVEY_USER
    ADD CONSTRAINT SURVEY_USER_SURVEY_CONFIG_FK
    FOREIGN KEY (SURVEY_ID)
    REFERENCES SURVEY_CONFIG (ID)
    ON DELETE CASCADE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/
