CREATE TABLE EMPLOYMENT_REVIEW_RIGHT
(
  ID                             NUMBER(16)          NOT NULL,
  EMPLOYMENT_REVIEW              NUMBER(16)          NOT NULL,
  PERMISSION                     NUMBER(16)          NOT NULL,
  RIGHT_NAME                     VARCHAR2(256 BYTE)  NOT NULL,
  RIGHT_VALUE                    VARCHAR2(256 BYTE),
  STATE                          NUMBER(16)          DEFAULT 0,
  ATTR1                          VARCHAR2(256 CHAR),
  ATTR2                          VARCHAR2(256 CHAR),
  ATTR3                          VARCHAR2(256 CHAR),
  ATTR4                          VARCHAR2(256 CHAR),
  ATTR5                          VARCHAR2(256 CHAR),
  LAST_MOD_USER                  VARCHAR2(128 CHAR),
  LAST_MOD_TIME                  DATE                DEFAULT SYSDATE,
  REVIEW_STATE                   NUMBER(1)           DEFAULT 0,
  REVIEW_DATE                    DATE,
  REVIEWED_BY_INFO               VARCHAR2(256 CHAR),
  REVIEWED_BY                    NUMBER(16),
  NOTE                           VARCHAR2(2048 CHAR),
  SIGNED_OFF                     NUMBER(1)           DEFAULT 0,
  CREATION_DATE                  DATE,
  RIGHT_ISREQUIRED               NUMBER(1),
  PERSON_SERVICE                 NUMBER(16)
)
TABLESPACE &DATA_TABLESPACE
;

ALTER TABLE EMPLOYMENT_REVIEW_RIGHT ADD (
  CONSTRAINT EMPLOYMENT_REVIEW_R_PK
 PRIMARY KEY
 (ID)
  USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS);

ALTER TABLE EMPLOYMENT_REVIEW_RIGHT ADD (
  CONSTRAINT EMPREVR_EMPREV_FK
 FOREIGN KEY (EMPLOYMENT_REVIEW)
 REFERENCES EMPLOYMENT_REVIEW (ID)
    ON DELETE CASCADE);
ALTER TABLE EMPLOYMENT_REVIEW_RIGHT ADD (
  CONSTRAINT EMPREVR_PERMISSION_FK
 FOREIGN KEY (PERMISSION)
 REFERENCES ENTITLEMENT (ID)
    ON DELETE CASCADE);
ALTER TABLE EMPLOYMENT_REVIEW_RIGHT ADD (
  CONSTRAINT EMPREVR_PERSON_SERVICE_FK
 FOREIGN KEY (PERSON_SERVICE)
 REFERENCES PERSON_SERVICE (ID)
    ON DELETE SET NULL);
ALTER TABLE EMPLOYMENT_REVIEW_RIGHT ADD (
  CONSTRAINT EMPREVR_REVIEWED_BY_FK
 FOREIGN KEY (REVIEWED_BY)
 REFERENCES PERSON (ID)
    ON DELETE SET NULL);

grant select, insert, update, delete, references on EMPLOYMENT_REVIEW_RIGHT to IDEAS;
grant select, insert, update, delete, references on EMPLOYMENT_REVIEW_RIGHT to IDEAS_CONNECTOR;
grant select on EMPLOYMENT_REVIEW_RIGHT to IDEAS_REPORT;


CREATE SEQUENCE EMPLOYMENT_REVIEW_RIGHT_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER;

grant select on EMPLOYMENT_REVIEW_RIGHT_SEQ to AA;
grant select, alter on EMPLOYMENT_REVIEW_RIGHT_SEQ to IDEAS;
grant select on EMPLOYMENT_REVIEW_RIGHT_SEQ to IDEAS_CONNECTOR;
grant select on EMPLOYMENT_REVIEW_RIGHT_SEQ to IDEAS_REPORT;
