--CREATE A TABLE AND ITS CONSTRAINTS
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'HISTORY';

  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tables t where t.owner = curr_user and t.table_name = tab_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'CREATE TABLE HISTORY
(
  ID                             NUMBER(16)          NOT NULL,
  OPERATION                      NUMBER(3)           NOT NULL,
  STATUS                         NUMBER(16)          DEFAULT 0 NOT NULL,
  ENT_TYPE                       NUMBER(16)          NOT NULL,
  ENT_ID                         NUMBER(16)          NOT NULL,
  ENT_DESC                       VARCHAR2(512 CHAR),
  ENT_NAME                       VARCHAR2(256 CHAR),
  ENT_VAL1                       VARCHAR2(512 CHAR),
  ENT_VAL2                       VARCHAR2(512 CHAR),
  ENT_VAL3                       VARCHAR2(512 CHAR),
  ENT_VAL4                       VARCHAR2(512 CHAR),
  ENT_VAL5                       VARCHAR2(512 CHAR),
  OLD_VAL                        VARCHAR2(512 CHAR),
  OLD_VAL_EXT1                   VARCHAR2(512 CHAR),
  OLD_VAL_EXT2                   VARCHAR2(512 CHAR),
  OLD_VAL_EXT3                   VARCHAR2(512 CHAR),
  OLD_VAL_EXT4                   VARCHAR2(512 CHAR),
  OLD_VAL_EXT5                   VARCHAR2(512 CHAR),
  NEW_VAL                        VARCHAR2(512 CHAR),
  NEW_VAL_EXT1                   VARCHAR2(512 CHAR),
  NEW_VAL_EXT2                   VARCHAR2(512 CHAR),
  NEW_VAL_EXT3                   VARCHAR2(512 CHAR),
  NEW_VAL_EXT4                   VARCHAR2(512 CHAR),
  NEW_VAL_EXT5                   VARCHAR2(512 CHAR),
  FIELD                          VARCHAR2(512 CHAR),
  FIELD_LBL                      VARCHAR2(512 CHAR),
  NOTE                           VARCHAR2(4000 CHAR),
  ATTR1                          VARCHAR2(256 CHAR),
  ATTR2                          VARCHAR2(256 CHAR),
  ATTR3                          VARCHAR2(256 CHAR),
  ATTR4                          VARCHAR2(256 CHAR),
  ATTR5                          VARCHAR2(256 CHAR),
  LAST_MOD_USER                  VARCHAR2(128 CHAR),
  LAST_MOD_TIME                  DATE                DEFAULT SYSDATE,
  REVISION                       NUMBER(16)          DEFAULT 0 NOT NULL
)
TABLESPACE &DATA_TABLESPACE
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'ALTER TABLE HISTORY ADD (
  CONSTRAINT HISTORY_PK
 PRIMARY KEY
 (ID)
  USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--CREATE A SEQUENCE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  seq_name          varchar2(30) := 'HISTORY_SEQ';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_sequences t where t.sequence_owner = curr_user and t.sequence_name = seq_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'CREATE SEQUENCE HISTORY_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

CREATE OR REPLACE TRIGGER TRG_ENTITLEMENT_HISTORY
  AFTER INSERT OR UPDATE OR DELETE ON ENTITLEMENT
  FOR EACH ROW
declare
begin
  null;
end TRG_ENTITLEMENT_HISTORY;
/

CREATE OR REPLACE TRIGGER TRG_ENT_HIER_HISTORY
  BEFORE INSERT OR DELETE ON ENTITLEMENT_HIER
  FOR EACH ROW
declare
begin
  null;
end TRG_ENT_HIER_HISTORY;
/
