create or replace function complex_index
(
  c1 in number,
  c2 in number,
  c3 in number,
  c4 in number  default null,
  c5 in number  default null,
  c6 in number  default null,
  c7 in number  default null,
  c8 in number  default null,
  c9 in number  default null,
  c10 in number default null,
  c11 in number default null,
  c12 in number default null,
  c13 in number default null,
  c14 in number default null,
  c15 in number default null
)
return varchar2 deterministic is
  c1_v  varchar2(16);
  c2_v  varchar2(16);
  c3_v  varchar2(16);
  c4_v  varchar2(16);
  c5_v  varchar2(16);
  c6_v  varchar2(16);
  c7_v  varchar2(16);
  c8_v  varchar2(16);
  c9_v  varchar2(16);
  c10_v varchar2(16);
  c11_v varchar2(16);
  c12_v varchar2(16);
  c13_v varchar2(16);
  c14_v varchar2(16);
  c15_v varchar2(16);
begin
  if c1  is null then c1_v  := 'X'; else c1_v  := trim(to_char(c1, '999999999999999'));  end if;
  if c2  is null then c2_v  := 'X'; else c2_v  := trim(to_char(c2, '999999999999999'));  end if;
  if c3  is null then c3_v  := 'X'; else c3_v  := trim(to_char(c3, '999999999999999'));  end if;
  if c4  is null then c4_v  := 'X'; else c4_v  := trim(to_char(c4, '999999999999999'));  end if;
  if c5  is null then c5_v  := 'X'; else c5_v  := trim(to_char(c5, '999999999999999'));  end if;
  if c6  is null then c6_v  := 'X'; else c6_v  := trim(to_char(c6, '999999999999999'));  end if;
  if c7  is null then c7_v  := 'X'; else c7_v  := trim(to_char(c7, '999999999999999'));  end if;
  if c8  is null then c8_v  := 'X'; else c8_v  := trim(to_char(c8, '999999999999999'));  end if;
  if c9  is null then c9_v  := 'X'; else c9_v  := trim(to_char(c9, '999999999999999'));  end if;
  if c10 is null then c10_v := 'X'; else c10_v := trim(to_char(c10, '999999999999999')); end if;
  if c11 is null then c11_v := 'X'; else c11_v := trim(to_char(c11, '999999999999999')); end if;
  if c12 is null then c12_v := 'X'; else c12_v := trim(to_char(c12, '999999999999999')); end if;
  if c13 is null then c13_v := 'X'; else c13_v := trim(to_char(c13, '999999999999999')); end if;
  if c14 is null then c14_v := 'X'; else c14_v := trim(to_char(c14, '999999999999999')); end if;
  if c15 is null then c15_v := 'X'; else c15_v := trim(to_char(c15, '999999999999999')); end if;

  return
    c1_v  || '_' || c2_v  || '_' || c3_v  || '_' || c4_v  || '_' || c5_v  || '_' ||
    c6_v  || '_' || c7_v  || '_' || c8_v  || '_' || c9_v  || '_' || c10_v || '_' ||
    c11_v || '_' || c12_v || '_' || c13_v || '_' || c14_v || '_' || c15_v;
end complex_index;
/

declare
  type t_cur is ref cursor;
  cur t_cur;
  
  idx_attrib user_indexes%ROWTYPE;

begin
  open cur for select * from user_indexes ui where ui.status <> 'VALID' or ui.funcidx_status <> 'ENABLED';
  
  loop
    fetch cur into idx_attrib;
    exit when cur%NOTFOUND;
    
    execute immediate( 'alter index ' || idx_attrib.index_name || ' rebuild compute statistics');
    
  end loop;
  close cur;
end;
/
