create table WORKSTREAM
(
  ID             number(16) not null,
  GROUP_NAME     varchar2(256),
  OPERATION_CODE varchar2(256),
  WORK_KEY       varchar2(256),
  STATUS         number(2),
  DATA           varchar2(4000),
  ATTR1          varchar2(256),
  ATTR2          varchar2(256)
)
tablespace &DATA_TABLESPACE
;

alter table WORKSTREAM
  add constraint WORKSTREAM_PK primary key (ID)
  using index 
  tablespace &INDEX_TABLESPACE compute statistics;

grant select on WORKSTREAM to AA;
grant select, insert, update, delete, references on WORKSTREAM to IDEAS;
grant select, insert, update, delete, references on WORKSTREAM to IDEAS_CONNECTOR;
grant select on WORKSTREAM to IDEAS_REPORT;

create sequence WORKSTREAM_SEQ
minvalue 100
maxvalue 999999999999999999999999999
start with 100
increment by 1
nocache;

grant select on WORKSTREAM_SEQ to AA;
grant select, alter on WORKSTREAM_SEQ to IDEAS;
grant select on WORKSTREAM_SEQ to IDEAS_CONNECTOR;
grant select on WORKSTREAM_SEQ to IDEAS_REPORT;
