create table WORKSTREAM
(
  ID             numeric(16) not null,
  GROUP_NAME     varchar(256),
  OPERATION_CODE varchar(256),
  WORK_KEY       varchar(256),
  STATUS         numeric(2),
  DATA           varchar(4000),
  ATTR1          varchar(256),
  ATTR2          varchar(256)
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE WORKSTREAM ADD
  CONSTRAINT WORKSTREAM_PK 
 PRIMARY KEY (ID);

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE WORKSTREAM' );

grant select on WORKSTREAM to &AA_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on WORKSTREAM to &IDEAS_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on WORKSTREAM to &IDEAS_CONN_SUPER_ADMIN_USER;
grant select on WORKSTREAM to &IDEAS_REPORT_SUPER_ADMIN_USER;

create sequence WORKSTREAM_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

grant usage on sequence WORKSTREAM_SEQ to &AA_SUPER_ADMIN_USER;
grant usage, alter on sequence WORKSTREAM_SEQ to &IDEAS_SUPER_ADMIN_USER;
grant usage, alter on sequence WORKSTREAM_SEQ to &IDEAS_CONN_SUPER_ADMIN_USER;
grant usage on sequence WORKSTREAM_SEQ to &IDEAS_REPORT_SUPER_ADMIN_USER;
