--CREATE A TABLE AND ITS CONSTRAINTS
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'WORKSTREAM';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tables t where t.owner = curr_user and t.table_name = tab_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'create table WORKSTREAM
(
  ID             number(16) not null,
  GROUP_NAME     varchar2(256),
  OPERATION_CODE varchar2(256),
  WORK_KEY       varchar2(256),
  STATUS         number(2),
  DATA           varchar2(4000),
  ATTR1          varchar2(256),
  ATTR2          varchar2(256)
)
tablespace &DATA_TABLESPACE
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table WORKSTREAM
  add constraint WORKSTREAM_PK primary key (ID)
  using index 
  tablespace &INDEX_TABLESPACE compute statistics
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

grant select on WORKSTREAM to AA;
grant select, insert, update, delete, references on WORKSTREAM to IDEAS;
grant select, insert, update, delete, references on WORKSTREAM to IDEAS_CONNECTOR;
grant select on WORKSTREAM to IDEAS_REPORT;


--CREATE A SEQUENCE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  seq_name          varchar2(30) := 'WORKSTREAM_SEQ';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_sequences t where t.sequence_owner = curr_user and t.sequence_name = seq_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'create sequence WORKSTREAM_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

grant select on WORKSTREAM_SEQ to AA;
grant select, alter on WORKSTREAM_SEQ to IDEAS;
grant select on WORKSTREAM_SEQ to IDEAS_CONNECTOR;
grant select on WORKSTREAM_SEQ to IDEAS_REPORT;
