CREATE TABLE ATTR_PERMISSION_MAPPING
(
  ID                             NUMBER(16)         NOT NULL,
  NAME                           VARCHAR2(256 CHAR) NOT NULL,
  DESCRIPTION                    VARCHAR2(512 CHAR),
  DISABLED                       NUMBER(1)          DEFAULT 0 NOT NULL,
  TYPE                           VARCHAR2(128)      NOT NULL,
  REQUIRED                       NUMBER(1)          DEFAULT 0 NOT NULL,
  SINGLE_VALUE                   NUMBER(1)          DEFAULT 0 NOT NULL,
  TARGET                         VARCHAR2(256 CHAR) NOT NULL,
  APPLICATION_NAME               VARCHAR2(256 CHAR),
  PERMISSION_TYPE                VARCHAR2(256 CHAR),
  PERMISSION_NAME                VARCHAR2(256 CHAR),
  ATTR1                          VARCHAR2(256 CHAR),
  ATTR2                          VARCHAR2(256 CHAR),
  ATTR3                          VARCHAR2(256 CHAR),
  ATTR4                          VARCHAR2(256 CHAR),
  ATTR5                          VARCHAR2(256 CHAR),
  CREATION_USER                  VARCHAR2(128 CHAR),
  CREATION_DATE                  DATE                DEFAULT SYSDATE,
  LAST_MOD_USER                  VARCHAR2(128 CHAR),
  LAST_MOD_TIME                  DATE                DEFAULT SYSDATE
)
tablespace &DATA_TABLESPACE
;

alter table ATTR_PERMISSION_MAPPING
  add constraint ATTR_PERMISSION_MAPPING_PK primary key (ID)
  using index 
  tablespace &INDEX_TABLESPACE compute statistics;

CREATE UNIQUE INDEX ATTR_PERMISSION_MAPPING_IDX ON ATTR_PERMISSION_MAPPING (NAME, TARGET)
tablespace &INDEX_TABLESPACE compute statistics;

--COMMENT ON COLUMN ATTR_PERMISSION_MAPPING.DISABLED IS
--'0: FALSE 1: TRUE';

COMMENT ON COLUMN ATTR_PERMISSION_MAPPING.REQUIRED IS
'0: FALSE 1: TRUE';

COMMENT ON COLUMN ATTR_PERMISSION_MAPPING.SINGLE_VALUE IS
'0: FALSE 1: TRUE';

grant select on ATTR_PERMISSION_MAPPING to AA;
grant select, insert, update, delete, references on ATTR_PERMISSION_MAPPING to IDEAS;
grant select, insert, update, delete, references on ATTR_PERMISSION_MAPPING to IDEAS_CONNECTOR;
grant select on ATTR_PERMISSION_MAPPING to IDEAS_REPORT;


create sequence ATTR_PERMISSION_MAPPING_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER
;

grant select on ATTR_PERMISSION_MAPPING_SEQ to AA;
grant select, alter on ATTR_PERMISSION_MAPPING_SEQ to IDEAS;
grant select on ATTR_PERMISSION_MAPPING_SEQ to IDEAS_CONNECTOR;
grant select on ATTR_PERMISSION_MAPPING_SEQ to IDEAS_REPORT;
