CREATE TABLE ATTR_PERMISSION_MAPPING
(
  ID                             NUMERIC(16)         NOT NULL,
  NAME                           VARCHAR(256)        NOT NULL,
  DESCRIPTION                    VARCHAR(512),
  DISABLED                       NUMERIC(1)          DEFAULT 0 NOT NULL,
  TYPE                           VARCHAR(128)        NOT NULL,
  REQUIRED                       NUMERIC(1)          DEFAULT 0 NOT NULL,
  SINGLE_VALUE                   NUMERIC(1)          DEFAULT 0 NOT NULL,
  TARGET                         VARCHAR(256)        NOT NULL,
  APPLICATION_NAME               VARCHAR(256),
  PERMISSION_TYPE                VARCHAR(256),
  PERMISSION_NAME                VARCHAR(256),
  ATTR1                          VARCHAR(256),
  ATTR2                          VARCHAR(256),
  ATTR3                          VARCHAR(256),
  ATTR4                          VARCHAR(256),
  ATTR5                          VARCHAR(256),
  CREATION_USER                  VARCHAR(128),
  CREATION_DATE                  DATE                DEFAULT CURRENT_DATE,
  LAST_MOD_USER                  VARCHAR(128),
  LAST_MOD_TIME                  DATE                DEFAULT CURRENT_DATE
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE ATTR_PERMISSION_MAPPING ADD
  CONSTRAINT ATTR_PERMISSION_MAPPING_PK
 PRIMARY KEY (ID);

CREATE UNIQUE INDEX ATTR_PERMISSION_MAPPING_IDX ON ATTR_PERMISSION_MAPPING (NAME, TARGET)
;

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE ATTR_PERMISSION_MAPPING' );

--COMMENT ON COLUMN ATTR_PERMISSION_MAPPING.DISABLED IS
--'0: FALSE 1: TRUE';

COMMENT ON COLUMN ATTR_PERMISSION_MAPPING.REQUIRED IS
'0: FALSE 1: TRUE';

COMMENT ON COLUMN ATTR_PERMISSION_MAPPING.SINGLE_VALUE IS
'0: FALSE 1: TRUE';

grant select on ATTR_PERMISSION_MAPPING to &AA_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on ATTR_PERMISSION_MAPPING to &IDEAS_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on ATTR_PERMISSION_MAPPING to &IDEAS_CONN_SUPER_ADMIN_USER;
grant select on ATTR_PERMISSION_MAPPING to &IDEAS_REPORT_SUPER_ADMIN_USER;


CREATE SEQUENCE ATTR_PERMISSION_MAPPING_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

grant usage on sequence ATTR_PERMISSION_MAPPING_SEQ to &AA_SUPER_ADMIN_USER;
grant usage, alter on sequence ATTR_PERMISSION_MAPPING_SEQ to &IDEAS_SUPER_ADMIN_USER;
grant usage, alter on sequence ATTR_PERMISSION_MAPPING_SEQ to &IDEAS_CONN_SUPER_ADMIN_USER;
grant usage on sequence ATTR_PERMISSION_MAPPING_SEQ to &IDEAS_REPORT_SUPER_ADMIN_USER;
