CREATE TABLE ATTR_RIGHT_VALUE_MAPPING
(
  ID                             NUMERIC(16)         NOT NULL,
  MAPPING_ID                     NUMERIC(16)         NOT NULL,
  ATTRIBUTE_VALUE                VARCHAR(256)        NOT NULL,
  RIGHT_VALUE                    VARCHAR(256),
  AS_DEFAULT                     NUMERIC(1)          DEFAULT 0 NOT NULL,
  DESCRIPTION                    VARCHAR(512),
  ATTR1                          VARCHAR(256),
  ATTR2                          VARCHAR(256),
  ATTR3                          VARCHAR(256),
  ATTR4                          VARCHAR(256),
  ATTR5                          VARCHAR(256),
  CREATION_USER                  VARCHAR(128),
  CREATION_DATE                  DATE                DEFAULT CURRENT_DATE,
  LAST_MOD_USER                  VARCHAR(128),
  LAST_MOD_TIME                  DATE                DEFAULT CURRENT_DATE
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE ATTR_RIGHT_VALUE_MAPPING ADD
  CONSTRAINT ATTR_RIGHT_VALUE_MAPPING_PK
 PRIMARY KEY (ID);

ALTER TABLE ATTR_RIGHT_VALUE_MAPPING ADD
  CONSTRAINT ATTR_PERMISSION_MAPPING_ID_FK
 FOREIGN KEY (MAPPING_ID)
 REFERENCES ATTR_PERMISSION_MAPPING (ID)
    ON DELETE CASCADE;

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE ATTR_RIGHT_VALUE_MAPPING' );

COMMENT ON COLUMN ATTR_RIGHT_VALUE_MAPPING.AS_DEFAULT IS
'0: FALSE 1: TRUE';

grant select on ATTR_RIGHT_VALUE_MAPPING to &AA_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on ATTR_RIGHT_VALUE_MAPPING to &IDEAS_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on ATTR_RIGHT_VALUE_MAPPING to &IDEAS_CONN_SUPER_ADMIN_USER;
grant select on ATTR_RIGHT_VALUE_MAPPING to &IDEAS_REPORT_SUPER_ADMIN_USER;


CREATE SEQUENCE ATTR_RIGHT_VALUE_MAPPING_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

grant usage on sequence ATTR_RIGHT_VALUE_MAPPING_SEQ to &AA_SUPER_ADMIN_USER;
grant usage, alter on sequence ATTR_RIGHT_VALUE_MAPPING_SEQ to &IDEAS_SUPER_ADMIN_USER;
grant usage, alter on sequence ATTR_RIGHT_VALUE_MAPPING_SEQ to &IDEAS_CONN_SUPER_ADMIN_USER;
grant usage on sequence ATTR_RIGHT_VALUE_MAPPING_SEQ to &IDEAS_REPORT_SUPER_ADMIN_USER;
