--CREATE A TABLE AND ITS CONSTRAINTS
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'TMP_JOIN_TASK';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tables t where t.owner = curr_user and t.table_name = tab_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'create global temporary table TMP_JOIN_TASK
(
  CODE VARCHAR2(128 CHAR)
)
on commit delete rows
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'create index TMP_JOIN_TASK_CODE_IDX on TMP_JOIN_TASK (CODE)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

grant select on TMP_JOIN_TASK to AA;
grant select, insert, update, delete, references on TMP_JOIN_TASK to IDEAS;
grant select, insert, update, delete, references on TMP_JOIN_TASK to IDEAS_CONNECTOR;
grant select on TMP_JOIN_TASK to IDEAS_REPORT;
