--CREATE A TABLE AND ITS CONSTRAINTS
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'TMP_JOIN_TASK';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from sysibm.tables t where ( t.table_type = 'BASE TABLE' or t.table_type is null ) and lower ( t.table_schema ) = lower ( curr_user ) and t.table_name = tab_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'CREATE GLOBAL TEMPORARY TABLE TMP_JOIN_TASK
(
  CODE                           VARCHAR(128)
)
ON COMMIT DELETE ROWS
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'create index TMP_JOIN_TASK_CODE_IDX on TMP_JOIN_TASK (CODE)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
commit;
set serveroutput off
set verify on

grant select on TMP_JOIN_TASK to &AA_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on TMP_JOIN_TASK to &IDEAS_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on TMP_JOIN_TASK to &IDEAS_CONN_SUPER_ADMIN_USER;
grant select on TMP_JOIN_TASK to &IDEAS_REPORT_SUPER_ADMIN_USER;
