CREATE OR REPLACE TRIGGER TRG_ENT_HIER_PROTECTION
  BEFORE INSERT OR UPDATE ON ENTITLEMENT_HIER
  FOR EACH ROW
declare
  ENT_EXT_ROLE_TYPE      constant numeric(1) := -1;
  ENT_PROFILE_TYPE       constant numeric(1) := 1;
  counter                numeric(16);
begin
  --un padre di livello piu' basso del figlio non e' permesso
  if ( :new.parent_int_type < :new.child_int_type ) then
    --2015-07-13 - Aggiunta eccezione per ruolo unfulfilled padre di un ruolo fulfilled
    if ( :new.parent_int_type <> ENT_EXT_ROLE_TYPE and :new.child_int_type <> ENT_PROFILE_TYPE ) then
      /*PG-BEGIN*/
      RAISE_APPLICATION_ERROR ( -20099, 'HIERARCHY ERROR!!! PARENT LEVEL '|| :new.parent_int_type || ' WITH CHILD LEVEL '||:new.child_int_type ||' NOT ALLOWED!');
      /*RAISE EXCEPTION 'HIERARCHY ERROR!!! PARENT LEVEL % WITH CHILD LEVEL % NOT ALLOWED!', new.parent_int_type, new.child_int_type;
      return null;*/
      /*PG-END*/
    end if;
  end if;

  select count(1) into counter from tmp_codoperation;

  if ( counter = 0 and inserting ) then
    RAISE_APPLICATION_ERROR ( -20004, 'NO DIRECT INSERTION ALLOWED ON THIS TABLE');
  elsif( counter = 0 and updating ) then
    RAISE_APPLICATION_ERROR ( -20005, 'NO DIRECT UPDATING ALLOWED ON THIS TABLE');
  end if;

end TRG_ENT_HIER_PROTECTION;
/