create or replace view entitlement_i18n as
with entitlement_localized as
(
  select
    ( 0 - e.id ) as id,
    1 as language,
    e.name as i18n_name,
    e.description as i18n_desc,
    e.id as entitlement
  from entitlement e
  union
  select
    i.id,
    i.language,
    i.name as i18n_name,
    i.description as i18n_desc,
    e.id as entitlement
  from entitlement e, i18n_entity i
  where e.id = i.entitlement and i.entitlement is not null
)
select
  t.id,
  t.language,
  t.i18n_name,
  t.i18n_desc,
  t.entitlement,
  e.code,
  e.name,
  e.description,
  e.int_type,
  e.profile_ext_type,
  e.family,
  e.state,
  e.last_mod_user,
  e.last_mod_time,
  e.attr1,
  e.attr2,
  e.attr3,
  e.attr4,
  e.attr5,
  e.application,
  e.value,
  e.type,
  e.auth,
  e.profile_type,
  e.sod,
  e.dn,
  e.business_name,
  e.it_resource_name,
  e.owner,
  e.organization,
  e.user_membership,
  e.expiration,
  e.last_date_reviewed,
  e.business_policy,
  e.privilege,
  e.sod_policy,
  e.jr_constraint,
  e.exception,
  e.delegation,
  e.workflow_auth,
  e.workflow_auth_state,
  e.workflow_check,
  e.workflow_check_state,
  e.jobrole_family,
  e.to_review,
  e.last_review,
  e.authorized,
  e.modified,
  e.creation_user,
  e.creation_date,
  e.ownercode,
  e.scope_visibility,
  e.revision,
  e.revision_date,
  e.revision_comment,
  e.administrative,
  e.required_resource,
  e.flow_auth,
  e.flow_auth_state,
  e.flow_check,
  e.flow_check_state,
  e.ext_type,
  e.ext_ref,
  e.attribute_based,
  e.required,
  e.attribute_name
from
  entitlement e,
  entitlement_localized t
where e.id = t.entitlement
;
