CREATE OR REPLACE function ent_30_ent_flat_hier_align
(
  entitlement_id in numeric(31),
  cr_user in varchar(4000)
)
return sys_refcursor is
  ENTITLEMENT_DELETED       constant numeric(1) := 2;

  count_cur                 sys_refcursor;

  counter                   numeric(16);
begin
  select count(1) into counter from entitlement_flat_hier t where t.parent = entitlement_id;

  if ( counter >= 1 ) then
    --cancelliamo gli eventuali profili non piu' presenti
    delete from entitlement_flat_hier t where t.id in
    (
      select t.id from entitlement_flat_hier t,
      (
        select
          t.parent, t.parent_int_type, t.parent_ext_type, t.parent_application, t.parent_profile_type,
          t.child, t.child_int_type, t.child_ext_type, t.child_application, t.child_profile_type,
          eh.lvl, cr_user
        from
        (
          select
            efh.parent, efh.parent_int_type, efh.parent_ext_type, efh.parent_application, efh.parent_profile_type,
            efh.child, efh.child_int_type, efh.child_ext_type, efh.child_application, efh.child_profile_type,
            efh.ext_fulfillment_limit
          from
            entitlement_flat_hier efh
          where
            efh.parent = entitlement_id
          minus
          select
            p.id as parent, p.int_type as parent_int_type, p.ext_type as parent_ext_type, p.application as parent_application, p.profile_type as parent_profile_type,
            c.id as child, c.int_type as child_int_type, c.ext_type as child_ext_type, c.application as child_application, c.profile_type as child_profile_type,
            th.ext_fulfillment_limit
          from
            (
              select t.parent, t.child, min(t.ext_fulfillment_limit) as ext_fulfillment_limit, min(t.lvl) as lvl from
              (
                select t.parent, t.child, t.ext_fulfillment_limit, min(lvl) as lvl from
                (
                  select entitlement_id as parent, t.child as child, t.ext_fulfillment_limit as ext_fulfillment_limit, level as lvl from
                  /*PG-BEGIN*/
                  entitlement_hier t
                  connect by t.parent = prior t.child
                  start with t.parent = entitlement_id
                  /*(
                    select * from connectby ( 'entitlement_hier', 'child', 'parent', cast ( entitlement_id as varchar ), 0 )
                    as t ( child numeric(16), parent numeric(16), level int )
                  ) tt, entitlement_hier t where tt.parent = t.parent and tt.child = t.child*/
                  /*PG-END*/
                  union
                  select entitlement_id as parent, entitlement_id as child, 0 as ext_fulfillment_limit, 0 as lvl from dual
                ) t group by t.parent, t.child, t.ext_fulfillment_limit
              ) t group by t.parent, t.child
            ) th,
            entitlement p,
            entitlement c
          where
            th.parent = p.id
            and th.child = c.id
            and c.modified <> ENTITLEMENT_DELETED
         ) t, entitlement_flat_hier eh where eh.parent = t.parent and eh.child = t.child
      ) pr_del where t.child = pr_del.child and t.parent = pr_del.parent and t.parent = entitlement_id
    );
  end if;

  insert into entitlement_flat_hier
  (
    id,
    parent, parent_int_type, parent_ext_type, parent_application, parent_profile_type,
    child, child_int_type, child_ext_type, child_application, child_profile_type,
    lvl, creation_user, ext_fulfillment_limit
  )
  with ent_hier as
  (
    select t.parent, t.child, min(t.ext_fulfillment_limit) as ext_fulfillment_limit, min(t.lvl) as lvl from
    (
      select t.parent, t.child, t.ext_fulfillment_limit, min(lvl) as lvl from
      (
        select entitlement_id as parent, t.child as child, t.ext_fulfillment_limit as ext_fulfillment_limit, level as lvl from
        /*PG-BEGIN*/
        entitlement_hier t
        connect by t.parent = prior t.child
        start with t.parent = entitlement_id
        /*(
          select * from connectby ( 'entitlement_hier', 'child', 'parent', cast ( entitlement_id as varchar ), 0 )
          as t ( child numeric(16), parent numeric(16), level int )
        ) tt, entitlement_hier t where tt.parent = t.parent and tt.child = t.child*/
        /*PG-END*/
        union
        select entitlement_id as parent, entitlement_id as child, 0 as ext_fulfillment_limit, 0 as lvl from dual
      ) t group by t.parent, t.child, t.ext_fulfillment_limit
    ) t group by t.parent, t.child
  )
  select
    entitlement_flat_hier_seq.nextval,
    t.parent, t.parent_int_type, t.parent_ext_type, t.parent_application, t.parent_profile_type,
    t.child, t.child_int_type, t.child_ext_type, t.child_application, t.child_profile_type,
    eh.lvl, cr_user, t.ext_fulfillment_limit
  from
  (
    select
      p.id as parent, p.int_type as parent_int_type, p.ext_type as parent_ext_type, p.application as parent_application, p.profile_type as parent_profile_type,
      c.id as child, c.int_type as child_int_type, c.ext_type as child_ext_type, c.application as child_application, c.profile_type as child_profile_type,
      th.ext_fulfillment_limit as ext_fulfillment_limit
    from
      ent_hier th,
      entitlement p,
      entitlement c
    where
      th.parent = p.id
      and th.child = c.id
      and c.modified <> ENTITLEMENT_DELETED
    minus
    select
      efh.parent, efh.parent_int_type, efh.parent_ext_type, efh.parent_application, efh.parent_profile_type,
      efh.child, efh.child_int_type, efh.child_ext_type, efh.child_application, efh.child_profile_type,
      efh.ext_fulfillment_limit
    from
      entitlement_flat_hier efh
    where
      efh.parent = entitlement_id
  ) t, ent_hier eh where eh.parent = t.parent and eh.child = t.child;

  open count_cur for select cast ( 1 as numeric(16) ) as COUNTER from dual;
  return count_cur;
end ent_30_ent_flat_hier_align;
/
