CREATE OR REPLACE function ou_flat_hier_calc
(
  num_of_days in number
)
return number is
   cur_ou      sys_refcursor;

   ou_id       number(16);
   counter     number(16);
begin
  if ( num_of_days is not null ) then
    select count(1) into counter from organizational_unit t
    /*PG-BEGIN*/
    where t.last_mod_time > sysdate - num_of_days;
    /*where t.last_mod_time > now() - ( num_of_days || ' day')::INTERVAL;*/
    /*PG-END*/
    if ( counter = 0 ) then
      return 0;
    end if;
  end if;

  delete from organizational_unit_flat_hier t;

  /*PG-BEGIN*/

  /*execute 'create or replace temporary view ou_hierarchy as select * from organizational_unit where hierarchy = 1';*/
  /*PG-END*/

  open cur_ou for
    /*PG-BEGIN*/
    select t.id from organizational_unit t
    connect by prior t.id = t.parent
    start with t.id = 1
    /*select t.id from connectby ( 'ou_hierarchy', 'id', 'parent', cast (1 as varchar), 0 )
    as t ( id numeric(16), parent numeric(16), level int )*/
    /*PG-END*/
    order by level;
  loop
    fetch cur_ou into ou_id;
    exit when cur_ou%NOTFOUND;

    /*PG-BEGIN*/

    /*insert into organizational_unit_flat_hier ( parent, child, lvl )
    values ( ou_id, ou_id, 1 );*/
    /*PG-END*/

    insert into organizational_unit_flat_hier ( parent, child, lvl )
    select th.parent, th.child, th.lvl from
      /*PG-BEGIN*/
      (select ou_id as parent, t.id as child, level as lvl from organizational_unit t
      where t.hierarchy = 1
      connect by prior t.id = t.parent
      start with t.id = ou_id) th
      /*(select ou_id as parent, ouhier.child, ouhier.level + 1 as lvl from ou_hierarchy t,
      (select * from connectby('ou_hierarchy', 'id', 'parent', cast (ou_id as varchar), 0)
      as t(child numeric(16), parent numeric(16), level int)) ouhier where t.parent = ouhier.parent) th*/
      /*PG-END*/
      /*where th.parent <> th.child*/
      ;
  end loop;
  close cur_ou;

  return 1;
end ou_flat_hier_calc;
/
