CREATE TABLE PWDMANAGEMENT_ATTR_VAL
(
  ID                             NUMBER(16)          NOT NULL,
  PWDMANAGEMENT                  NUMBER(16)          NOT NULL,
  PWDCFG_ATTR_KEY                NUMBER(16)          NOT NULL,
  VALUE                          VARCHAR2(512 CHAR),
  STATE                          NUMBER(16)          DEFAULT 0,
  ATTR1                          VARCHAR2(256 CHAR),
  ATTR2                          VARCHAR2(256 CHAR),
  ATTR3                          VARCHAR2(256 CHAR),
  ATTR4                          VARCHAR2(256 CHAR),
  ATTR5                          VARCHAR2(256 CHAR),
  CREATION_DATE                  DATE                DEFAULT SYSDATE,
  CREATION_USER                  VARCHAR2(128 CHAR),
  LAST_MOD_USER                  VARCHAR2(128 CHAR),
  LAST_MOD_TIME                  DATE                DEFAULT SYSDATE
)
TABLESPACE &DATA_TABLESPACE
;

ALTER TABLE PWDMANAGEMENT_ATTR_VAL ADD (
  CONSTRAINT PWDMANAGEMENT_ATTR_VAL_PK
 PRIMARY KEY
 (ID)
  USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS);

ALTER TABLE PWDMANAGEMENT_ATTR_VAL ADD (
  CONSTRAINT PWDMAN_ATTR_VAL_PWDCFG_AK_FK
 FOREIGN KEY (PWDCFG_ATTR_KEY)
 REFERENCES PWDMANAGEMENT_ATTR_VAL (ID)
    ON DELETE CASCADE);

ALTER TABLE PWDMANAGEMENT_ATTR_VAL ADD (
  CONSTRAINT PWDMAN_ATTR_VAL_PWDMAN_FK
 FOREIGN KEY (PWDMANAGEMENT)
 REFERENCES PWDMANAGEMENT (ID)
    ON DELETE CASCADE);

CREATE INDEX PWDMAN_ATTR_VAL_PWDCFG_AK_IDX ON PWDMANAGEMENT_ATTR_VAL
(PWDCFG_ATTR_KEY)
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

CREATE INDEX PWDMAN_ATTR_VAL_PWDMAN_IDX ON PWDMANAGEMENT_ATTR_VAL
(PWDMANAGEMENT)
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

CREATE INDEX PWDMAN_ATTR_VAL_UNIQUE_IDX ON PWDMANAGEMENT_ATTR_VAL
(PWDMANAGEMENT, PWDCFG_ATTR_KEY, LOWER(VALUE))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

grant select on PWDMANAGEMENT_ATTR_VAL to AA;
grant select, insert, update, delete, references on PWDMANAGEMENT_ATTR_VAL to IDEAS;
grant select, insert, update, delete, references on PWDMANAGEMENT_ATTR_VAL to IDEAS_CONNECTOR;
grant select on PWDMANAGEMENT_ATTR_VAL to IDEAS_REPORT;


CREATE SEQUENCE PWDMANAGEMENT_ATTR_VAL_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER;

grant select on PWDMANAGEMENT_ATTR_VAL_SEQ to AA;
grant select, alter on PWDMANAGEMENT_ATTR_VAL_SEQ to IDEAS;
grant select on PWDMANAGEMENT_ATTR_VAL_SEQ to IDEAS_CONNECTOR;
grant select on PWDMANAGEMENT_ATTR_VAL_SEQ to IDEAS_REPORT;
