--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'AUTHORIZATIONS';
  tab_col_name      varchar2(30) := 'ATTRIBUTE_BASED';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tab_columns t where t.owner = curr_user and t.table_name = tab_name and t.column_name = tab_col_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table AUTHORIZATIONS add ATTRIBUTE_BASED NUMBER(1)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on


alter trigger trg_add_modify_authorizations disable;

declare
  cur_pr        sys_refcursor;
  
  pr_id         number(16);
  pr_attr_based varchar2(256);
begin
  open cur_pr for
    select distinct
      e.id,
      case
        when e.attribute_based = 1 then '1'
        else null
      end attr_based
      from authorizations au, entitlement e
    where
      au.profile= e.id
      and e.attribute_based is not null;
  loop
    fetch cur_pr into pr_id, pr_attr_based;
    exit when cur_pr%NOTFOUND;
    
    update authorizations set attribute_based = pr_attr_based where profile = pr_id;
  end loop;
  close cur_pr;
end;
/
commit;

alter trigger trg_add_modify_authorizations enable;
