--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'AUTHORIZATIONS';
  tab_col_name      varchar(30) := 'ATTRIBUTE_BASED';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.columns t where t.tabschema = curr_user and lower ( t.tabname ) = lower ( tab_name ) and lower ( t.colname ) = lower ( tab_col_name );
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table AUTHORIZATIONS add ATTRIBUTE_BASED NUMERIC(1)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on


declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_disable ( 'trg_add_modify_authorizations' );
end;
/

declare
  cur_pr        sys_refcursor;
  
  pr_id         numeric(16);
  pr_attr_based varchar(256);
begin
  open cur_pr for
    select distinct
      e.id,
      case
        when e.attribute_based = 1 then '1'
        else null
      end attr_based
      from authorizations au, entitlement e
    where
      au.profile= e.id
      and e.attribute_based is not null;
  loop
    fetch cur_pr into pr_id, pr_attr_based;
    exit when cur_pr%NOTFOUND;
    
    update authorizations set attribute_based = pr_attr_based where profile = pr_id;
  end loop;
  close cur_pr;
end;
/
commit;

declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_enable ( 'trg_add_modify_authorizations' );
end;
/
