create or replace function event_20_align_per_prof_id
return number is
  cur_per_prof     sys_refcursor;
  per_prof_id      number(16);

  per_id           number(16);
  acc_code         varchar2(256);
  tar_name         varchar2(256);

  pro_id           number(16);
  pro_type         varchar2(256);
  pro_ext_ref      varchar2(256);

  counter          number(16);
begin
  open cur_per_prof for select t.id, t.account_code, t.target from person_profile t where t.person is null;
  loop
    fetch cur_per_prof into per_prof_id, acc_code, tar_name;
    exit when cur_per_prof%NOTFOUND;

    select count(1) into counter from pwdmanagement pwd, target t
    where pwd.pwdcfg = t.pwdcfg and pwd.person is not null
    and lower ( pwd.code ) = lower ( acc_code ) and lower ( t.name ) = lower ( tar_name );
    if ( counter = 1 ) then
      select pwd.person into per_id from pwdmanagement pwd, target t
      where pwd.pwdcfg = t.pwdcfg and pwd.person is not null
      and lower ( pwd.code ) = lower ( acc_code ) and lower ( t.name ) = lower ( tar_name );

      update person_profile set person = per_id where id = per_prof_id;
    end if;
  end loop;
  close cur_per_prof;

  open cur_per_prof for select t.id, t.permission_code, t.permission_type, t.target from person_profile t where t.profile is null;
  loop
    fetch cur_per_prof into per_prof_id, pro_ext_ref, pro_type, tar_name;
    exit when cur_per_prof%NOTFOUND;

    select count(1) into counter from entitlement e, profile_type pt, application a, target t
    where e.profile_type = pt.id and pt.application = a.id and a.target = t.id
    and lower ( e.ext_ref ) = lower ( pro_ext_ref ) and lower ( pt.name ) = lower ( pro_type )
    and lower ( t.value ) = lower ( tar_name );
    if ( counter = 1 ) then
      select e.id into pro_id from entitlement e, profile_type pt, application a, target t
      where e.profile_type = pt.id and pt.application = a.id and a.target = t.id
      and lower ( e.ext_ref ) = lower ( pro_ext_ref ) and lower ( pt.name ) = lower ( pro_type )
      and lower ( t.value ) = lower ( tar_name );

      update person_profile set profile = pro_id where id = per_prof_id;
    else
      select count(1) into counter from entitlement e, profile_type pt, application a, target t
      where e.profile_type = pt.id and pt.application = a.id and a.target = t.id
      and lower ( e.name ) = lower ( pro_ext_ref ) and lower ( pt.name ) = lower ( pro_type )
      and lower ( t.value ) = lower ( tar_name );
      if ( counter = 1 ) then
        select e.id into pro_id from entitlement e, profile_type pt, application a, target t
        where e.profile_type = pt.id and pt.application = a.id and a.target = t.id
        and lower ( e.name ) = lower ( pro_ext_ref ) and lower ( pt.name ) = lower ( pro_type )
        and lower ( t.value ) = lower ( tar_name );

        update person_profile set profile = pro_id where id = per_prof_id;
      end if;
    end if;

  end loop;
  close cur_per_prof;

  return 0;
end event_20_align_per_prof_id;
/

GRANT EXECUTE ON event_20_align_per_prof_id TO ideas;
