CREATE OR REPLACE function event_20_align_per_prof_status
return number is
  cur_per_prof     sys_refcursor;
  per_prof_id      number(16);

  per_id           number(16);
  pro_id           number(16);

  counter          number(16);
begin
  open cur_per_prof for select t.id, t.person, t.profile from person_profile t where t.person is not null and t.profile is not null and t.status = 4;
  loop
    fetch cur_per_prof into per_prof_id, per_id, pro_id;
    exit when cur_per_prof%NOTFOUND;

    select count(1) into counter from person p, employment e, entitlement_flat_hier efh
    where p.id = per_id and p.id = e.person and e.entitlement = efh.parent and efh.child = pro_id;
    if ( counter > 0 ) then
      update person_profile set status = 2 where id = per_prof_id;
    end if;
  end loop;
  close cur_per_prof;

  return 0;
end event_20_align_per_prof_status;
/

GRANT EXECUTE ON event_20_align_per_prof_status TO ideas;
