CREATE OR REPLACE function event_20_align_per_prof_status
return numeric(31) is
  cur_per_prof     sys_refcursor;
  per_prof_id      numeric(16);

  per_id           numeric(16);
  pro_id           numeric(16);

  counter          numeric(16);
begin
  open cur_per_prof for select t.id, t.person, t.profile from person_profile t where t.person is not null and t.profile is not null and t.status = 4;
  loop
    fetch cur_per_prof into per_prof_id, per_id, pro_id;
    exit when cur_per_prof%NOTFOUND;

    select count(1) into counter from person p, employment e, entitlement_flat_hier efh
    where p.id = per_id and p.id = e.person and e.entitlement = efh.parent and efh.child = pro_id;
    if ( counter > 0 ) then
      update person_profile set status = 2 where id = per_prof_id;
    end if;
  end loop;
  close cur_per_prof;

  return 0;
end event_20_align_per_prof_status;
/

GRANT EXECUTE ON FUNCTION "EVENT_20_ALIGN_PER_PROF_STATUS" TO &IDEAS_SUPER_ADMIN_USER;


CREATE OR REPLACE PROCEDURE event_20_align_per_prof_status_sp
(
  counter out numeric(31)
)
AS
begin
  counter := event_20_align_per_prof_status;
end event_20_align_per_prof_status_sp;
/

GRANT EXECUTE ON PROCEDURE "EVENT_20_ALIGN_PER_PROF_STATUS_SP" TO &IDEAS_SUPER_ADMIN_USER;
