CREATE OR REPLACE function event_21_prc_event_out
(
  v_event in numeric(31),
  v_security_block in numeric(31)
)
return sys_refcursor is
  -- elenco eventi Profile Manager

  v_eventpm_cur         sys_refcursor;
  v_eventpm_id          numeric(16);
  v_eventpm_rownum      numeric(16);

  v_eventpm             eventpm%rowtype;

  -- cursore temporaneo
  cur_tmp               sys_refcursor;

  -- variabile contatore eventi
  v_counter             numeric(16);

  v_operation           numeric(2);
  v_user_erc_id         numeric(16);
  v_cod_operation       varchar(256);
  v_state               numeric(16);
  v_priority            numeric(1);
  v_trace               varchar(256);

  v_return              numeric(16);
begin
  -- gestione lock per gestione la lettura degli eventi in serie (no parallelo)
  update configuration set value = 0 where name = 'ERLOCKOUT';

  v_state := 0;
  v_trace := '';

  -- blocco di sicurezza
  open cur_tmp for select count(1) from eventpm t;
  fetch cur_tmp into v_counter;
  close cur_tmp;

  if ( v_security_block <> -1 and v_counter >= v_security_block ) then
    -- implementazione blocco sicurezza --
    v_state := 2;
    v_trace := 'Blocco di sicurezza';
  end if;
  ----------------------

  open v_eventpm_cur for
    /*PG-BEGIN*/
    select t.id, rownum
      from eventpm t
     where rownum <= (v_event + 1)
     order by id;
    /*select t.id, row_number() OVER (ORDER BY id) as i
      from eventpm t
     order by id
     limit (v_event + 1);*/
    /*PG-END*/

  -- iterazione eventi pm --
  loop
    fetch v_eventpm_cur into v_eventpm_id, v_eventpm_rownum;
    /*PG-BEGIN*/
    exit when v_eventpm_cur%NOTFOUND or v_eventpm_cur%ROWCOUNT >= v_event;
    /*exit when NOT FOUND;--or ROW COUNT >= v_event;*/
    /*PG-END*/

    /*PG-BEGIN*/
    v_return := event_20_align_per_prof_id;
    /*v_return := event_20_align_per_prof_id();*/
    /*PG-END*/

    v_user_erc_id := null;
    v_counter := null;

    select * into v_eventpm from eventpm t where t.id = v_eventpm_id;

    v_operation := v_eventpm.operation;
    v_cod_operation := v_eventpm.cod_operation;

    if ( v_cod_operation is null ) then
      v_cod_operation := 'PM_[CREATE_EVENT_PUT_PKG] not defined';
    end if;

    if ( substr(upper(v_cod_operation), 1, 5) = 'PM_DC' or substr(upper(v_cod_operation), 1, 8) = 'BATCHXLS' ) then
      v_priority := 1;
    else
      v_priority := 0;
    end if;

    ---------------------

    select count(1) into v_counter from person p where p.id = v_eventpm.person;

    -- la person non esiste
    if ( v_counter = 0 ) then
        v_user_erc_id := null;
    -- la person esiste
    else
      select p.user_erc into v_user_erc_id from person p where p.id = v_eventpm.person;

      --la userErc esiste
      if ( v_user_erc_id is not null ) then
        select count(1) into v_counter from user_erc ue where ue.id = v_user_erc_id;

        --non esiste la user_erc assegnata alla person
        if ( v_counter = 0 ) then
          v_user_erc_id := null;
        end if;

      end if;

    end if;

    v_counter := null;

    ------------------------

    -- *** controlli preliminari prima della gestione puntuale dell'evento *** --
    --aggiunta/rimozione profilo
    if ( v_operation = 1 or v_operation = 2 ) then
      select count(1) into v_counter from authorizations t where t.id = v_eventpm.authorizations;

      if ( v_counter = 0 ) then
        -- la riga e stata cancellata (probabilmente si tratta di applicazione non connettorizzata)
        v_operation := 99;
        v_return := event_01_del_fb_auth ( v_eventpm.authorizations, v_operation );
      end if;
      v_counter := null;
    end if;

    -- add functionality
    if ( v_operation = 1 ) then
      v_operation := event_11_funct_add ( v_eventpm, v_user_erc_id, v_state, v_trace, v_cod_operation, v_priority );
    -- remove functionality
    elsif ( v_operation = 2 ) then
      v_operation := event_11_funct_rem ( v_eventpm, v_user_erc_id, v_state, v_trace, v_cod_operation, v_priority );
    elsif ( v_operation = 6 ) then
      v_operation := event_11_account_mod ( v_eventpm, v_user_erc_id, v_state, v_trace, v_priority, 6 );
    -- enable account
    elsif ( v_operation = 7 ) then
      v_operation := event_11_account_mod ( v_eventpm, v_user_erc_id, v_state, v_trace, v_priority, 7 );
    -- change password
    elsif ( v_operation = 8 ) then
      v_operation := event_11_account_mod ( v_eventpm, v_user_erc_id, v_state, v_trace, v_priority, 8 );
    -- delete account
    elsif ( v_operation = 9 ) then
      v_operation := event_11_account_mod ( v_eventpm, v_user_erc_id, v_state, v_trace, v_priority, 9 );
    elsif ( v_operation = 10 ) then
      v_operation := event_11_account_mod ( v_eventpm, v_user_erc_id, v_state, v_trace, v_priority, 10 );
    elsif ( v_operation = 11 ) then
      v_operation := event_11_account_mod ( v_eventpm, v_user_erc_id, v_state, v_trace, v_priority, 11 );
    -- add/remove service
    elsif ( v_operation = 12 or v_operation = 13 ) then
      v_operation := event_11_serv_add_rem ( v_eventpm, v_user_erc_id, v_state, v_trace, v_cod_operation, v_priority );
    -- add resource
    elsif ( v_operation = 14 ) then
      v_operation := event_11_res_add (  v_eventpm, v_user_erc_id, v_state, v_trace, v_cod_operation, v_priority );
    -- remove resource
    elsif ( v_operation = 15 ) then
      v_operation := event_11_res_rem ( v_eventpm, v_user_erc_id, v_state, v_trace, v_cod_operation, v_priority );
    end if;

    -- cancellazione evento
    delete from eventpm t where t.id = v_eventpm.id;

  end loop;
  close v_eventpm_cur;

  /*PG-BEGIN*/
  v_return := event_20_align_per_prof_status;
  /*v_return := event_20_align_per_prof_status();*/
  /*PG-END*/

  open v_eventpm_cur for
    /*PG-BEGIN*/
    select t.id, rownum from eventpm t where rownum <= 2;
    /*select t.id, row_number() OVER (ORDER BY id) as i from eventpm t limit 2;*/
    /*PG-END*/

  return v_eventpm_cur;
end event_21_prc_event_out;
/
