--DROP A COLUMN FROM A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'ATTR_PERMISSION_MAPPING';
  tab_col_name      varchar2(30) := 'DISABLED';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tab_columns t where t.owner = curr_user and t.table_name = tab_name and t.column_name = tab_col_name;
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'alter table ATTR_PERMISSION_MAPPING drop column DISABLED
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on


--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'ATTR_PERMISSION_MAPPING';
  tab_col_name      varchar2(30) := 'ENABLED';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tab_columns t where t.owner = curr_user and t.table_name = tab_name and t.column_name = tab_col_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table ATTR_PERMISSION_MAPPING add ENABLED NUMBER(1) DEFAULT 0 NOT NULL
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

COMMENT ON COLUMN ATTR_PERMISSION_MAPPING.ENABLED IS
'0: FALSE 1: TRUE';

--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'ATTR_PERMISSION_MAPPING';
  tab_col_name      varchar2(30) := 'TARGET_ID';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tab_columns t where t.owner = curr_user and t.table_name = tab_name and t.column_name = tab_col_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table ATTR_PERMISSION_MAPPING add TARGET_ID NUMBER(16) DEFAULT 1
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on


--ADD A FOREIGN KEY
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'ATTR_PERMISSION_MAPPING';
  tab_fk_name       varchar2(30) := 'ATTR_PERM_MAPPING_TARGET_ID_FK';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_constraints t where t.owner = curr_user and t.table_name = tab_name and t.constraint_name = tab_fk_name and t.constraint_type = 'R';
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'ALTER TABLE ATTR_PERMISSION_MAPPING ADD
  CONSTRAINT ATTR_PERM_MAPPING_TARGET_ID_FK
 FOREIGN KEY (TARGET_ID)
 REFERENCES TARGET (ID)
    ON DELETE CASCADE
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on
