declare
  im_id         number(16);
  im_name       varchar2(256) := 'AGC';

  fc_id         number(16);
  fc_name       varchar2(256) := 'system';
  
  fet_id        number(16);
  fet_name      varchar2(256) := 'TARGET';
  
  f_id          number(16);
  f_name        varchar2(256) := 'RIGHT_ADD';
  
  f_lob         clob := 'package t50d0c052 
'||'
'||'import com.engiweb.logger.impl.Log4JImpl
'||'import com.engiweb.profilemanager.common.ruleengine.action.UserAction
'||'import com.engiweb.profilemanager.common.bean.UserBean
'||'import com.engiweb.profilemanager.common.bean.event.EventTargetBean
'||'import com.engiweb.profilemanager.common.bean.entitlement.EntitlementBean
'||'import com.engiweb.profilemanager.common.bean.rule.SyncStateBean
'||'import com.engiweb.profilemanager.backend.dao.rights.RightsDAO
'||'import com.engiweb.pm.entity.BeanList
'||'import com.engiweb.profilemanager.common.bean.ServiceAttributeBean
'||'import com.engiweb.profilemanager.common.ruleengine.action.RightsAction
'||'import com.engiweb.profilemanager.common.bean.OrgUnitBean
'||'import com.engiweb.profilemanager.common.ruleengine.action.OrgUnitAction
'||'import com.engiweb.profilemanager.common.ruleengine.action.EntitlementAction
'||'
'||'global com.engiweb.profilemanager.backend.dao.db.SQLH sql
'||'global com.engiweb.logger.impl.Log4JImpl logger
'||'';

  fe_id         number(16);

  counter       number(16);
begin
  select count(1) into counter from ideas_module t where lower ( t.code ) = lower ( im_name );
  if ( counter = 1 ) then
    select t.id into im_id from ideas_module t where lower ( t.code ) = lower ( im_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO IDEAS MODULE FOUND');
  end if;

  select count(1) into counter from flow_context t where lower ( t.name ) = lower ( fc_name );
  if ( counter = 1 ) then
    select t.id into fc_id from flow_context t where lower ( t.name ) = lower ( fc_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW CONTEXT FOUND');
  end if;

  select count(1) into counter from flow_event_type t
  where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fet_name );
  if ( counter = 0 ) then
    select flow_event_type_seq.nextval into fet_id from dual;
    
    insert into flow_event_type ( id, flow_context, name, ideas_module )
    values ( fet_id, fc_id, fet_name, im_id );
  else
    select t.id into fet_id from flow_event_type t
    where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fet_name );
  end if;
  
  select count(1) into counter from flow t
  where t.ideas_module = im_id and t.flow_event_type = fet_id and lower ( t.name ) = lower ( f_name ); 
  if ( counter = 0 ) then
    select flow_seq.nextval into f_id from dual;
    
    insert into flow ( id, flow_event_type, name, flow_lob, ideas_module )
    values ( f_id, fet_id, f_name, f_lob, im_id );
  else
    select t.id into f_id from flow t
    where t.ideas_module = im_id and t.flow_event_type = fet_id and lower ( t.name ) = lower ( f_name ); 

    update flow set flow_lob = f_lob where ideas_module = im_id and id = f_id;
  end if;
  
  select count(1) into counter from flow_entity t
  where t.ideas_module = im_id and t.flow = f_id and t.flow_type = 2 and t.flow_entity_type = 0 and t.parent is null; 
  if ( counter = 0 ) then
    select flow_entity_seq.nextval into fe_id from dual;
    
    insert into flow_entity ( id, flow, flow_type, root, parent, flow_entity_type, position, ideas_module)
    values ( fe_id, f_id, 2, fe_id, null, 0, 0, im_id );
  end if;

end;
/
commit;

--------------------------------------------------------------------
