declare
  cur           sys_refcursor;

  im_id         number(16);
  im_name       varchar2(256) := 'AGC';

  fc_id         number(16);
  fc_name       varchar2(256) := 'system';
  
  fet_id        number(16);
  fet_name      varchar2(256) := 'IN';
  
  f_id          number(16);
  f_name        varchar2(256) := 'ORGUNIT_MODIFY';
  
  fr_id         number(16);
  fr_name       varchar2(256) := 'Modify OrgUnit';
  
  fe_id         number(16);
  
  fe_index      number(16);

  counter       number(16);
begin
  select count(1) into counter from ideas_module t where lower ( t.code ) = lower ( im_name );
  if ( counter = 1 ) then
    select t.id into im_id from ideas_module t where lower ( t.code ) = lower ( im_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO IDEAS MODULE FOUND' );
  end if;

  select count(1) into counter from flow_context t where lower ( t.name ) = lower ( fc_name );
  if ( counter = 1 ) then
    select t.id into fc_id from flow_context t where lower ( t.name ) = lower ( fc_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW CONTEXT FOUND' );
  end if;

  select count(1) into counter from flow_event_type t
  where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fet_name );
  if ( counter = 1 ) then
    select t.id into fet_id from flow_event_type t
    where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fet_name );
  end if;
  
  select count(1) into counter from flow t
  where t.ideas_module = im_id and t.flow_event_type = fet_id and lower ( t.name ) = lower ( f_name ); 
  if ( counter = 1 ) then
    select t.id into f_id from flow t
    where t.ideas_module = im_id and t.flow_event_type = fet_id and lower ( t.name ) = lower ( f_name ); 
  end if;

  select count(1) into counter from flow_rule t
  where t.ideas_module = im_id and t.flow = f_id and lower ( t.name ) = lower ( fr_name ); 
  if ( counter = 1 ) then
    select t.id into fr_id from flow_rule t
    where t.ideas_module = im_id and t.flow = f_id and lower ( t.name ) = lower ( fr_name ); 
  end if;
  
  select count(1) into counter from flow_entity t where t.ideas_module = im_id and t.flow = f_id and t.flow_rule = fr_id;
  if ( counter > 1 ) then
    fe_index := 1;
    open cur for select t.id from flow_entity t where t.ideas_module = im_id and t.flow = f_id and t.flow_rule = fr_id;
    loop
      fetch cur into fe_id;
      exit when cur%NOTFOUND or counter = fe_index;
      
      delete from flow_entity t where t.id = fe_id;
      fe_index := fe_index + 1;
    end loop;
    close cur;
  end if;

end;
/
commit;
