CREATE TABLE TARGET_RESOURCE_SCHEMA
(
  ID                             NUMERIC(16)       NOT NULL,
  TARGET_ID                      NUMERIC(16)       DEFAULT 1 NOT NULL,
  RESOURCE_TYPE                  VARCHAR(256)      NOT NULL,
  TARGET_NAME                    VARCHAR(256),
  EVENT_MARKER                   VARCHAR(256),
  DEFINITION                     CLOB(2G),
  ATTR1                          VARCHAR(256),
  ATTR2                          VARCHAR(256),
  ATTR3                          VARCHAR(256),
  ATTR4                          VARCHAR(256),
  ATTR5                          VARCHAR(256),
  CREATION_USER                  VARCHAR(128),
  CREATION_DATE                  DATE                DEFAULT CURRENT_DATE,
  LAST_MOD_USER                  VARCHAR(128),
  LAST_MOD_TIME                  DATE                DEFAULT CURRENT_DATE
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE TARGET_RESOURCE_SCHEMA ADD
  CONSTRAINT TARGET_RESOURCE_SCHEMA_PK
 PRIMARY KEY (ID);

ALTER TABLE TARGET_RESOURCE_SCHEMA ADD
  CONSTRAINT TARGET_RES_SCHEMA_TARGETID_FK
 FOREIGN KEY (TARGET_ID)
 REFERENCES TARGET (ID)
    ON DELETE CASCADE;

CREATE UNIQUE INDEX TARGET_RESOURCE_SCHEMA_IDX ON TARGET_RESOURCE_SCHEMA
(TARGET_ID, RESOURCE_TYPE);

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE TARGET_RESOURCE_SCHEMA' );


grant select on TARGET_RESOURCE_SCHEMA to &AA_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on TARGET_RESOURCE_SCHEMA to &IDEAS_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on TARGET_RESOURCE_SCHEMA to &IDEAS_CONN_SUPER_ADMIN_USER;
grant select on TARGET_RESOURCE_SCHEMA to &IDEAS_REPORT_SUPER_ADMIN_USER;


CREATE SEQUENCE TARGET_RESOURCE_SCHEMA_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

grant usage on sequence TARGET_RESOURCE_SCHEMA_SEQ to &AA_SUPER_ADMIN_USER;
grant usage, alter on sequence TARGET_RESOURCE_SCHEMA_SEQ to &IDEAS_SUPER_ADMIN_USER;
grant usage, alter on sequence TARGET_RESOURCE_SCHEMA_SEQ to &IDEAS_CONN_SUPER_ADMIN_USER;
grant usage on sequence TARGET_RESOURCE_SCHEMA_SEQ to &IDEAS_REPORT_SUPER_ADMIN_USER;
