CREATE TABLE TARGET_RESOURCE_SCHEMA_DEF
(
  ID              NUMERIC(16)       NOT NULL,
  TR_SCHEMA_ID    NUMERIC(16)       NOT NULL,
  DEFINITION      CLOB(2G)
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

COMMENT ON COLUMN TARGET_RESOURCE_SCHEMA_DEF.DEFINITION IS
'DB2_CLOB_SIZE: 2G';

ALTER TABLE TARGET_RESOURCE_SCHEMA_DEF ADD
  CONSTRAINT TARGET_RESOURCE_SCHEMA_DEF_PK
 PRIMARY KEY (ID);
CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE TARGET_RESOURCE_SCHEMA_DEF' );

ALTER TABLE TARGET_RESOURCE_SCHEMA_DEF ADD
  CONSTRAINT TARGET_RES_SCHEMA_DEF_TRSID_FK
 FOREIGN KEY (TR_SCHEMA_ID)
 REFERENCES TARGET_RESOURCE_SCHEMA_DEF (ID)
    ON DELETE CASCADE;

grant select on TARGET_RESOURCE_SCHEMA_DEF to &AA_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on TARGET_RESOURCE_SCHEMA_DEF to &IDEAS_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on TARGET_RESOURCE_SCHEMA_DEF to &IDEAS_CONN_SUPER_ADMIN_USER;
grant select on TARGET_RESOURCE_SCHEMA_DEF to &IDEAS_REPORT_SUPER_ADMIN_USER;


CREATE SEQUENCE TARGET_RESOURCE_SCHEMA_DEF_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

grant usage on sequence TARGET_RESOURCE_SCHEMA_DEF_SEQ to &AA_SUPER_ADMIN_USER;
grant usage, alter on sequence TARGET_RESOURCE_SCHEMA_DEF_SEQ to &IDEAS_SUPER_ADMIN_USER;
grant usage, alter on sequence TARGET_RESOURCE_SCHEMA_DEF_SEQ to &IDEAS_CONN_SUPER_ADMIN_USER;
grant usage on sequence TARGET_RESOURCE_SCHEMA_DEF_SEQ to &IDEAS_REPORT_SUPER_ADMIN_USER;
