CREATE TABLE TARGET_RESOURCE_SCHEMA_DEF
(
  ID              NUMBER(16)       NOT NULL,
  TR_SCHEMA_ID    NUMBER(16)       NOT NULL,
  DEFINITION      CLOB
)
  LOB (DEFINITION) STORE AS
  (
    TABLESPACE   &LOB_TABLESPACE
    ENABLE       STORAGE IN ROW
    CHUNK        8192
    NOCACHE
    INDEX TARGET_RES_SCHEMA_DEF_IDX
    (
      TABLESPACE &LOB_TABLESPACE
    )
  )
TABLESPACE &DATA_TABLESPACE
;

COMMENT ON COLUMN TARGET_RESOURCE_SCHEMA_DEF.DEFINITION IS
'DB2_CLOB_SIZE: 2G';

ALTER TABLE TARGET_RESOURCE_SCHEMA_DEF ADD (
  CONSTRAINT TARGET_RESOURCE_SCHEMA_DEF_PK
 PRIMARY KEY
 (ID)
  USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS);

ALTER TABLE TARGET_RESOURCE_SCHEMA_DEF ADD
  CONSTRAINT TARGET_RES_SCHEMA_DEF_TRSID_FK
 FOREIGN KEY (TR_SCHEMA_ID)
 REFERENCES TARGET_RESOURCE_SCHEMA_DEF (ID)
    ON DELETE CASCADE;

grant select on TARGET_RESOURCE_SCHEMA_DEF to AA;
grant select, insert, update, delete, references on TARGET_RESOURCE_SCHEMA_DEF to IDEAS;
grant select, insert, update, delete, references on TARGET_RESOURCE_SCHEMA_DEF to IDEAS_CONNECTOR;
grant select on TARGET_RESOURCE_SCHEMA_DEF to IDEAS_REPORT;


create sequence TARGET_RESOURCE_SCHEMA_DEF_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER
;

grant select on TARGET_RESOURCE_SCHEMA_DEF_SEQ to AA;
grant select, alter on TARGET_RESOURCE_SCHEMA_DEF_SEQ to IDEAS;
grant select on TARGET_RESOURCE_SCHEMA_DEF_SEQ to IDEAS_CONNECTOR;
grant select on TARGET_RESOURCE_SCHEMA_DEF_SEQ to IDEAS_REPORT;
