--ADD A SPECIFIC FLOW_TYPE TO ALL FLOWs OF A FLOW_EVENT_TYPE
declare
  cur_flow      sys_refcursor;

  im_id         number(16);
  im_name       varchar2(256) := 'AGC';

  fc_id         number(16);
  fc_name       varchar2(256) := 'system';
  
  fet_id        number(16);
  fet_name      varchar2(256) := 'INTERNAL';
  
  ft_id         number(16);
  ft_name       varchar2(256) := 'BEFORE';
  
  fe_id         number(16);
  f_id          number(16);

  counter       number(16);
begin
  select count(1) into counter from ideas_module t where lower ( t.code ) = lower ( im_name );
  if ( counter = 1 ) then
    select t.id into im_id from ideas_module t where lower ( t.code ) = lower ( im_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO IDEAS MODULE FOUND');
  end if;

  select count(1) into counter from flow_context t where lower ( t.name ) = lower ( fc_name );
  if ( counter = 1 ) then
    select t.id into fc_id from flow_context t where lower ( t.name ) = lower ( fc_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW CONTEXT FOUND');
  end if;

  select count(1) into counter from flow_type t where lower ( t.name ) = lower ( ft_name );
  if ( counter = 1 ) then
    select t.id into ft_id from flow_type t where lower ( t.name ) = lower ( ft_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW TYPE FOUND');
  end if;

  select count(1) into counter from flow_event_type t
  where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fet_name );
  if ( counter = 1 ) then
    select t.id into fet_id from flow_event_type t
    where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fet_name );
  end if;
  
  open cur_flow for
    select id from flow t where t.flow_event_type = fet_id and t.ideas_module = im_id
    and not exists ( select 1 from flow_entity tt where t.id = tt.flow and tt.flow_type = ft_id );
  loop
    fetch cur_flow into f_id;
    exit when cur_flow%NOTFOUND;
    select flow_entity_seq.nextval into fe_id from dual;
    
    insert into flow_entity ( id, flow, flow_type, root, parent, flow_entity_type, position, ideas_module)
    values ( fe_id, f_id, ft_id, fe_id, null, 0, 0, im_id );
  end loop;

end;
/
commit;

--------------------------------------------------------------------
