CREATE OR REPLACE TRIGGER TRG_EV_TAR_TO_USER_EVENT_ERC
  AFTER INSERT ON EVENT_TARGET
  FOR EACH ROW
declare
  counter         numeric(16);

  pro_name        varchar(256);
  per_prof_id     numeric(16);
  per_prof_status numeric(16);
begin
  if ( :new.operation not in ( 1, 2, 12 ) ) then
    return;
  end if;

  if ( :new.attr3 is not null ) then
    pro_name := :new.attr3;
  else
    pro_name := :new.functionality;
  end if;

  select count(1) into counter from person_profile t
  where lower ( t.account_code ) = lower ( :new.code ) and lower ( t.permission_code ) = lower ( pro_name )
  and lower ( t.permission_type ) = lower ( :new.functionality_type ) and lower ( t.target ) = lower ( :new.target );
  if ( counter = 1 ) then
    select t.id, t.status into per_prof_id, per_prof_status from person_profile t
    where lower ( t.account_code ) = lower ( :new.code ) and lower ( t.permission_code ) = lower ( pro_name )
    and lower ( t.permission_type ) = lower ( :new.functionality_type ) and lower ( t.target ) = lower ( :new.target );
  elsif ( counter > 1 ) then
    return;
  end if;

  --1)  aggiunta permesso ad utente
  --12) aggiunta permesso utente in caso di rights
  if ( :new.operation in ( 1, 12 ) ) then
    if ( counter = 0 ) then
      insert into person_profile ( id, status, account_code, permission_code, permission_type, target )
      values ( person_profile_seq.nextval, 4, :new.code, pro_name, :new.functionality_type, :new.target );
    elsif ( counter = 1 ) then
      --person profile presente su IGI e aggiunto anche in maniera indipendente sul target
      if ( per_prof_status in ( 1, 2, 3 ) ) then
        update person_profile set status = 2, ext_id = null where id = per_prof_id;
      --person_profile non presente su IGI (perche' rimosso) ma aggiunto sul target
      elsif ( per_prof_status in ( 11, 12, 13 ) ) then
        update person_profile set status = 4, ext_id = null where id = per_prof_id;
      end if;
    end if;
  end if;

  --2) rimozione permesso da utente
  if ( :new.operation = 2 ) then
    if ( counter = 1 ) then
      --non si cancella l'entry solo nel caso in cui sia richiesta un'assegnazione sul target (status=1)
      --poiche' il motore di regole potrebbe notificare l'assegnazione al target, ma non ci sarebbe poi
      --l'entry su person_profile
      if ( per_prof_status in ( 2, 3, 11, 12, 13 ) ) then
        delete from person_profile where id = per_prof_id;
      end if;
    end if;
  end if;

end TRG_EV_TAR_TO_USER_EVENT_ERC;
/
