CREATE OR REPLACE function event_20_align_per_prof_ser_id
return number is
  cur_per_prof_ser sys_refcursor;
  per_prof_ser_id  number(16);
  prof_id          number(16);

  sa_id            number(16);
  sa_name          varchar2(256);

  counter          number(16);
begin
  open cur_per_prof_ser for
    select tt.id, t.profile, tt.name
    from person_profile t, person_profile_service tt
    where t.id = tt.person_profile and tt.service_attribute is null;
  loop
    fetch cur_per_prof_ser into per_prof_ser_id, prof_id, sa_name;
    exit when cur_per_prof_ser%NOTFOUND;

    select count(1) into counter from service_attribute t
    where t.profile = prof_id and lower ( t.name ) = lower ( sa_name );
    if ( counter = 1 ) then
      select t.id into sa_id from service_attribute t
      where t.profile = prof_id and lower ( t.name ) = lower ( sa_name );

      update person_profile_service set service_attribute = sa_id where id = per_prof_ser_id;
    end if;
  end loop;
  close cur_per_prof_ser;

  return 0;
end event_20_align_per_prof_ser_id;
/

GRANT EXECUTE ON event_20_align_per_prof_ser_id TO ideas;
