CREATE OR REPLACE function event_20_align_per_prof_ser_st
return number is
  cur_per_prof_ser sys_refcursor;
  per_prof_ser_id  number(16);

  per_id           number(16);
  pro_id           number(16);
  sa_id            number(16);
  per_prof_ser_val varchar2(256);

  counter          number(16);
begin
  open cur_per_prof_ser for
    select tt.id, t.person, t.profile, tt.service_attribute, tt.value from person_profile t, person_profile_service tt
    where t.id = tt.person_profile and tt.person_profile is not null and tt.service_attribute is not null and tt.status = 4;
  loop
    fetch cur_per_prof_ser into per_prof_ser_id, per_id, pro_id, sa_id, per_prof_ser_val;
    exit when cur_per_prof_ser%NOTFOUND;

    select count(1) into counter from person_service ps, employment e, entitlement_flat_hier efh
    where ps.service_attribute = sa_id and ps.person = per_id and lower ( ps.value ) = lower ( per_prof_ser_val )
    and ps.id = e.person and e.entitlement = efh.parent and efh.child = pro_id;
    if ( counter > 0 ) then
      update person_profile_service set status = 2 where id = per_prof_ser_id;
    end if;
  end loop;
  close cur_per_prof_ser;

  return 0;
end event_20_align_per_prof_ser_st;
/

GRANT EXECUTE ON event_20_align_per_prof_ser_st TO ideas;
