CREATE OR REPLACE function arc_15_pg_eval_attribute
(
  user_id         in number,
  pg_parent_id    in number,
  pg_par_cond     in number,
  pg_profile_id   in number,
  pg_attribute_id in number
)
return boolean is
  CONDITION_OR    constant number(1) := 0;
  CONDITION_AND   constant number(1) := 1;
  cur_pg          sys_refcursor;

  pg_id           number(16);
  pg_type         number(16);
  pg_condition    number(16);
  pg_value        varchar2(256);

  counter         number(16);
begin
  select count(1) into counter from person_service t
  where t.profile = pg_profile_id
  and t.person = user_id
  and t.service_attribute = pg_attribute_id;

  --utente ha il permesso ma non ha l'attribute
  if ( counter = 0 ) then
    return false;
  end if;

  select count(1) into counter from profile_group t
  where t.parent = pg_parent_id;

  --nel profile group, l'attribute non ha value figli
  if ( counter = 0 ) then
    return true;
  end if;

  open cur_pg for
    select t.id, t.type, t.condition, t.value from profile_group t
    where t.parent = pg_parent_id
    order by t.type asc;
  loop
    fetch cur_pg into pg_id, pg_type, pg_condition, pg_value;
    exit when cur_pg%NOTFOUND;

    select count(1) into counter from person_service t
    where t.profile = pg_profile_id
    and t.person = user_id
    and t.service_attribute = pg_attribute_id
    and lower( t.value ) = lower ( pg_value );

    if ( pg_par_cond = CONDITION_OR ) then
      if ( counter > 0 ) then
        return true;
      end if;
    elsif ( pg_par_cond = CONDITION_AND ) then
      if ( counter = 0 ) then
        return false;
      end if;
    else
      --non dovrebbe succedere
      RAISE_APPLICATION_ERROR ( -20050, 'PROFILE GROUP CONDITION NOT VALID');
      return false;
    end if;

  end loop;
  close cur_pg;

  if ( pg_par_cond = CONDITION_OR ) then
    return false;
  elsif ( pg_par_cond = CONDITION_AND ) then
    return true;
  end if;

end arc_15_pg_eval_attribute;
/
