CREATE OR REPLACE function arc_17_pg_eval_group
(
  environment_id in numeric(31),
  domain_id      in numeric(31),
  user_id        in numeric(31),
  pg_parent_id   in numeric(31),
  pg_par_cond    in numeric(31)
)
return boolean is
  CONDITION_OR    constant numeric(1) := 0;
  CONDITION_AND   constant numeric(1) := 1;
  PG_GROUP        constant numeric(2) := 4;
  PG_PERMISSION   constant numeric(2) := 3;

  cur_pg          sys_refcursor;

  pg_id           numeric(16);
  pg_type         numeric(16);
  pg_condition    numeric(1);
  pg_profile_id   numeric(16);

  counter         numeric(16);

  ret_bool        boolean;
  user_id_str     varchar(256);
begin
  select count(1) into counter from profile_group t
  where t.parent = pg_parent_id;

  --nel profile group, il profile group DEVE avere dei figli
  if ( counter > 0 ) then
    open cur_pg for
      select t.id, t.type, t.condition, t.profile from profile_group t
      where t.parent = pg_parent_id
      order by t.type asc;
    loop
      fetch cur_pg into pg_id, pg_type, pg_condition, pg_profile_id;
      exit when cur_pg%NOTFOUND;

      if ( pg_par_cond = CONDITION_OR ) then
        if ( pg_type = PG_PERMISSION ) then
          if ( arc_16_pg_eval_permission ( environment_id, domain_id, user_id, pg_id, pg_condition, pg_profile_id ) = true ) then
            return true;
          end if;
        elsif ( pg_type = PG_GROUP ) then
          /*DB2-BEGIN*/
          /*ret_bool := arc_17_pg_eval_group ( environment_id, domain_id, user_id, pg_id, pg_condition );*/
          user_id_str := cast ( user_id as varchar(256) );
          if ( user_id_str is null or length ( user_id_str ) = 0 ) then
            user_id_str := 'null';
          end if;
          execute immediate 'call '|| current_user ||'.arc_17_pg_eval_group_SP ( :result, '||environment_id||', '||domain_id||', '||user_id_str||', '||pg_id||', '||pg_condition||' )' using out ret_bool;
          /*DB2-END*/
          if ( ret_bool = true ) then
            return true;
          end if;
        end if;
      elsif ( pg_par_cond = CONDITION_AND ) then
        if ( pg_type = PG_PERMISSION ) then
          if ( arc_16_pg_eval_permission ( environment_id, domain_id, user_id, pg_id, pg_condition, pg_profile_id ) = false ) then
            return false;
          end if;
        elsif ( pg_type = PG_GROUP ) then
          /*DB2-BEGIN*/
          /*ret_bool := arc_17_pg_eval_group ( environment_id, domain_id, user_id, pg_id, pg_condition );*/
          user_id_str := cast ( user_id as varchar(256) );
          if ( user_id_str is null or length ( user_id_str ) = 0 ) then
            user_id_str := 'null';
          end if;
          execute immediate 'call '|| current_user ||'.arc_17_pg_eval_group_SP ( :result, '||environment_id||', '||domain_id||', '||user_id_str||', '||pg_id||', '||pg_condition||' )' using out ret_bool;
          /*DB2-END*/
          if ( ret_bool = false ) then
            return false;
          end if;
        end if;
      else
        --non dovrebbe succedere
        RAISE_APPLICATION_ERROR ( -20050, 'PROFILE GROUP CONDITION NOT VALID');
        return false;
      end if;

    end loop;
    close cur_pg;
  end if;

  if ( pg_par_cond = CONDITION_OR ) then
    return false;
  elsif ( pg_par_cond = CONDITION_AND ) then
    return true;
  end if;

end arc_17_pg_eval_group;
/
