CREATE OR REPLACE function arc_40_pg_up_proj
(
  group_id in number,
  group_cond in number,
  dest_root_id in number,
  dest_parent_id in number
)
return sys_refcursor is
  cur_return             sys_refcursor;

  entitlement_parent_cur sys_refcursor;
  cur_child              sys_refcursor;
  ent_id                 number(16);
  ent_type               number(1);
  ent_cond               number(1);
  prof_id                number(16);
  pg_new_id              number(16);
  pg_new_cond            number(1);

  pg_prof_id             number(16);
  entitlement_id         number(16);
  counter                number(16);

  PG_GROUP_TYPE          constant number(1) := 4;
  PG_PROFILE_TYPE        constant number(1) := 3;

  NUMERIC_OR             constant number(1) := 0;
  NUMERIC_AND            constant number(1) := 1;

  NUMERIC_FALSE          constant number(1) := 0;
begin
  open cur_child for
    select t.id, t.type, t.condition, t.profile
    from profile_group t where t.parent = group_id;
  loop
    fetch cur_child into ent_id, ent_type, ent_cond, prof_id;
    exit when cur_child%NOTFOUND;

    pg_new_id   := dest_parent_id;
    pg_new_cond := ent_cond;

    --gestione gruppo
    if ( ent_type = PG_GROUP_TYPE ) then
      if ( ent_cond = NUMERIC_AND ) then
        if ( group_cond = NUMERIC_OR ) then
          select profile_group_seq.nextval into pg_new_id from dual;
          pg_new_cond := NUMERIC_AND;

          insert into profile_group ( id, name, root, parent, type, condition )
          values ( pg_new_id, pg_new_id, dest_root_id, dest_parent_id, PG_GROUP_TYPE, pg_new_cond );
        end if;
      elsif ( ent_cond = NUMERIC_OR ) then
        if ( group_cond = NUMERIC_AND ) then
          select profile_group_seq.nextval into pg_new_id from dual;
          pg_new_cond := NUMERIC_OR;

          insert into profile_group ( id, name, root, parent, type, condition )
          values ( pg_new_id, pg_new_id, dest_root_id, dest_parent_id, PG_GROUP_TYPE, pg_new_cond );
        end if;
     end if;
     /*DB2-BEGIN*/
     cur_return := arc_40_pg_up_proj ( ent_id, ent_cond, dest_root_id, pg_new_id );
     /*execute immediate 'call '|| current_user ||'.arc_40_pg_up_proj_SP ( :result, '||ent_id||', '||ent_cond||', '||dest_root_id||', '||pg_new_id||' )' using out cur_return;*/
     /*DB2-END*/
     close cur_return;

    elsif ( ent_type = PG_PROFILE_TYPE ) then
    --gestione permesso
      if ( group_cond = NUMERIC_AND ) then
        select profile_group_seq.nextval into pg_new_id from dual;

        insert into profile_group ( id, name, root, parent, type, condition )
        values ( pg_new_id, pg_new_id, dest_root_id, dest_parent_id, PG_GROUP_TYPE, NUMERIC_OR );
      end if;

      entitlement_parent_cur := ent_20_ent_parents ( prof_id, NUMERIC_FALSE );
      loop
        fetch entitlement_parent_cur into entitlement_id;
        exit when entitlement_parent_cur%NOTFOUND;

        select count(1) into counter from profile_group t
        where t.root = dest_root_id and t.parent = dest_parent_id
        and t.profile = entitlement_id;

        if ( entitlement_id <> prof_id and counter = 0 ) then
          select profile_group_seq.nextval into pg_prof_id from dual;

          insert into profile_group ( id, name, root, parent, type, condition, profile )
          values ( pg_prof_id, pg_prof_id, dest_root_id, pg_new_id, PG_PROFILE_TYPE, NUMERIC_OR, entitlement_id );
        end if;
      end loop;
      close entitlement_parent_cur;
    end if;

  end loop;
  close cur_child;

  open cur_return for select 1 as COUNTER from dual;
  return cur_return;
end arc_40_pg_up_proj;
/
