CREATE OR REPLACE function arc_17_pg_eval_group_task
(
  entity_id      in numeric(31),
  pg_parent_id   in numeric(31),
  pg_par_cond    in numeric(31),
  entity_type    in numeric(31)
)
return boolean is
  CONDITION_OR    constant numeric(1) := 0;
  CONDITION_AND   constant numeric(1) := 1;
  PG_GROUP        constant numeric(2) := 4;
  PG_PERMISSION   constant numeric(2) := 3;

  cur_pg          sys_refcursor;

  pg_id           numeric(16);
  pg_type         numeric(16);
  pg_condition    numeric(1);
  pg_profile_id   numeric(16);

  counter         numeric(16);

  ret_bool        boolean;
begin
  select count(1) into counter from profile_group t
  where t.parent = pg_parent_id;

  --nel profile group, il profile group DEVE avere dei figli
  if ( counter > 0 ) then
    open cur_pg for
      select t.id, t.type, t.condition, t.profile from profile_group t
      where t.parent = pg_parent_id
      order by t.type asc;
    loop
      fetch cur_pg into pg_id, pg_type, pg_condition, pg_profile_id;
      exit when cur_pg%NOTFOUND;

      if ( pg_par_cond = CONDITION_OR ) then
        if ( pg_type = PG_PERMISSION ) then
          if ( arc_16_pg_eval_permission_task ( entity_id, pg_id, pg_condition, pg_profile_id, entity_type ) = true ) then
            return true;
          end if;
        elsif ( pg_type = PG_GROUP ) then
          /*DB2-BEGIN*/
          /*ret_bool := arc_17_pg_eval_group_task ( entity_id, pg_id, pg_condition, entity_type );*/
          execute immediate 'call '|| current_user ||'.arc_17_pg_eval_group_task_SP ( :result, '||entity_id||', '||pg_id||', '||pg_condition||', '||entity_type||' )' using out ret_bool;
          /*DB2-END*/
          if ( ret_bool = true ) then
            return true;
          end if;
        end if;
      elsif ( pg_par_cond = CONDITION_AND ) then
        if ( pg_type = PG_PERMISSION ) then
          if ( arc_16_pg_eval_permission_task ( entity_id, pg_id, pg_condition, pg_profile_id, entity_type ) = false ) then
            return false;
          end if;
        elsif ( pg_type = PG_GROUP ) then
          /*DB2-BEGIN*/
          /*ret_bool := arc_17_pg_eval_group_task ( entity_id, pg_id, pg_condition, entity_type );*/
          execute immediate 'call '|| current_user ||'.arc_17_pg_eval_group_task_SP ( :result, '||entity_id||', '||pg_id||', '||pg_condition||', '||entity_type||' )' using out ret_bool;
          /*DB2-END*/
          if ( ret_bool = false ) then
            return false;
          end if;
        end if;
      else
        --non dovrebbe succedere
        RAISE_APPLICATION_ERROR ( -20050, 'PROFILE GROUP CONDITION NOT VALID');
        return false;
      end if;

    end loop;
    close cur_pg;
  end if;

  if ( pg_par_cond = CONDITION_OR ) then
    return false;
  elsif ( pg_par_cond = CONDITION_AND ) then
    return true;
  end if;

end arc_17_pg_eval_group_task;
/

GRANT EXECUTE ON FUNCTION "ARC_17_PG_EVAL_GROUP_TASK" TO &IDEAS_SUPER_ADMIN_USER;


CREATE OR REPLACE PROCEDURE arc_17_pg_eval_group_task_sp
(
  counter out boolean,
  entity_id      in numeric(31),
  pg_parent_id   in numeric(31),
  pg_par_cond    in numeric(31),
  entity_type    in numeric(31)

)
AS
begin
  counter := arc_17_pg_eval_group_task ( entity_id, pg_parent_id, pg_par_cond, entity_type );
end arc_17_pg_eval_group_task_sp;
/

GRANT EXECUTE ON PROCEDURE "ARC_17_PG_EVAL_GROUP_TASK_SP" TO &IDEAS_SUPER_ADMIN_USER;
