CREATE OR REPLACE function arc_21_init_app
(
  app_id in numeric(31),
  environment_id in numeric(31)
)
return sys_refcursor is
/*
Dato un'unita organizzativa valorizziamo la tabella temporanea TMP_RPD2_JOIN
Viene restituita una lista di DOMINI
*/
  ASSIGNMENT_DIRECT constant numeric(1) := 1;
  SKIP_APP          numeric(1)    := 0;
  t_domain_cur      sys_refcursor;
  cur_app_ent       sys_refcursor;
  ent_id            numeric(16);
  v_return          numeric(16);
begin
  delete from tmp_rpd2_join;

  open cur_app_ent for
    select ent.id from application app, entitlement ent
    where app.id = ent.application and app.id = app_id
    and ent.int_type in ( 1, -1 )
    and app.enable_sod = SKIP_APP;
  loop
    fetch cur_app_ent into ent_id;
    exit when cur_app_ent%NOTFOUND;

    v_return := arc_01_set_tmp_join_by_ent ( ent_id, environment_id, ASSIGNMENT_DIRECT );

  end loop;
  close cur_app_ent;

  t_domain_cur := arc_19_calc_pg ( environment_id, null );
  return t_domain_cur;
end arc_21_init_app;
/

GRANT EXECUTE ON FUNCTION "ARC_21_INIT_APP" TO &IDEAS_SUPER_ADMIN_USER;


CREATE OR REPLACE PROCEDURE arc_21_init_app_sp
(
  counter out sys_refcursor,
  app_id in numeric(31),
  environment_id in numeric(31)

)
AS
begin
  counter := arc_21_init_app ( app_id, environment_id );
end arc_21_init_app_sp;
/

GRANT EXECUTE ON PROCEDURE "ARC_21_INIT_APP_SP" TO &IDEAS_SUPER_ADMIN_USER;
