create or replace function arc_21_init_pwd
(
  tar_id in number,
  environment_id in number
)
return sys_refcursor is
/*
Dato un'unita organizzativa valorizziamo la tabella temporanea TMP_RPD2_JOIN
Viene restituita una lista di DOMINI
*/
  ASSIGNMENT_DIRECT constant number(1) := 1;
  SKIP_APP          number(1)    := 0;
  t_domain_cur      sys_refcursor;
  cur_tar_ent       sys_refcursor;
  ent_id            number(16);
  v_return          number(16);
begin
  delete from tmp_rpd2_join;

  open cur_tar_ent for
    select ent.id from target t, application app, entitlement ent
    where t.id = app.target and app.id = ent.application and t.id = tar_id
    and ent.int_type in ( 1, -1 )
    and app.enable_sod = SKIP_APP;
  loop
    fetch cur_tar_ent into ent_id;
    exit when cur_tar_ent%NOTFOUND;

    v_return := arc_01_set_tmp_join_by_ent ( ent_id, environment_id, ASSIGNMENT_DIRECT );

  end loop;
  close cur_tar_ent;

  t_domain_cur := arc_19_calc_pg ( environment_id, null );
  return t_domain_cur;
end arc_21_init_pwd;
/

GRANT EXECUTE ON arc_21_init_pwd TO ideas;
