create table TASK_ENTITLEMENT
(
  ENVIRONMENT   NUMERIC(16) not null,
  TASK          NUMERIC(16) not null,
  ENTITLEMENT   NUMERIC(16) not null,
  LAST_MOD_TIME TIMESTAMP(6) default CURRENT_TIMESTAMP,
  COMP_TIME     NUMERIC(16) default 0
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE TASK_ENTITLEMENT ADD
  CONSTRAINT TASK_ENTITLEMENT_PK
 PRIMARY KEY (ENVIRONMENT, TASK, ENTITLEMENT);

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE TASK_ENTITLEMENT' );

alter table TASK_ENTITLEMENT
  add constraint TASK_ENTITLEMENT_TASK_FK foreign key (ENVIRONMENT, TASK)
  references TASK (ENVIRONMENT, ID) on delete cascade;
alter table TASK_ENTITLEMENT
  add constraint TASK_ENTITLEMENT_ENTITL_FK foreign key (ENTITLEMENT)
  references ENTITLEMENT (ID) on delete cascade;

grant select on TASK_ENTITLEMENT to &AA_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on TASK_ENTITLEMENT to &IDEAS_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on TASK_ENTITLEMENT to &IDEAS_CONN_SUPER_ADMIN_USER;
grant select on TASK_ENTITLEMENT to &IDEAS_REPORT_SUPER_ADMIN_USER;

