create table TASK_ENTITLEMENT
(
  ENVIRONMENT   NUMBER(16) not null,
  TASK          NUMBER(16) not null,
  ENTITLEMENT   NUMBER(16) not null,
  LAST_MOD_TIME TIMESTAMP(6) default systimestamp,
  COMP_TIME     NUMBER(16) default 0
)
tablespace &DATA_TABLESPACE
;

alter table TASK_ENTITLEMENT
  add constraint TASK_ENTITLEMENT_PK primary key (ENVIRONMENT, TASK, ENTITLEMENT)
  using index 
  tablespace &INDEX_TABLESPACE compute statistics;
alter table TASK_ENTITLEMENT
  add constraint TASK_ENTITLEMENT_TASK_FK foreign key (ENVIRONMENT, TASK)
  references TASK (ENVIRONMENT, ID) on delete cascade;
alter table TASK_ENTITLEMENT
  add constraint TASK_ENTITLEMENT_ENTITL_FK foreign key (ENTITLEMENT)
  references ENTITLEMENT (ID) on delete cascade;

grant select on TASK_ENTITLEMENT to AA;
grant select, insert, update, delete, references on TASK_ENTITLEMENT to IDEAS;
grant select, insert, update, delete, references on TASK_ENTITLEMENT to IDEAS_CONNECTOR;
grant select on TASK_ENTITLEMENT to IDEAS_REPORT;
