--CREATE A TABLE AND ITS CONSTRAINTS
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'TASK_ENTITLEMENT';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from sysibm.tables t where ( t.table_type = 'BASE TABLE' or t.table_type is null ) and lower ( t.table_schema ) = lower ( curr_user ) and t.table_name = tab_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'create table TASK_ENTITLEMENT
(
  ENVIRONMENT   NUMERIC(16) not null,
  TASK          NUMERIC(16) not null,
  ENTITLEMENT   NUMERIC(16) not null,
  LAST_MOD_TIME TIMESTAMP(6) default CURRENT_TIMESTAMP,
  COMP_TIME     NUMERIC(16) default 0
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'ALTER TABLE TASK_ENTITLEMENT ADD
  CONSTRAINT TASK_ENTITLEMENT_PK
 PRIMARY KEY (ENVIRONMENT, TASK, ENTITLEMENT)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table TASK_ENTITLEMENT
  add constraint TASK_ENTITLEMENT_TASK_FK foreign key (ENVIRONMENT, TASK)
  references TASK (ENVIRONMENT, ID) on delete cascade
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table TASK_ENTITLEMENT
  add constraint TASK_ENTITLEMENT_ENTITL_FK foreign key (ENTITLEMENT)
  references ENTITLEMENT (ID) on delete cascade
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
commit;
set serveroutput off
set verify on


--REORGANIZE A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'TASK_ENTITLEMENT';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from sysibm.tables t where ( t.table_type = 'BASE TABLE' or t.table_type is null ) and lower ( t.table_schema ) = lower ( curr_user ) and t.table_name = tab_name;
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'CALL SYSPROC.ADMIN_CMD( ''REORG TABLE TASK_ENTITLEMENT'' )
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
commit;
set serveroutput off
set verify on

grant select on TASK_ENTITLEMENT to &AA_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on TASK_ENTITLEMENT to &IDEAS_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on TASK_ENTITLEMENT to &IDEAS_CONN_SUPER_ADMIN_USER;
grant select on TASK_ENTITLEMENT to &IDEAS_REPORT_SUPER_ADMIN_USER;

