create table TASK_GROUP
(
  ENVIRONMENT         NUMERIC(16) not null,
  TASK                NUMERIC(16) not null,
  HIERARCHY           NUMERIC(16) not null,
  ORGANIZATIONAL_UNIT NUMERIC(16) not null,
  LAST_MOD_TIME       TIMESTAMP(6) default CURRENT_TIMESTAMP,
  COMP_TIME           NUMERIC(16) default 0
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE TASK_GROUP ADD
  CONSTRAINT TASK_GROUP_PK
 PRIMARY KEY (ENVIRONMENT, TASK, ORGANIZATIONAL_UNIT);

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE TASK_GROUP' );

alter table TASK_GROUP
  add constraint TASK_GROUP_TASK_FK foreign key (ENVIRONMENT, TASK)
  references TASK (ENVIRONMENT, ID) on delete cascade;
alter table TASK_GROUP
  add constraint TASK_GROUP_ORG_UNIT_FK foreign key (ORGANIZATIONAL_UNIT)
  references ORGANIZATIONAL_UNIT (ID) on delete cascade;

grant select on TASK_GROUP to &AA_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on TASK_GROUP to &IDEAS_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on TASK_GROUP to &IDEAS_CONN_SUPER_ADMIN_USER;
grant select on TASK_GROUP to &IDEAS_REPORT_SUPER_ADMIN_USER;

