create table TASK_GROUP
(
  ENVIRONMENT         NUMBER(16) not null,
  TASK                NUMBER(16) not null,
  HIERARCHY           NUMBER(16) not null,
  ORGANIZATIONAL_UNIT NUMBER(16) not null,
  LAST_MOD_TIME       TIMESTAMP(6) default systimestamp,
  COMP_TIME           NUMBER(16) default 0
)
tablespace &DATA_TABLESPACE
;

alter table TASK_GROUP
  add constraint TASK_GROUP_PK primary key (ENVIRONMENT, TASK, ORGANIZATIONAL_UNIT)
  using index 
  tablespace &INDEX_TABLESPACE compute statistics;
alter table TASK_GROUP
  add constraint TASK_GROUP_TASK_FK foreign key (ENVIRONMENT, TASK)
  references TASK (ENVIRONMENT, ID) on delete cascade;
alter table TASK_GROUP
  add constraint TASK_GROUP_ORG_UNIT_FK foreign key (ORGANIZATIONAL_UNIT)
  references ORGANIZATIONAL_UNIT (ID) on delete cascade;

grant select on TASK_GROUP to AA;
grant select, insert, update, delete, references on TASK_GROUP to IDEAS;
grant select, insert, update, delete, references on TASK_GROUP to IDEAS_CONNECTOR;
grant select on TASK_GROUP to IDEAS_REPORT;
