--CREATE A TABLE AND ITS CONSTRAINTS
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'TASK_GROUP';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tables t where t.owner = curr_user and t.table_name = tab_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'create table TASK_GROUP
(
  ENVIRONMENT         NUMBER(16) not null,
  TASK                NUMBER(16) not null,
  HIERARCHY           NUMBER(16) not null,
  ORGANIZATIONAL_UNIT NUMBER(16) not null,
  LAST_MOD_TIME       TIMESTAMP(6) default systimestamp,
  COMP_TIME           NUMBER(16) default 0
)
tablespace &DATA_TABLESPACE
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table TASK_GROUP
  add constraint TASK_GROUP_PK primary key (ENVIRONMENT, TASK, ORGANIZATIONAL_UNIT)
  using index 
  tablespace &INDEX_TABLESPACE compute statistics
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table TASK_GROUP
  add constraint TASK_GROUP_TASK_FK foreign key (ENVIRONMENT, TASK)
  references TASK (ENVIRONMENT, ID) on delete cascade
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table TASK_GROUP
  add constraint TASK_GROUP_ORG_UNIT_FK foreign key (ORGANIZATIONAL_UNIT)
  references ORGANIZATIONAL_UNIT (ID) on delete cascade
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

grant select on TASK_GROUP to AA;
grant select, insert, update, delete, references on TASK_GROUP to IDEAS;
grant select, insert, update, delete, references on TASK_GROUP to IDEAS_CONNECTOR;
grant select on TASK_GROUP to IDEAS_REPORT;
