create table ORGANIZATIONAL_UNIT_INCOMP
(
  ENVIRONMENT         NUMERIC(16) not null,
  HIERARCHY           NUMERIC(16) not null,
  ORGANIZATIONAL_UNIT NUMERIC(16) not null,
  HIGH                NUMERIC(16) default 0,
  MEDIUM              NUMERIC(16) default 0,
  LOW                 NUMERIC(16) default 0,
  LAST_MOD_TIME       TIMESTAMP(6) default CURRENT_TIMESTAMP,
  COMP_TIME           NUMERIC(16) default 0
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE ORGANIZATIONAL_UNIT_INCOMP ADD
  CONSTRAINT ORGANIZATIONAL_UNIT_INCOMP_PK
 PRIMARY KEY (ENVIRONMENT, HIERARCHY, ORGANIZATIONAL_UNIT);
CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE ORGANIZATIONAL_UNIT_INCOMP' );

alter table ORGANIZATIONAL_UNIT_INCOMP
  add constraint OU_INCOMP_ENVIRONMENT_FK foreign key (ENVIRONMENT)
  references ENVIRONMENT (ID) on delete cascade;
alter table ORGANIZATIONAL_UNIT_INCOMP
  add constraint OU_INCOMP_HIERARCHY_FK foreign key (HIERARCHY)
  references HIERARCHY (ID) on delete cascade;
alter table ORGANIZATIONAL_UNIT_INCOMP
  add constraint OU_INCOMP_ORG_UNIT_FK foreign key (ORGANIZATIONAL_UNIT)
  references ORGANIZATIONAL_UNIT (ID) on delete cascade;

grant select on ORGANIZATIONAL_UNIT_INCOMP to &AA_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on ORGANIZATIONAL_UNIT_INCOMP to &IDEAS_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on ORGANIZATIONAL_UNIT_INCOMP to &IDEAS_CONN_SUPER_ADMIN_USER;
grant select on ORGANIZATIONAL_UNIT_INCOMP to &IDEAS_REPORT_SUPER_ADMIN_USER;

