--CREATE A TABLE AND ITS CONSTRAINTS
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'ORGANIZATIONAL_UNIT_INCOMP';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from sysibm.tables t where ( t.table_type = 'BASE TABLE' or t.table_type is null ) and lower ( t.table_schema ) = lower ( curr_user ) and t.table_name = tab_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'create table ORGANIZATIONAL_UNIT_INCOMP
(
  ENVIRONMENT         NUMERIC(16) not null,
  HIERARCHY           NUMERIC(16) not null,
  ORGANIZATIONAL_UNIT NUMERIC(16) not null,
  HIGH                NUMERIC(16) default 0,
  MEDIUM              NUMERIC(16) default 0,
  LOW                 NUMERIC(16) default 0,
  LAST_MOD_TIME       TIMESTAMP(6) default CURRENT_TIMESTAMP,
  COMP_TIME           NUMERIC(16) default 0
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'ALTER TABLE ORGANIZATIONAL_UNIT_INCOMP ADD
  CONSTRAINT ORGANIZATIONAL_UNIT_INCOMP_PK
 PRIMARY KEY (ENVIRONMENT, HIERARCHY, ORGANIZATIONAL_UNIT)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table ORGANIZATIONAL_UNIT_INCOMP
  add constraint OU_INCOMP_ENVIRONMENT_FK foreign key (ENVIRONMENT)
  references ENVIRONMENT (ID) on delete cascade
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table ORGANIZATIONAL_UNIT_INCOMP
  add constraint OU_INCOMP_HIERARCHY_FK foreign key (HIERARCHY)
  references HIERARCHY (ID) on delete cascade
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table ORGANIZATIONAL_UNIT_INCOMP
  add constraint OU_INCOMP_ORG_UNIT_FK foreign key (ORGANIZATIONAL_UNIT)
  references ORGANIZATIONAL_UNIT (ID) on delete cascade
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
commit;
set serveroutput off
set verify on


--REORGANIZE A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'ORGANIZATIONAL_UNIT_INCOMP';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from sysibm.tables t where ( t.table_type = 'BASE TABLE' or t.table_type is null ) and lower ( t.table_schema ) = lower ( curr_user ) and t.table_name = tab_name;
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'CALL SYSPROC.ADMIN_CMD( ''REORG TABLE ORGANIZATIONAL_UNIT_INCOMP'' )
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
commit;
set serveroutput off
set verify on


grant select on ORGANIZATIONAL_UNIT_INCOMP to &AA_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on ORGANIZATIONAL_UNIT_INCOMP to &IDEAS_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on ORGANIZATIONAL_UNIT_INCOMP to &IDEAS_CONN_SUPER_ADMIN_USER;
grant select on ORGANIZATIONAL_UNIT_INCOMP to &IDEAS_REPORT_SUPER_ADMIN_USER;

