--CREATE A TABLE AND ITS CONSTRAINTS
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'ORGANIZATIONAL_UNIT_INCOMP';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tables t where t.owner = curr_user and t.table_name = tab_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'create table ORGANIZATIONAL_UNIT_INCOMP
(
  ENVIRONMENT         NUMBER(16) not null,
  HIERARCHY           NUMBER(16) not null,
  ORGANIZATIONAL_UNIT NUMBER(16) not null,
  HIGH                NUMBER(16) default 0,
  MEDIUM              NUMBER(16) default 0,
  LOW                 NUMBER(16) default 0,
  LAST_MOD_TIME       TIMESTAMP(6) default systimestamp,
  COMP_TIME           NUMBER(16) default 0
)
tablespace &DATA_TABLESPACE
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table ORGANIZATIONAL_UNIT_INCOMP
  add constraint ORGANIZATIONAL_UNIT_INCOMP_PK primary key (ENVIRONMENT, HIERARCHY, ORGANIZATIONAL_UNIT)
  using index 
  tablespace &INDEX_TABLESPACE compute statistics
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table ORGANIZATIONAL_UNIT_INCOMP
  add constraint OU_INCOMP_ENVIRONMENT_FK foreign key (ENVIRONMENT)
  references ENVIRONMENT (ID) on delete cascade
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table ORGANIZATIONAL_UNIT_INCOMP
  add constraint OU_INCOMP_HIERARCHY_FK foreign key (HIERARCHY)
  references HIERARCHY (ID) on delete cascade
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table ORGANIZATIONAL_UNIT_INCOMP
  add constraint OU_INCOMP_ORG_UNIT_FK foreign key (ORGANIZATIONAL_UNIT)
  references ORGANIZATIONAL_UNIT (ID) on delete cascade
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

grant select on ORGANIZATIONAL_UNIT_INCOMP to AA;
grant select, insert, update, delete, references on ORGANIZATIONAL_UNIT_INCOMP to IDEAS;
grant select, insert, update, delete, references on ORGANIZATIONAL_UNIT_INCOMP to IDEAS_CONNECTOR;
grant select on ORGANIZATIONAL_UNIT_INCOMP to IDEAS_REPORT;
