CREATE OR REPLACE function arc_31_align_ou_incomp
(
  environment_id in numeric(31),
  mod_time in timestamp := current_timestamp
)
return sys_refcursor is
 /*    Procedura per allineamento tabella ORGANIZATIONAL_UNIT_INCOMP*/
  t_ent_incomp_cur sys_refcursor;
begin
  insert into organizational_unit_incomp (environment, hierarchy, organizational_unit, last_mod_time)
    select environment_id, t.hierarchy, t.id, mod_time from organizational_unit t where not exists
    (select 1 from organizational_unit_incomp i where t.id = i.organizational_unit and i.environment = environment_id);

  open t_ent_incomp_cur for select t.organizational_unit as ORGANIZATIONAL_UNIT_INCOMP_ID from organizational_unit_incomp t where t.environment = environment_id;

  return t_ent_incomp_cur;
end arc_31_align_ou_incomp;
/

GRANT EXECUTE ON FUNCTION "ARC_31_ALIGN_OU_INCOMP" TO &IDEAS_SUPER_ADMIN_USER;

CREATE OR REPLACE PROCEDURE arc_31_align_ou_incomp_sp
(
  counter out sys_refcursor,
  environment_id in numeric(31),
  mod_time in timestamp 

)
AS
begin
  counter := arc_31_align_ou_incomp ( environment_id, mod_time );
end arc_31_align_ou_incomp_sp;
/

GRANT EXECUTE ON PROCEDURE "ARC_31_ALIGN_OU_INCOMP_SP" TO &IDEAS_SUPER_ADMIN_USER;
