create or replace view TASK_ALL_ENTITLEMENT_HIER as
with task_profile_working as
(
  select env.id as environment, tp.task, ent.id as profile, case when ent.int_type = 0 then 0 else 1 end as direct_assignment
  from environment env, task_profile tp, entitlement ent
  where env.id = tp.environment and tp.profile = ent.id
  and env.working = 1
),
task_profile_group_working as
(
  select pgr.environment, pgr.task, pg.profile, pgr.direct_assignment
  from profile_group pg,
  (
    select tp.environment, tp.task, pg.id, tp.direct_assignment
    from profile_group pg, task_profile_working tp
    where pg.profile = tp.profile and tp.direct_assignment = 0
    and pg.type = 5
  ) pgr
  where pgr.id = pg.root and pg.type = 3
),
task_profile_all_working as
(
  select t.environment, t.task, t.profile, t.direct_assignment from task_profile_working t where t.direct_assignment = 1
  union
  select t.environment, t.task, t.profile, t.direct_assignment from task_profile_group_working t
)
select
  tfh.environment,
  tfh.parent as task_parent,
  tfh.child as task_child,
  efh.parent as entitlement_parent,
  efh.child as entitlement_child,
  tp.direct_assignment
from
  task_flat_hier tfh,
  task_profile_all_working tp,
  entitlement_flat_hier efh,
  entitlement e
where
  tfh.child = tp.task
  and tfh.environment = tp.environment
  and tp.profile = efh.child
  and efh.parent = e.id
  and e.authorized = 1
;

grant select on TASK_ALL_ENTITLEMENT_HIER to AA;
grant select on TASK_ALL_ENTITLEMENT_HIER to IDEAS;
grant select on TASK_ALL_ENTITLEMENT_HIER to IDEAS_CONNECTOR;
grant select on TASK_ALL_ENTITLEMENT_HIER to IDEAS_REPORT;
