create table REQUEST_NOTIFICATION
(
  request         number(16) not null,
  pa_notification number(16) not null,
  pa_working      number(16) not null,
  attr1           varchar2(256 CHAR),
  attr2           varchar2(256 CHAR),
  attr3           varchar2(256 CHAR),
  attr4           varchar2(256 CHAR),
  attr5           varchar2(256 CHAR),
  creation_user   varchar2(128 CHAR),
  creation_date   date default SYSDATE,
  last_mod_user   varchar2(128 CHAR),
  last_mod_time   date default SYSDATE
)
tablespace &DATA_TABLESPACE;

alter table REQUEST_NOTIFICATION
  add constraint REQUEST_NOTIFICATION_PK primary key (REQUEST)
  using index 
  tablespace &INDEX_TABLESPACE compute statistics;

alter table REQUEST_NOTIFICATION
  add constraint REQUEST_NOTIFICATION_REQ_FK foreign key (REQUEST)
  references request (ID) on delete cascade;
alter table REQUEST_NOTIFICATION
  add constraint REQUEST_NOTIFICATION_PA_N_FK foreign key (PA_NOTIFICATION)
  references cfg_processactivity (ID) on delete cascade;
alter table REQUEST_NOTIFICATION
  add constraint REQUEST_NOTIFICATION_PA_W_FK foreign key (PA_WORKING)
  references cfg_processactivity (ID) on delete cascade;

grant select on REQUEST_NOTIFICATION to AA;
grant select, insert, update, delete, references on REQUEST_NOTIFICATION to IDEAS;
grant select, insert, update, delete, references on REQUEST_NOTIFICATION to IDEAS_CONNECTOR;
grant select on REQUEST_NOTIFICATION to IDEAS_REPORT;
