create table REQUEST_NOTIFICATION
(
  request         numeric(16) not null,
  pa_notification numeric(16) not null,
  pa_working      numeric(16) not null,
  attr1           varchar(256),
  attr2           varchar(256),
  attr3           varchar(256),
  attr4           varchar(256),
  attr5           varchar(256),
  creation_user   varchar(128),
  creation_date   date default CURRENT_DATE,
  last_mod_user   varchar(128),
  last_mod_time   date default CURRENT_DATE
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE REQUEST_NOTIFICATION ADD
  CONSTRAINT REQUEST_NOTIFICATION_PK 
 PRIMARY KEY (REQUEST);

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE REQUEST_NOTIFICATION' );

alter table REQUEST_NOTIFICATION
  add constraint REQUEST_NOTIFICATION_REQ_FK foreign key (REQUEST)
  references request (ID) on delete cascade;
alter table REQUEST_NOTIFICATION
  add constraint REQUEST_NOTIFICATION_PA_N_FK foreign key (PA_NOTIFICATION)
  references cfg_processactivity (ID) on delete cascade;
alter table REQUEST_NOTIFICATION
  add constraint REQUEST_NOTIFICATION_PA_W_FK foreign key (PA_WORKING)
  references cfg_processactivity (ID) on delete cascade;

grant select on REQUEST_NOTIFICATION to &AA_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on REQUEST_NOTIFICATION to &IDEAS_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on REQUEST_NOTIFICATION to &IDEAS_CONN_SUPER_ADMIN_USER;
grant select on REQUEST_NOTIFICATION to &IDEAS_REPORT_SUPER_ADMIN_USER;

