--CREATE A TABLE AND ITS CONSTRAINTS
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'REQUEST_NOTIFICATION';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from sysibm.tables t where ( t.table_type = 'BASE TABLE' or t.table_type is null ) and lower ( t.table_schema ) = lower ( curr_user ) and t.table_name = tab_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'create table REQUEST_NOTIFICATION
(
  request         numeric(16) not null,
  pa_notification numeric(16) not null,
  pa_working      numeric(16) not null,
  attr1           varchar(256),
  attr2           varchar(256),
  attr3           varchar(256),
  attr4           varchar(256),
  attr5           varchar(256),
  creation_user   varchar(128),
  creation_date   date default CURRENT_DATE,
  last_mod_user   varchar(128),
  last_mod_time   date default CURRENT_DATE
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'ALTER TABLE REQUEST_NOTIFICATION ADD
  CONSTRAINT REQUEST_NOTIFICATION_PK 
 PRIMARY KEY (REQUEST)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table REQUEST_NOTIFICATION
  add constraint REQUEST_NOTIFICATION_REQ_FK foreign key (REQUEST)
  references request (ID) on delete cascade
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table REQUEST_NOTIFICATION
  add constraint REQUEST_NOTIFICATION_PA_N_FK foreign key (PA_NOTIFICATION)
  references cfg_processactivity (ID) on delete cascade
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table REQUEST_NOTIFICATION
  add constraint REQUEST_NOTIFICATION_PA_W_FK foreign key (PA_WORKING)
  references cfg_processactivity (ID) on delete cascade
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
commit;
set serveroutput off
set verify on


--REORGANIZE A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'REQUEST_NOTIFICATION';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from sysibm.tables t where ( t.table_type = 'BASE TABLE' or t.table_type is null ) and lower ( t.table_schema ) = lower ( curr_user ) and t.table_name = tab_name;
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'CALL SYSPROC.ADMIN_CMD( ''REORG TABLE REQUEST_NOTIFICATION'' )
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
commit;
set serveroutput off
set verify on

grant select on REQUEST_NOTIFICATION to &AA_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on REQUEST_NOTIFICATION to &IDEAS_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on REQUEST_NOTIFICATION to &IDEAS_CONN_SUPER_ADMIN_USER;
grant select on REQUEST_NOTIFICATION to &IDEAS_REPORT_SUPER_ADMIN_USER;

