create table CFG_NOTIFICATION
(
  ID                NUMBER(16) not null,
  EMS_TEMPLATE      NUMBER(16) not null,
  REQUESTED_FOR     NUMBER(1),
  REQUESTED_BY      NUMBER(1),
  APPROVERS         NUMBER(1),
  FIXED_NOTIFY      NUMBER(1),
  FIXED_NOTIFY_LIST VARCHAR2(2048 CHAR),
  ATTR1             VARCHAR2(256 CHAR),
  ATTR2             VARCHAR2(256 CHAR),
  ATTR3             VARCHAR2(256 CHAR),
  ATTR4             VARCHAR2(256 CHAR),
  ATTR5             VARCHAR2(256 CHAR),
  CREATION_DATE     DATE default SYSDATE,
  CREATION_USER     VARCHAR2(128 CHAR),
  LAST_MOD_USER     VARCHAR2(128 CHAR),
  LAST_MOD_TIME     DATE default SYSDATE
)
tablespace &DATA_TABLESPACE
;

alter table CFG_NOTIFICATION
  add constraint CFG_NOTIFICATION_PK primary key (ID)
  using index 
  tablespace &INDEX_TABLESPACE compute statistics;

alter table CFG_NOTIFICATION
  add constraint CFG_NOTIF_EMS_TEMPLATE_FK foreign key (EMS_TEMPLATE)
  references EMS_TEMPLATE (ID) on delete cascade;

comment on column CFG_NOTIFICATION.REQUESTED_FOR
  is '0: Unselected - 1: TO - 2: CC - 3: BCC - 4: SMS';
comment on column CFG_NOTIFICATION.REQUESTED_BY
  is '0: Unselected - 1: TO - 2: CC - 3: BCC - 4: SMS';
comment on column CFG_NOTIFICATION.APPROVERS
  is '0: Unselected - 1: TO - 2: CC - 3: BCC - 4: SMS';
comment on column CFG_NOTIFICATION.FIXED_NOTIFY
  is '0: Unselected - 1: TO - 2: CC - 3: BCC - 4: SMS';
comment on column CFG_NOTIFICATION.FIXED_NOTIFY_LIST
  is 'Email/SMS list';

grant select on CFG_NOTIFICATION to AA;
grant select, insert, update, delete, references on CFG_NOTIFICATION to IDEAS;
grant select, insert, update, delete, references on CFG_NOTIFICATION to IDEAS_CONNECTOR;
grant select on CFG_NOTIFICATION to IDEAS_REPORT;

create sequence CFG_NOTIFICATION_SEQ
minvalue 100
maxvalue 999999999999999999999999999
start with 100
increment by 1
nocache;

grant select on CFG_NOTIFICATION_SEQ to AA;
grant select, alter on CFG_NOTIFICATION_SEQ to IDEAS;
grant select on CFG_NOTIFICATION_SEQ to IDEAS_CONNECTOR;
grant select on CFG_NOTIFICATION_SEQ to IDEAS_REPORT;
