create table CFG_PRIORITY
(
  ID                       NUMBER(16) not null,
  TYPE                     NUMBER(1) not null,
  CFG_NOTIFICATION_EMAIL   NUMBER(16),
  CFG_NOTIFICATION_SMS     NUMBER(16),
  DESCRIPTION              VARCHAR2(512 CHAR),
  PRIORITY_VALUE           NUMBER(16) not null,
  PRIORITY_UNIT            NUMBER(1) default 1 not null,
  REMINDER_START_VALUE     NUMBER(16) not null,
  REMINDER_START_UNIT      NUMBER(1) default 1 not null,
  REMINDER_FREQUENCY_VALUE NUMBER(16) not null,
  REMINDER_FREQUENCY_UNIT  NUMBER(1) default 1 not null,
  STATE                    NUMBER(16) default 0,
  ATTR1                    VARCHAR2(256 CHAR),
  ATTR2                    VARCHAR2(256 CHAR),
  ATTR3                    VARCHAR2(256 CHAR),
  ATTR4                    VARCHAR2(256 CHAR),
  ATTR5                    VARCHAR2(256 CHAR),
  CREATION_DATE            DATE default SYSDATE,
  CREATION_USER            VARCHAR2(128 CHAR),
  LAST_MOD_USER            VARCHAR2(128 CHAR),
  LAST_MOD_TIME            DATE default SYSDATE
)
tablespace &DATA_TABLESPACE
; 

alter table CFG_PRIORITY
  add constraint CFG_PRIORITY_PK primary key (ID)
  using index 
  tablespace &INDEX_TABLESPACE compute statistics;

alter table CFG_PRIORITY
  add constraint CFG_PRIORITY_NOTIF_EMAIL_FK foreign key (CFG_NOTIFICATION_EMAIL)
  references CFG_NOTIFICATION (ID) on delete set null;

alter table CFG_PRIORITY
  add constraint CFG_PRIORITY_NOTIF_SMS_FK foreign key (CFG_NOTIFICATION_SMS)
  references CFG_NOTIFICATION (ID) on delete set null;

create unique index CFG_PRIORITY_TYPE_IDX on CFG_PRIORITY (TYPE)
  tablespace IGA_CORE_INDX compute statistics;

grant select on CFG_PRIORITY to AA;
grant select, insert, update, delete, references on CFG_PRIORITY to IDEAS;
grant select, insert, update, delete, references on CFG_PRIORITY to IDEAS_CONNECTOR;
grant select on CFG_PRIORITY to IDEAS_REPORT;

create sequence CFG_PRIORITY_SEQ
minvalue 100
maxvalue 999999999999999999999999999
start with 100
increment by 1
nocache;

grant select on CFG_PRIORITY_SEQ to AA;
grant select, alter on CFG_PRIORITY_SEQ to IDEAS;
grant select on CFG_PRIORITY_SEQ to IDEAS_CONNECTOR;
grant select on CFG_PRIORITY_SEQ to IDEAS_REPORT;
