--DROP A FOREIGN KEY
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'REQUEST';
  tab_fk_name       varchar2(30) := 'REQUEST_LAST_ACC_US_S_USER_FK';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_constraints t where t.owner = curr_user and t.table_name = tab_name and t.constraint_name = tab_fk_name and t.constraint_type = 'R';
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'alter table REQUEST
  drop constraint REQUEST_LAST_ACC_US_S_USER_FK
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--DROP A COLUMN FROM A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'REQUEST';
  tab_col_name      varchar2(30) := 'LAST_ACCESS_USER';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tab_columns t where t.owner = curr_user and t.table_name = tab_name and t.column_name = tab_col_name;
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'alter table REQUEST drop column LAST_ACCESS_USER
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--DROP A COLUMN FROM A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'REQUEST';
  tab_col_name      varchar2(30) := 'LAST_ACCESS_DATE';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tab_columns t where t.owner = curr_user and t.table_name = tab_name and t.column_name = tab_col_name;
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'alter table REQUEST drop column LAST_ACCESS_DATE
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on
