--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'CFG_PROCESS';
  tab_col_name      varchar2(30) := 'CFG_NOTIFICATION_SMS';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tab_columns t where t.owner = curr_user and t.table_name = tab_name and t.column_name = tab_col_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table CFG_PROCESS add CFG_NOTIFICATION_SMS NUMBER(16)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--ADD A FOREIGN KEY
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'CFG_PROCESS';
  tab_fk_name       varchar2(30) := 'CFG_PROCESS_NOTIF_SMS_FK';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_constraints t where t.owner = curr_user and t.table_name = tab_name and t.constraint_name = tab_fk_name and t.constraint_type = 'R';
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table CFG_PROCESS
  add constraint CFG_PROCESS_NOTIF_SMS_FK foreign key (CFG_NOTIFICATION_SMS)
  references cfg_notification (ID) on delete set null
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on
