create table CFG_FIXED_REDIRECTUSER_SCOPE
(
  ACTIVITY_ID NUMBER(10) not null,
  OU_ID       NUMBER(16) not null,
  OU_CODE     VARCHAR2(128 CHAR) not null,
  HIER        NUMBER(1) default 1,
  ATTR1       VARCHAR2(256 CHAR),
  ATTR2       VARCHAR2(256 CHAR),
  ATTR3       VARCHAR2(256 CHAR),
  ATTR4       VARCHAR2(256 CHAR),
  ATTR5       VARCHAR2(256 CHAR)
)
tablespace &DATA_TABLESPACE
;

alter table CFG_FIXED_REDIRECTUSER_SCOPE
  add constraint CFG_FIXED_REDIRESER_SCOPE_PK primary key (OU_ID, ACTIVITY_ID)
  using index 
  tablespace &INDEX_TABLESPACE compute statistics;

alter table CFG_FIXED_REDIRECTUSER_SCOPE
  add constraint CFG_FIXED_RED_USER_SC_ACT foreign key (ACTIVITY_ID)
  references CFG_ACTIVITY (ID) on delete cascade;

comment on table  CFG_FIXED_REDIRECTUSER_SCOPE
  is 'Contains data of all organization unit which form a fixed user scope of a process activity';

comment on column  CFG_FIXED_REDIRECTUSER_SCOPE.ACTIVITY_ID
  is 'Activity identifier';
comment on column  CFG_FIXED_REDIRECTUSER_SCOPE.OU_ID
  is 'Organization unit primary key used by Profile Manager';
comment on column  CFG_FIXED_REDIRECTUSER_SCOPE.OU_CODE
  is 'Organization unit code';
comment on column  CFG_FIXED_REDIRECTUSER_SCOPE.HIER
  is 'Flag indicating whether entire subtree, starting from current organization unit, must be included in the scope (1) or not (0)';

grant select on CFG_FIXED_REDIRECTUSER_SCOPE to AA;
grant select, insert, update, delete, references on CFG_FIXED_REDIRECTUSER_SCOPE to IDEAS;
grant select, insert, update, delete, references on CFG_FIXED_REDIRECTUSER_SCOPE to IDEAS_CONNECTOR;
grant select on CFG_FIXED_REDIRECTUSER_SCOPE to IDEAS_REPORT;
