CREATE TABLE CFG_FIXED_REDIRECTUSER_SCOPE
(
  ACTIVITY_ID                    NUMERIC(10)         NOT NULL,
  OU_ID                          NUMERIC(16)         NOT NULL,
  OU_CODE                        VARCHAR(128)        NOT NULL,
  HIER                           NUMERIC(1)          DEFAULT 1,
  ATTR1                          VARCHAR(256),
  ATTR2                          VARCHAR(256),
  ATTR3                          VARCHAR(256),
  ATTR4                          VARCHAR(256),
  ATTR5                          VARCHAR(256)
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE CFG_FIXED_REDIRECTUSER_SCOPE ADD
  CONSTRAINT CFG_FIXED_REDIRESER_SCOPE_PK
 PRIMARY KEY (OU_ID, ACTIVITY_ID);

ALTER TABLE CFG_FIXED_REDIRECTUSER_SCOPE ADD
  CONSTRAINT CFG_FIXED_RED_USER_SC_ACT
 FOREIGN KEY (ACTIVITY_ID)
 REFERENCES CFG_ACTIVITY (ID)
    ON DELETE CASCADE;

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE CFG_FIXED_REDIRECTUSER_SCOPE' );


COMMENT ON TABLE CFG_FIXED_REDIRECTUSER_SCOPE IS
'Contains data of all organization unit which form a fixed user scope of a process activity';

COMMENT ON COLUMN CFG_FIXED_REDIRECTUSER_SCOPE.ACTIVITY_ID IS
'Activity identifier';

COMMENT ON COLUMN CFG_FIXED_REDIRECTUSER_SCOPE.HIER IS
'Flag indicating whether entire subtree, starting from current organization unit, must be included in the scope (1) or not (0)';

COMMENT ON COLUMN CFG_FIXED_REDIRECTUSER_SCOPE.OU_CODE IS
'Organization unit code';

COMMENT ON COLUMN CFG_FIXED_REDIRECTUSER_SCOPE.OU_ID IS
'Organization unit primary key used by Profile Manager';

grant select on CFG_FIXED_REDIRECTUSER_SCOPE to &AA_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on CFG_FIXED_REDIRECTUSER_SCOPE to &IDEAS_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on CFG_FIXED_REDIRECTUSER_SCOPE to &IDEAS_CONN_SUPER_ADMIN_USER;
grant select on CFG_FIXED_REDIRECTUSER_SCOPE to &IDEAS_REPORT_SUPER_ADMIN_USER;

