alter table CFG_PROCESSACTIVITY_ACTION drop primary key;

declare
  tab_name      varchar(30) := 'CFG_PROCESSACTIVITY_ACTION';
  pk_col_name   varchar(30) := 'ID';
  seq_name      varchar(30) := upper ( tab_name ) || '_SEQ';
  cur_tab       sys_refcursor;
  tab_seq       numeric(16);
  
  tab_rowid     varchar(256);
begin
  open cur_tab for 'select rowid from ' || tab_name || ' where ' || pk_col_name || ' is null';
  loop
    fetch cur_tab into tab_rowid;
    exit when cur_tab%NOTFOUND;
    execute immediate ( 'select ' || seq_name || '.nextval from dual') into tab_seq;
    
    execute immediate ( 'update ' || tab_name || ' set ' || pk_col_name || ' = ' || tab_seq || ' where rowid = '''|| tab_rowid || '''' );
    
  end loop;
  close cur_tab;
end;
/
commit;
alter table CFG_PROCESSACTIVITY_ACTION alter column ID set not null;


--REORGANIZE A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'CFG_PROCESSACTIVITY_ACTION';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from sysibm.tables t where ( t.table_type = 'BASE TABLE' or t.table_type is null ) and lower ( t.table_schema ) = lower ( curr_user ) and t.table_name = tab_name;
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'CALL SYSPROC.ADMIN_CMD( ''REORG TABLE CFG_PROCESSACTIVITY_ACTION'' )
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
commit;
set serveroutput off
set verify on


ALTER TABLE CFG_PROCESSACTIVITY_ACTION ADD
  CONSTRAINT CFG_PROCESSACTIVITY_ACTION_PK
 PRIMARY KEY (ID);
CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE CFG_PROCESSACTIVITY_ACTION' );
