alter table CFG_PROCESSACTIVITY_ACTION
  drop constraint CFG_PROCESSACTIVITYACTION_PK cascade;

declare
  tab_name      varchar2(30) := 'CFG_PROCESSACTIVITY_ACTION';
  pk_col_name   varchar2(30) := 'ID';
  seq_name      varchar2(30) := upper ( tab_name ) || '_SEQ';
  cur_tab       sys_refcursor;
  tab_seq       number(16);
  
  tab_rowid     rowid;
begin
  open cur_tab for 'select rowid from ' || tab_name || ' where ' || pk_col_name || ' is null';
  loop
    fetch cur_tab into tab_rowid;
    exit when cur_tab%NOTFOUND;
    execute immediate ( 'select ' || seq_name || '.nextval from dual') into tab_seq;
    
    execute immediate ( 'update ' || tab_name || ' set ' || pk_col_name || ' = ' || tab_seq || ' where rowid = '''|| tab_rowid || '''' );
    
  end loop;
  close cur_tab;
end;
/
commit;


--ALTER A COLUMN SET NOT NULL
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'CFG_PROCESSACTIVITY_ACTION';
  tab_col_name      varchar2(30) := 'ID';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tab_columns t where t.owner = curr_user and t.table_name = tab_name and t.column_name = tab_col_name and t.nullable = 'N';
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'alter table CFG_PROCESSACTIVITY_ACTION modify ID not null
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

alter table CFG_PROCESSACTIVITY_ACTION
  add constraint CFG_PROCESSACTIVITY_ACTION_PK primary key (ID)
  using index 
  tablespace &INDEX_TABLESPACE compute statistics;
