--CREATE AN INDEX
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  idx_name          varchar(30) := 'TMP_AO_ITROLE_FULL_IDX';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.indexes t where t.indschema = curr_user and lower ( indname ) = lower ( idx_name );
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'CREATE INDEX TMP_AO_ITROLE_FULL_IDX ON TMP_AO_ENTITLEMENT
(AUTHOBJ, FIELD_NAME, MIN_VALUE, MAX_VALUE, SAP_AUTH)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--CREATE AN INDEX
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  idx_name          varchar(30) := 'TMP_PROF_AO_F_VAL_FULL_IDX';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.indexes t where t.indschema = curr_user and lower ( indname ) = lower ( idx_name );
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'CREATE INDEX TMP_PROF_AO_F_VAL_FULL_IDX ON TMP_PROFILE_AO_FIELD_VALUE
(PROFILE_AO_FIELD, VALUE)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on
