create or replace function arc4s_02_calc_prof_risk_by_app
(
  application_id in number
)
return sys_refcursor is

  ENTITLEMENT_PROFILE_TYPE constant number(1) := 1;
  ENTITLEMENT_IT_ROLE_TYPE constant number(1) := 2;
  COMMIT_STEP         CONSTANT NUMBER(2) := 10;

  it_role_count  sys_refcursor;
  cur_sap_role   sys_refcursor;
  cur_t_name     sys_refcursor;

  sap_role_id    number(16);
  counter        number(16) := 0;
  commit_counter number(16) := 0;

  t_name         varchar2(256);

  v_return       number(16);
begin
  open cur_sap_role for
    select t.id from entitlement t
    where t.application = application_id
    and t.int_type = ENTITLEMENT_IT_ROLE_TYPE and t.family is null;
  loop
    fetch cur_sap_role into sap_role_id;
    exit when cur_sap_role%NOTFOUND;

    delete from entitlement_risk t where t.entitlement = sap_role_id;

    insert into entitlement_risk ( id, entitlement, risk )
    select entitlement_risk_seq.nextval, tr_pr.sro, tr_pr.pr from
    (
      select /*+ ORDERED */ distinct tr.entitlement as sro, pr.id as pr
      from transactionrole tr, entitlement pr
      where tr.entitlement = sap_role_id
      and tr.application = application_id
      and tr.application = pr.application
      --and tr.id = pr.transaction  --tutte le transazioni non star o non ranged non hanno l'id nel transactionrole
      and upper(tr.name) = upper(pr.transaction_name)
      and pr.int_type = ENTITLEMENT_PROFILE_TYPE
    ) tr_pr;

    open cur_t_name for
        select tr.name from transactionrole tr
        where (tr.entitlement = sap_role_id and tr.application = application_id and tr.name like '%*')
        or (tr.entitlement = sap_role_id and tr.application = application_id and tr.name like '%|%');
    loop
      fetch cur_t_name into t_name;
      exit when cur_t_name%notfound;

      v_return := arc4s_01_transaction_parser ( sap_role_id, t_name, application_id );
    end loop;
    close cur_t_name;

/*
    --da modificare quando il legame tra profile_ao e profile_ao_field sara' univoco
    insert into entitlement_risk_ao ( id, entitlement_risk, auth_obj )
    select entitlement_risk_seq.nextval, a.entitlement_risk_id, authobj_id from
    (
      select distinct ipr.id as entitlement_risk_id, pao.auth_obj as authobj_id from
      entitlement_risk ipr, profile_ao pao
      where ipr.profile = pao.profile and ipr.it_role = itr.id
    ) a;
*/
    counter := counter + 1;
    commit_counter := commit_counter + 1;
    if ( commit_counter >= COMMIT_STEP ) then
      commit_counter := 0;
      commit;
    end if;

  end loop;
  close cur_sap_role;

  open it_role_count for select counter from dual;

  return it_role_count;
end arc4s_02_calc_prof_risk_by_app;
/
