create or replace function arc4s_06_ch_aof_val_all_into
(
  pr_ao_id in number,
  pr_ao_auth_obj in number,
  ao_sap_auth in varchar2,
  eq_cond in number
)
return number is
--all into -  tutti tra (NEW)
--NUM_ALL_INTO_COND   CONSTANT NUMBER(1) := 3;
--
--la funzione check_aof_val_all_into ritorna:
--   NUMERIC_TRUE se TROVA ALMENO uno dei valori all'intervallo dell'insieme di definizione
--   NUMERIC_FALSE altrimenti
-- questa modalita' e' usata per simulare un OR in un insieme "IN"

  NUMERIC_FALSE      CONSTANT NUMBER(1) := 0;
  NUMERIC_TRUE       CONSTANT NUMBER(1) := 1;

  NUMERIC_OR         CONSTANT NUMBER(1) := 0;
  NUMERIC_AND        CONSTANT NUMBER(1) := 1;

  --all into -  tutti tra (NEW)
  NUM_ALL_INTO_COND   CONSTANT NUMBER(1) := 3;

  cur_f_val          sys_refcursor;
  f_id               number(16);
  f_name             varchar2(256);

  cond_ok            number(1) := NUMERIC_TRUE;
  count_itr_min_risk number(16);

  tmp_is_full        number(1) := NUMERIC_FALSE;
begin
    if ( eq_cond = NUMERIC_OR ) then
      cond_ok := NUMERIC_FALSE;
    elsif ( eq_cond = NUMERIC_AND ) then
      cond_ok := NUMERIC_TRUE;
    end if;

  --cerchiamo tutti i FIELD ID, NAME che hanno una condizione di ALL INTO
  open cur_f_val for
    select t.id, t.name from profile_ao_field t
    where t.profile_ao = pr_ao_id and t.eq_condition = NUM_ALL_INTO_COND;
  loop
    fetch cur_f_val into f_id, f_name;
    exit when cur_f_val%NOTFOUND;

    --riempiamo la tabella temporanea con tutti i VALUE anche con quelli
    --con l'asterisco svolti
    tmp_is_full := arc4s_05_pr_ao_f_val_parser ( pr_ao_auth_obj, f_id, f_name, ao_sap_auth );

    --scartiamo i VALUE del RISK in condizione ALL INTO
    --con i MIN_VALUE dell'IT_ROLE
    --e ne contiamo numericamente il risultato
    --    CONDITION | IT ROLE VALUE  | RISK VALUE
    --ES.  any from    (01, 02, 03)   (01, 02, 03, 04, 05, 06)  --> YES
    --ES.  any from    (01, 02, 07)   (01, 02, 03, 04, 05, 06)  --> NO
    select count(1) into count_itr_min_risk from
    (
      select distinct tmp.min_value from tmp_ao_entitlement tmp
      where tmp.authobj = pr_ao_auth_obj and tmp.field_name = f_name
      and tmp.sap_auth = ao_sap_auth
      minus
      select distinct t.value from tmp_profile_ao_field_value t
      where t.profile_ao_field = f_id
    ) t;

    --se siamo in condizioni AND e il conteggio dello scarto tra MIN_VALUE
    --dell'IT_ROLE e VALUE del RISK e' maggiore di zero, significa che qualche
    --valore dell'IT_ROLE e' al di fuori dell'intervallo di definizione del RISK
    if ( eq_cond = NUMERIC_AND and count_itr_min_risk > 0 ) then
      cond_ok := NUMERIC_FALSE;
      exit;
    --se siamo in condizioni OR e il conteggio dello scarto tra MIN_VALUE
    --dell'IT_ROLE e VALUE del RISK e' maggiore di zero, significa che qualche
    --valore dell'IT_ROLE e' al di fuori dell'intervallo di definizione del RISK
    elsif ( eq_cond = NUMERIC_OR and count_itr_min_risk = 0 ) then
      cond_ok := NUMERIC_TRUE;
      exit;
    end if;

  end loop;
  close cur_f_val;

  return cond_ok;
end arc4s_06_ch_aof_val_all_into;
/
