create or replace function arc2arcs_05_align_all_risk
(
  src_env_name in varchar2,
  dest_env_name in varchar2
)
return number is
  src_environment    number(16);
  dest_environment   number(16);

  ret_var            number(16);
begin
  --cerchiamo l'environment di default (WORKING = 1) all'interno del
  --sistema di destinazione
  if ( src_env_name is null ) then
    src_environment := arc2arcs_00_get_src_wrk_env();
  else
    select t.id into src_environment from &IGA_CORE_USER_OLD..environment t where lower(t.name) = lower(src_env_name);
  end if;

  --cerchiamo l'environment di default (WORKING = 1) all'interno del
  --sistema di destinazione
  if ( dest_env_name is null ) then
    dest_environment := arc2arcs_00_get_dest_wrk_env();
  else
    select t.id into dest_environment from environment t where lower(t.name) = lower(dest_env_name);
  end if;

  --cancelliamo nel sistema di destinazione i risk, risk_type e risk_task
  --non presenti nel sistema sorgente
  ret_var := arc2arcs_02_del_non_ex_risk ( src_environment, dest_environment );

  --allineiamo nel sistema di destinazione tutte le informazioni dei risk
  ret_var := arc2arcs_02_align_risk ( src_environment, dest_environment );

  --inseriamo nel sistema di destinazione i risk, risk_type e risk_task non presenti
  --nel sistema sorgente
  ret_var := arc2arcs_02_ins_mis_risk ( src_environment, dest_environment );

  return ret_var;
end arc2arcs_05_align_all_risk;
/
