--DROP A TRIGGER
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  trg_name          varchar(30) := 'TRG_ENTITLEMENT_HISTORY';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.triggers t where t.trigschema = curr_user and lower ( t.trigname ) = lower ( trg_name );
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'drop trigger trg_entitlement_history
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--DROP A TRIGGER
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  trg_name          varchar(30) := 'TRG_ENT_HIER_HISTORY';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.triggers t where t.trigschema = curr_user and lower ( t.trigname ) = lower ( trg_name );
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'drop trigger trg_ent_hier_history
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--DROP A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'HISTORY';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from sysibm.tables t where ( t.table_type = 'BASE TABLE' or t.table_type is null ) and lower ( t.table_schema ) = lower ( curr_user ) and t.table_name = tab_name;
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'drop table history
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
commit;
set serveroutput off
set verify on

--DROP A SEQUENCE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  seq_name          varchar(30) := 'HISTORY_SEQ';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.sequences t where lower ( t.seqschema ) = lower ( curr_user ) and t.seqtype <> 'I' and lower ( t.seqname ) = lower ( seq_name );
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'drop sequence history_seq
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on


declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_disable ( 'trg_add_modify_authorizations' );
end;
/
declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_disable ( 'trg_entitlement_protection' );
end;
/
declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_disable ( 'trg_entitlement_validator' );
end;
/
declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_disable ( 'trg_ent_hier_protection' );
end;
/
declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_disable ( 'trg_add_remove_ent_flat_hier' );
end;
/

declare
  counter      numeric(16);
begin
  select count(1) into counter from application where administrative = 1;
  if ( counter > 0 ) then
    delete from application where administrative = 1;
  end if;

  select count(1) into counter from entitlement where administrative = 1;
  if ( counter > 0 ) then
    delete from entitlement where administrative = 1;
  end if;
end;
/
commit;

declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_enable ( 'trg_add_modify_authorizations' );
end;
/
declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_enable ( 'trg_entitlement_protection' );
end;
/
declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_enable ( 'trg_entitlement_validator' );
end;
/
declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_enable ( 'trg_ent_hier_protection' );
end;
/
declare
  var_ret    numeric(1);
begin
  var_ret := db2_trg_enable ( 'trg_add_remove_ent_flat_hier' );
end;
/
