--DROP A TRIGGER
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  trg_name          varchar2(30) := 'TRG_ENTITLEMENT_HISTORY';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_triggers t where t.owner = curr_user and t.trigger_name = trg_name;
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'drop trigger trg_entitlement_history
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--DROP A TRIGGER
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  trg_name          varchar2(30) := 'TRG_ENT_HIER_HISTORY';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_triggers t where t.owner = curr_user and t.trigger_name = trg_name;
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'drop trigger trg_ent_hier_history
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--DROP A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'HISTORY';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tables t where t.owner = curr_user and t.table_name = tab_name;
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'drop table history cascade constraints
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

--DROP A SEQUENCE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  seq_name          varchar2(30) := 'HISTORY_SEQ';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_sequences t where t.sequence_owner = curr_user and t.sequence_name = seq_name;
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'drop sequence history_seq
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

purge recyclebin;


alter trigger trg_add_modify_authorizations disable;
alter trigger trg_entitlement_protection disable;
alter trigger trg_entitlement_validator disable;
alter trigger trg_ent_hier_protection disable;
alter trigger trg_add_remove_ent_flat_hier disable;

declare
  counter      number(16);
begin
  select count(1) into counter from application where administrative = 1;
  if ( counter > 0 ) then
    delete from application where administrative = 1;
  end if;

  select count(1) into counter from entitlement where administrative = 1;
  if ( counter > 0 ) then
    delete from entitlement where administrative = 1;
  end if;
end;
/
commit;

alter trigger trg_add_modify_authorizations enable;
alter trigger trg_entitlement_protection enable;
alter trigger trg_entitlement_validator enable;
alter trigger trg_ent_hier_protection enable;
alter trigger trg_add_remove_ent_flat_hier enable;
