create table EMS_TEMPLATE_TYPE
(
  ID   NUMERIC(16) not null,
  CODE VARCHAR(256) not null,
  NAME VARCHAR(256) not null
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE EMS_TEMPLATE_TYPE ADD
  CONSTRAINT EMS_TEMPLATE_TYPE_PK 
 PRIMARY KEY (ID);

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE EMS_TEMPLATE_TYPE' );

grant select on EMS_TEMPLATE_TYPE to &AA_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on EMS_TEMPLATE_TYPE to &IDEAS_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on EMS_TEMPLATE_TYPE to &IDEAS_CONN_SUPER_ADMIN_USER;
grant select on EMS_TEMPLATE_TYPE to &IDEAS_REPORT_SUPER_ADMIN_USER;

create sequence EMS_TEMPLATE_TYPE_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

grant usage on sequence EMS_TEMPLATE_TYPE_SEQ to &AA_SUPER_ADMIN_USER;
grant usage, alter on sequence EMS_TEMPLATE_TYPE_SEQ to &IDEAS_SUPER_ADMIN_USER;
grant usage, alter on sequence EMS_TEMPLATE_TYPE_SEQ to &IDEAS_CONN_SUPER_ADMIN_USER;
grant usage on sequence EMS_TEMPLATE_TYPE_SEQ to &IDEAS_REPORT_SUPER_ADMIN_USER;
