--CREATE A TABLE AND ITS CONSTRAINTS
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'EMS_TEMPLATE_TYPE';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from sysibm.tables t where ( t.table_type = 'BASE TABLE' or t.table_type is null ) and lower ( t.table_schema ) = lower ( curr_user ) and t.table_name = tab_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'create table EMS_TEMPLATE_TYPE
(
  ID   NUMERIC(16) not null,
  CODE VARCHAR(256) not null,
  NAME VARCHAR(256) not null
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'ALTER TABLE EMS_TEMPLATE_TYPE ADD
  CONSTRAINT EMS_TEMPLATE_TYPE_PK 
 PRIMARY KEY (ID)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
commit;
set serveroutput off
set verify on


--REORGANIZE A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'EMS_TEMPLATE_TYPE';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from sysibm.tables t where ( t.table_type = 'BASE TABLE' or t.table_type is null ) and lower ( t.table_schema ) = lower ( curr_user ) and t.table_name = tab_name;
  if ( counter = 0 ) then
    return;
  end if;

  dml_def :=
'CALL SYSPROC.ADMIN_CMD( ''REORG TABLE EMS_TEMPLATE_TYPE'' )
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
commit;
set serveroutput off
set verify on

grant select on EMS_TEMPLATE_TYPE to &AA_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on EMS_TEMPLATE_TYPE to &IDEAS_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on EMS_TEMPLATE_TYPE to &IDEAS_CONN_SUPER_ADMIN_USER;
grant select on EMS_TEMPLATE_TYPE to &IDEAS_REPORT_SUPER_ADMIN_USER;


--CREATE A SEQUENCE
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  seq_name          varchar(30) := 'EMS_TEMPLATE_TYPE_SEQ';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from syscat.sequences t where lower ( t.seqschema ) = lower ( curr_user ) and t.seqtype <> 'I' and lower ( t.seqname ) = lower ( seq_name );
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'create sequence EMS_TEMPLATE_TYPE_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
commit;
set serveroutput off
set verify on

grant usage on sequence EMS_TEMPLATE_TYPE_SEQ to &AA_SUPER_ADMIN_USER;
grant usage, alter on sequence EMS_TEMPLATE_TYPE_SEQ to &IDEAS_SUPER_ADMIN_USER;
grant usage, alter on sequence EMS_TEMPLATE_TYPE_SEQ to &IDEAS_CONN_SUPER_ADMIN_USER;
grant usage on sequence EMS_TEMPLATE_TYPE_SEQ to &IDEAS_REPORT_SUPER_ADMIN_USER;
