--CREATE A TABLE AND ITS CONSTRAINTS
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'EMS_TEMPLATE_TYPE';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tables t where t.owner = curr_user and t.table_name = tab_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'create table EMS_TEMPLATE_TYPE
(
  ID   NUMBER(16) not null,
  CODE VARCHAR2(256 CHAR) not null,
  NAME VARCHAR2(256 CHAR) not null
)
tablespace IGA_CORE_DATA
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'alter table EMS_TEMPLATE_TYPE
  add constraint EMS_TEMPLATE_TYPE_PK primary key (ID)
  using index 
  tablespace IGA_CORE_INDX compute statistics
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

grant select on EMS_TEMPLATE_TYPE to AA;
grant select, insert, update, delete, references on EMS_TEMPLATE_TYPE to IDEAS;
grant select, insert, update, delete, references on EMS_TEMPLATE_TYPE to IDEAS_CONNECTOR;
grant select on EMS_TEMPLATE_TYPE to IDEAS_REPORT;

--CREATE A SEQUENCE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  seq_name          varchar2(30) := 'EMS_TEMPLATE_TYPE_SEQ';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_sequences t where t.sequence_owner = curr_user and t.sequence_name = seq_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'create sequence EMS_TEMPLATE_TYPE_SEQ
minvalue 100
maxvalue 999999999999999999999999999
start with 100
increment by 1
nocache
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

grant select on EMS_TEMPLATE_TYPE_SEQ to AA;
grant select, alter on EMS_TEMPLATE_TYPE_SEQ to IDEAS;
grant select on EMS_TEMPLATE_TYPE_SEQ to IDEAS_CONNECTOR;
grant select on EMS_TEMPLATE_TYPE_SEQ to IDEAS_REPORT;
