declare
  cur_ems_lan       sys_refcursor;
  ems_lan_id        NUMERIC(16);
  ems_lan_name      VARCHAR(256);
  ems_lan_country   VARCHAR(256);
begin
  open cur_ems_lan for
    select el.id, el.name, el.country from ems_language el
    where not exists (
      select 1 from language l
      where l.id = el.id
      and lower ( l.code ) = lower ( el.name )
    )
    union
    select el.id, el.name, el.country from ems_language el
    where not exists (
      select 1 from language l
      where l.id = el.id
      and lower ( l.code ) = lower ( el.name )
      and l.country is null
    )
    and el.country is null
    ;
  loop
    fetch cur_ems_lan into ems_lan_id, ems_lan_name, ems_lan_country;
    exit when cur_ems_lan%NOTFOUND;
    
    if ( instr ( ems_lan_name, '_' ) = 0 and ( ems_lan_country is null or instr ( ems_lan_country, '_' ) = 0 ) ) then
      update ems_language set name = '_' || name, country = '_' || country where id = ems_lan_id;
    end if;
  end loop;
  close cur_ems_lan;
end;
/
commit;
