declare
  cur_ems_lan       sys_refcursor;
  cur_lan           sys_refcursor;
  lan_id            NUMERIC(16);
  lan_code          VARCHAR(256);
  lan_country       VARCHAR(256);
  ems_lan_id        NUMERIC(16);
  ems_lan_name      VARCHAR(256);
  ems_lan_country   VARCHAR(256);
  
  ems_lan_offset    NUMERIC(16) := 1000;

  counter           NUMERIC(16);
begin
  open cur_ems_lan for
    select el.id from ems_language el
    where not exists (
      select 1 from language l
      where l.id = el.id
      and lower ( l.code ) = lower ( el.name )
    )
    union
    select el.id from ems_language el
    where not exists (
      select 1 from language l
      where l.id = el.id
      and lower ( l.code ) = lower ( el.name )
      and l.country is null
    )
    and el.country is null
    ;
  loop
    fetch cur_ems_lan into ems_lan_id;
    exit when cur_ems_lan%NOTFOUND;
    
    update ems_i18n_message set language = language + ems_lan_offset where language = ems_lan_id;
  end loop;
  close cur_ems_lan;

  open cur_lan for select id, code, country from language;
  loop
    fetch cur_lan into lan_id, lan_code, lan_country;
    exit when cur_lan%NOTFOUND;
    select count(1) into counter from ems_language t where t.id = lan_id;
    if ( counter = 1 ) then
      select t.name, t.country into ems_lan_name, ems_lan_country from ems_language t where t.id = lan_id;
      if ( lower ( lan_code ) <> lower ( ems_lan_name ) or lower ( lan_country ) <> lower ( ems_lan_country ) ) then
        
        if ( lan_country is null ) then
          select count(1) into counter from ems_language t where lower ( t.name ) = lower ( '_' || lan_code ) and lower ( t.country ) =  lower ( '_' );
        else
          select count(1) into counter from ems_language t where lower ( t.name ) = lower ( '_' || lan_code ) and lower ( t.country ) =  lower ( '_' || lan_country );
        end if;
        if ( counter = 1 ) then
          if ( lan_country is null ) then
            select id into ems_lan_id from ems_language t where lower ( t.name ) = lower ( '_' || lan_code ) and lower ( t.country ) =  lower ( '_' );
          else
            select id into ems_lan_id from ems_language t where lower ( t.name ) = lower ( '_' || lan_code ) and lower ( t.country ) =  lower ( '_' || lan_country );
          end if;
          
          update ems_i18n_message set language = lan_id where language = ems_lan_id + ems_lan_offset;
        end if;
      end if;
    end if;
  end loop;
  close cur_lan;
end;
/
commit;

