declare
  cur_ems_t         sys_refcursor;
  cur_lan           sys_refcursor;

  ems_t_id          NUMERIC(16);
  ems_t_loc         NUMERIC(16);
  lan_id            NUMERIC(16);
  lan_code          VARCHAR(256) := 'IL';
  lan_def_id        NUMERIC(16);
  counter           NUMERIC(16);
begin
  select count(1) into counter from ems_language t where lower ( t.name ) = lower ( lan_code );
  if ( counter = 0 ) then
    return;
  end if;
  select t.id into lan_id from ems_language t where lower ( t.name ) = lower ( lan_code );
  
  select count(1) into counter from ems_language t where t.language_status = 2;
  if ( counter > 1 ) then
    return;
  end if;
  select t.id into lan_def_id from ems_language t where t.language_status = 2;
  
  if ( lan_id <> lan_def_id ) then
    open cur_ems_t for
      select
        t.id,
        t.loc
      from
      (
        select t.id, t.subject as loc from ems_template t
        where t.name not in ( 'Report Available', 'Campaign Started', 'ARM Reset Password', 'ForgotPassword' )
        union all
        select t.id, t.body as loc from ems_template t
        where t.name not in ( 'Report Available', 'Campaign Started', 'ARM Reset Password', 'ForgotPassword' )
      ) t order by t.id, t.loc;
    loop
      fetch cur_ems_t into ems_t_id, ems_t_loc;
      exit when cur_ems_t%NOTFOUND;

      update ems_i18n_message set language = lan_id where language = lan_def_id and localization = ems_t_loc;
    end loop;
    close cur_ems_t;
  end if;
end;
/
commit;
