declare
  lan_id                numeric(16);
  lan_code              varchar(256) := 'EN';
  lan_country           varchar(256) := null;
  
  template_type_id      numeric(16);
  template_type_code    varchar(256) := 'REMINDER';
  template_type_name    varchar(256) := 'REMINDER';

  template_id           numeric(16);

  template_name         varchar(256) := 'Reminder template';
  template_value        varchar(256) := null;
  template_desc         varchar(512) := '';
  template_alt_status   numeric(1) := 0;

  subj_loc_id           numeric(16);
  subj_loc_name         varchar(256) := 'email.subject.';
  
  body_loc_id           numeric(16);
  body_loc_name         varchar(256) := 'email.body.';
  
  alt_loc_id            numeric(16);
  alt_loc_name          varchar(256) := 'email.sms.';
  
  subj_mess_id          numeric(16);
  subj_mess             clob;

  body_mess_id          numeric(16);
  body_mess             clob;

  alt_mess_id           numeric(16);
  alt_mess              clob;

  counter               numeric(16);
begin
  subj_mess :='Reminder
'||'';

  body_mess :='${details}
'||'';

  alt_mess :='';

  if ( lan_country is null ) then
    select t.id into lan_id from ems_language t where lower ( t.name ) = lower ( lan_code ) and t.country is null;
  else
    select t.id into lan_id from ems_language t where lower ( t.name ) = lower ( lan_code ) and lower ( t.country ) = lower ( lan_country );
  end if;
  
  if ( template_type_code is not null or template_type_name is not null ) then
    select count(1) into counter from ems_template_type t
    where lower ( t.code ) = lower ( template_type_code ) and lower ( t.name ) = lower ( template_type_name );
    if ( counter = 0 ) then
      select ems_template_type_seq.nextval into template_type_id from dual;
      insert into ems_template_type ( id, code, name )
      values ( template_type_id, template_type_code, template_type_name );
    else
      select t.id into template_type_id from ems_template_type t
      where lower ( t.code ) = lower ( template_type_code ) and lower ( t.name ) = lower ( template_type_name );
    end if;
  end if;
  
  select count(1) into counter from ems_template t where lower ( t.name ) = lower ( template_name );
  if ( counter = 0 ) then
    select ems_template_seq.nextval into template_id from dual;
    insert into ems_template ( id, name, value, description, template_type, alternative_status, attr1, attr2, attr3, attr4, attr5 )
    values ( template_id, template_name, template_value, template_desc, template_type_id, template_alt_status, null, null, null, null, null );
  else
    select t.id into template_id from ems_template t where lower ( t.name ) = lower ( template_name );
    update ems_template set value = template_value, description = template_desc, template_type = template_type_id, alternative_status = template_alt_status
    where id = template_id;
  end if;
  
  subj_loc_name := subj_loc_name || template_id;
  select count(1) into counter from ems_localization t where lower ( t.code ) = lower ( subj_loc_name );
  if ( counter = 0 ) then
    select ems_localization_seq.nextval into subj_loc_id from dual;
    insert into ems_localization ( id, code, code_type )
    values ( subj_loc_id, subj_loc_name, 1 );
    
    update ems_template set subject = subj_loc_id where id = template_id;
  else
    select t.id into subj_loc_id from ems_localization t where lower ( t.code ) = lower ( subj_loc_name );

    select count(1) into counter from ems_template t where t.id = template_id and t.subject = subj_loc_id;
    if ( counter = 0 ) then
      update ems_template set subject = subj_loc_id where id = template_id;
    end if;
  end if;
  
  body_loc_name := body_loc_name || template_id;
  select count(1) into counter from ems_localization t where lower ( t.code ) = lower ( body_loc_name );
  if ( counter = 0 ) then
    select ems_localization_seq.nextval into body_loc_id from dual;
    insert into ems_localization ( id, code, code_type )
    values ( body_loc_id, body_loc_name, 1 );

    update ems_template set body = body_loc_id where id = template_id;
  else
    select t.id into body_loc_id from ems_localization t where lower ( t.code ) = lower ( body_loc_name );

    select count(1) into counter from ems_template t where t.id = template_id and t.body = body_loc_id;
    if ( counter = 0 ) then
      update ems_template set body = body_loc_id where id = template_id;
    end if;
  end if;
  
  alt_loc_name := alt_loc_name || template_id;
  select count(1) into counter from ems_localization t where lower ( t.code ) = lower ( alt_loc_name );
  if ( counter = 0 ) then
    select ems_localization_seq.nextval into alt_loc_id from dual;
    insert into ems_localization ( id, code, code_type )
    values ( alt_loc_id, alt_loc_name, 1 );

    update ems_template set alternative = alt_loc_id where id = template_id;
  else
    select t.id into alt_loc_id from ems_localization t where lower ( t.code ) = lower ( alt_loc_name );

    select count(1) into counter from ems_template t where t.id = template_id and t.body = alt_loc_id;
    if ( counter = 0 ) then
      update ems_template set alternative = alt_loc_id where id = template_id;
    end if;
  end if;
  
  select count(1) into counter from ems_i18n_message t where t.language = lan_id and t.localization = subj_loc_id;
  if ( counter = 0 ) then
    select ems_i18n_message_seq.nextval into subj_mess_id from dual;
    insert into ems_i18n_message ( id, localization, language, message )
    values ( subj_mess_id, subj_loc_id, lan_id, subj_mess );
  else
    select t.id into subj_mess_id from ems_i18n_message t where t.language = lan_id and t.localization = subj_loc_id;
    update ems_i18n_message set message = subj_mess where id = subj_mess_id;
  end if;
  
  select count(1) into counter from ems_i18n_message t where t.language = lan_id and t.localization = body_loc_id;
  if ( counter = 0 ) then
    select ems_i18n_message_seq.nextval into subj_mess_id from dual;
    insert into ems_i18n_message ( id, localization, language, message )
    values ( subj_mess_id, body_loc_id, lan_id, body_mess );
  else
    select t.id into body_mess_id from ems_i18n_message t where t.language = lan_id and t.localization = body_loc_id;
    update ems_i18n_message set message = body_mess where id = body_mess_id;
  end if;
  
  select count(1) into counter from ems_i18n_message t where t.language = lan_id and t.localization = alt_loc_id;
  if ( counter = 0 ) then
    select ems_i18n_message_seq.nextval into subj_mess_id from dual;
    insert into ems_i18n_message ( id, localization, language, message )
    values ( subj_mess_id, alt_loc_id, lan_id, alt_mess );
  else
    select t.id into alt_mess_id from ems_i18n_message t where t.language = lan_id and t.localization = alt_loc_id;
    update ems_i18n_message set message = alt_mess where id = alt_mess_id;
  end if;
  
end;
/
commit;

