declare
  cur_ems_t         sys_refcursor;
  cur_lan           sys_refcursor;

  ems_t_id          number(16);
  ems_t_loc         number(16);
  lan_id            number(16);
  lan_code          varchar2(256) := 'EN';
  lan_def_id        number(16);
  counter           number(16);
begin
  select count(1) into counter from ems_language t where lower ( t.name ) = lower ( lan_code );
  if ( counter = 0 ) then
    return;
  end if;
  select t.id into lan_def_id from  ems_language t where lower ( t.name ) = lower ( lan_code );
  
  open cur_ems_t for
    select
      t.id,
      t.loc
    from
    (
      select t.id, t.subject as loc from ems_template t
      where t.name in ( 'Report Available', 'Campaign Started', 'ARM Reset Password', 'ForgotPassword' )
      union all
      select t.id, t.body as loc from ems_template t
      where t.name in ( 'Report Available', 'Campaign Started', 'ARM Reset Password', 'ForgotPassword' )
    ) t order by t.id, t.loc;
  loop
    fetch cur_ems_t into ems_t_id, ems_t_loc;
    exit when cur_ems_t%NOTFOUND;
    
    open cur_lan for select t.id from ems_language t where t.language_status = 1;
    loop
      fetch cur_lan into lan_id;
      exit when cur_lan%NOTFOUND;
      
      select count(1) into counter from ems_i18n_message t where t.localization = ems_t_loc and t.language = lan_id;
      if ( counter = 0 ) then
        insert into ems_i18n_message ( id, localization, language, message )
        select ems_i18n_message_seq.nextval, ems_t_loc, lan_id, t.message from ems_i18n_message t
        where t.language = lan_def_id and t.localization = ems_t_loc;
      end if;
    end loop;
    close cur_lan;
  end loop;
  close cur_ems_t;
end;
/
commit;
