--modifica anche la lingua di default ad inglese
declare
  cur_ems_t         sys_refcursor;
  cur_lan           sys_refcursor;
  cur_loc_def       sys_refcursor;

  ems_i18n_id       number(16);
  ems_t_id          number(16);
  ems_t_loc         number(16);
  lan_id            number(16);
  lan_en_id         number(16);
  lan_en_code       varchar2(256) := 'EN';
  lan_def_id        number(16);
  lan_def_code      varchar2(256);
  counter           number(16);
begin
  select count(1) into counter from ems_language t where t.language_status = 2;
  if ( counter = 0 ) then
    return;
  end if;
  select t.id, t.name into lan_def_id, lan_def_code from ems_language t where t.language_status = 2;
  
  select count(1) into counter from ems_language t where lower ( t.name ) = lower ( lan_en_code );
  if ( counter = 0 ) then
    return;
  end if;
  select t.id into lan_en_id from  ems_language t where lower ( t.name ) = lower ( lan_en_code );
  
  update ems_language set language_status = 2 where id = lan_en_id;
  update ems_language set language_status = 1 where id = lan_def_id;
      
  open cur_ems_t for
    select
      t.id,
      t.loc
    from
    (
      select t.id, t.subject as loc from ems_template t
      where t.name not in ( 'Report Available', 'Campaign Started', 'ARM Reset Password', 'ForgotPassword' )
      union all
      select t.id, t.body as loc from ems_template t
      where t.name not in ( 'Report Available', 'Campaign Started', 'ARM Reset Password', 'ForgotPassword' )
    ) t order by t.id, t.loc;
  loop
    fetch cur_ems_t into ems_t_id, ems_t_loc;
    exit when cur_ems_t%NOTFOUND;
    
    --la lingua di default non e inglese (EN)
    if ( lower ( lan_en_code ) <> lower ( lan_def_code ) ) then
      select count(1) into counter from ems_i18n_message t where t.language = lan_def_id and t.localization = ems_t_loc;
      --la localizzazione non esiste per la lingua di default
      if ( counter = 0 ) then
        select count(1) into counter from ems_i18n_message t where t.language = lan_en_id and t.localization = ems_t_loc;
        --non esiste la localizzazione per la lingua inglese (EN), selezioniamo la prima disponibile
        if ( counter = 0 ) then
        dbms_output.put_line ( ems_t_loc );
          open cur_loc_def for select t.id from ems_i18n_message t where t.localization = ems_t_loc order by t.language;
          fetch cur_loc_def into ems_i18n_id;
          close cur_loc_def;
          
          insert into ems_i18n_message ( id, localization, language, message )
          select ems_i18n_message_seq.nextval, ems_t_loc, lan_en_id, t.message from ems_i18n_message t
          where t.id = ems_i18n_id;
        end if;
      else
        select count(1) into counter from ems_i18n_message t where t.language = lan_en_id and t.localization = ems_t_loc;
        --non esiste la localizzazione per la lingua inglese (EN)
        if ( counter = 0 ) then
          insert into ems_i18n_message ( id, localization, language, message )
          select ems_i18n_message_seq.nextval, ems_t_loc, lan_en_id, t.message from ems_i18n_message t
          where t.language = lan_def_id and t.localization = ems_t_loc;
        end if;
      end if;
    end if;

    open cur_lan for select t.id from ems_language t where t.language_status = 1;
    loop
      fetch cur_lan into lan_id;
      exit when cur_lan%NOTFOUND;
      
      select count(1) into counter from ems_i18n_message t where t.localization = ems_t_loc and t.language = lan_id;
      if ( counter = 0 ) then
        insert into ems_i18n_message ( id, localization, language, message )
        select ems_i18n_message_seq.nextval, ems_t_loc, lan_id, t.message from ems_i18n_message t
        where t.language = lan_en_id and t.localization = ems_t_loc;
      end if;
    end loop;
    close cur_lan;
  end loop;
  close cur_ems_t;
end;
/
commit;
