--CREATE A TABLE AND ITS CONSTRAINTS
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'INTERNAL_LOCK';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tables t where t.owner = curr_user and t.table_name = tab_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'CREATE TABLE INTERNAL_LOCK
(
  KEY                            VARCHAR2(256 CHAR),
  LAST_MOD_TIME                  DATE,
  ID                             NUMBER(16)
)
TABLESPACE &DATA_TABLESPACE
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

grant select, insert, update, delete, references on INTERNAL_LOCK to AA;
grant select, insert, update, delete, references on INTERNAL_LOCK to IDEAS;
grant select, insert, update, delete, references on INTERNAL_LOCK to IDEAS_CONNECTOR;
grant select on INTERNAL_LOCK to IDEAS_REPORT;
