--CREATE A TABLE AND ITS CONSTRAINTS
set verify off
set serveroutput on
declare
  curr_user         varchar(30);
  
  tab_name          varchar(30) := 'INTERNAL_LOCK';
  dml_def           varchar(4000);
  
  counter           numeric(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from sysibm.tables t where ( t.table_type = 'BASE TABLE' or t.table_type is null ) and lower ( t.table_schema ) = lower ( curr_user ) and t.table_name = tab_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'CREATE TABLE INTERNAL_LOCK
(
  KEY                            VARCHAR(256),
  LAST_MOD_TIME                  DATE,
  ID                             NUMERIC(16)
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
commit;
set serveroutput off
set verify on

grant select, insert, update, delete, references on INTERNAL_LOCK to &AA_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on INTERNAL_LOCK to &IDEAS_SUPER_ADMIN_USER;
grant select, insert, update, delete, references on INTERNAL_LOCK to &IDEAS_CONN_SUPER_ADMIN_USER;
grant select on INTERNAL_LOCK to &IDEAS_REPORT_SUPER_ADMIN_USER;
