declare
  loc_code         varchar2(256) := 'batch.phone.numeric';

  counter          number(16);
begin
  select count(1) into counter from localization where lower ( code ) = lower ( loc_code );
  if ( counter = 1 ) then 
    delete from localization where lower ( code ) = lower ( loc_code );
  end if;
end;
/
commit;

declare
  rq_id            number(16);
  rq_name          varchar2(256) := 'User. Export';
  rqf_name         varchar2(256) := 'BATCH_PHONE_NUMBER';
  loc_code         varchar2(256) := 'batch.phone.numeric';

  counter          numeric(16);
begin
  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );
  else
    return;
  end if;

  select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name )
  and lower ( t.title ) = lower ( loc_code );
  if ( counter = 1 ) then
    delete from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name )
    and lower ( t.title ) = lower ( loc_code );
  end if;
end;
/
commit;

declare
  counter          number(16);

  rq_id            number(16);
  rq_name_old      varchar2(256) := 'User. Export';
  rq_name          varchar2(256) := 'User. Export';
  rq_desc          varchar2(512) := '';
  rqd              clob;

  rqf_type_def     varchar2(256) := 'java.lang.String';
  rqf_width_def    number(16) := 300;

  rqf_id           number(16);
  rqf_name_old     varchar2(256);
  rqf_name         varchar2(256);
  rqf_type         varchar2(256);
  rqf_width        number(16);
  rqf_ord_by       number(1);
  rqf_ord_by_clau  varchar2(256);
  rqf_ord_pos      number(16);
  loc_id           number(16);
  loc_code_old     varchar2(256);
  loc_code         varchar2(256);
  i18n_msg         varchar2(256);
  repf_pos_id      number(16);
  repf_pos_id_old  number(16);

  --Si puo' modificare un campo esistente, se null si inserisce
  rqf_name1_old    varchar2(256) := 'BATCH_PHONE_numeric';
  rqf_name1        varchar2(256) := 'BATCH_PHONE_NUMBER';
  rqf_type1        varchar2(256) := rqf_type_def;
  rqf_width1       varchar2(256) := rqf_width_def;
  rqf_ord_by1      number(1)     := 0;
  rqf_ord_by_clau1 varchar2(256) := 'ASC';
  --Si puo' modificare un campo esistente, se null si inserisce
  loc_code1_old    varchar2(256) := 'batch.phone.numeric';
  loc_code1        varchar2(256) := 'batch.phone.number';
  i18n_msg1        varchar2(256) := 'PHONE_NUMBER';
  --Si puo' scegliere la posizione della colonna nel report. Gli indici iniziano da 0
  --Se il campo e' null viene lasciato per ultimo
  repf_pos_id1     number(16)    := 7;

  repfr_id         number(16);
  repfr_name_old   varchar2(256);
  repfr_name       varchar2(256);
  repfr_value      varchar2(256);
  repfr_l_id       number(16);
  repfr_l_code_old varchar2(256);
  repfr_l_code     varchar2(256);
  repfr_i18n_msg   varchar2(256);
  repfr_vis        number(16);
  repfr_mand       number(16);
  repfr_type       number(16);
  repfr_cust_id    number(16);
  repfr_cust_name  varchar2(256);
  repfr_pos_id     number(16);
  repfr_pos_id_old number(16);

  cur_lan          sys_refcursor;
  lan_id           number(16);
  
  cur_rep          sys_refcursor;
  rep_id           number(16);

begin
  rqd := 'select distinct p.code           as BATCH_CODE,
                p.surname        as BATCH_SURNAME,
                p.name           as BATCH_NAME,
                p.sex            as BATCH_SEX,
                ou.code          as BATCH_OU,
                pt.name          as BATCH_USER_TYPE,
                p.email          as BATCH_EMAIL,
                p.phone_number   as BATCH_PHONE_NUMBER,
                p.dn             as BATCH_DN,
                p.cod_fisc       as BATCH_FISCAL_CODE,
                p.date_of_birth  as BATCH_DATE_OF_BIRTH,
                p.place_of_birth as BATCH_PLACE_OF_BIRTH,
                p.address        as BATCH_ADDRESS,
                p.locality       as BATCH_CITY,
                p.nation         as BATCH_STATE,
                p.country        as BATCH_COUNTRY,
                p.zipcode        as BATCH_POSTAL_CODE
  from #pmschema#.person p
  left outer join #pmschema#.person_type pt on p.type = pt.id
  left outer join #pmschema#.group_person gp on p.id = gp.person
  left outer join #pmschema#.organizational_unit ou on gp.organizational_unit = ou.id
 where gp.hierarchy = ou.hierarchy
   and ou.hierarchy = 1
';

  --sezione query
  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );
    
    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
  --modifica il nome della query
  if ( rq_name <> rq_name_old ) then
    update r_query set name = rq_name where name = rq_name_old;
  end if;

  --QUERY FIELD 1: BEGIN
  rqf_id          := null;
  rqf_name_old    := rqf_name1_old;
  rqf_name        := rqf_name1;
  rqf_type        := rqf_type1;
  rqf_width       := rqf_width1;
  rqf_ord_by      := rqf_ord_by1;
  rqf_ord_by_clau := rqf_ord_by_clau1;
  rqf_ord_pos     := null;
  loc_id          := null;
  loc_code_old    := loc_code1_old;
  loc_code        := loc_code1;
  i18n_msg        := i18n_msg1;
  repf_pos_id_old := null;
  repf_pos_id     := repf_pos_id1;
    
  if ( rqf_name_old is null or rqf_name_old = rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 0 ) then
      select r_query_field_seq.nextval into rqf_id from dual;

      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  elsif ( rqf_name_old is not null and rqf_name_old <> rqf_name ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name_old );
      update r_query_field set column_name = rqf_name where id = rqf_id;
    end if;
  end if;
  if ( rqf_id is null ) then
    select count(1) into counter from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    if ( counter = 1 ) then
      select t.id into rqf_id from r_query_field t where t.r_query = rq_id and lower ( t.column_name ) = lower ( rqf_name );
    else
      select r_query_field_seq.nextval into rqf_id from dual;

      insert into r_query_field ( id, r_query, column_name, title, type, width )
      values ( rqf_id, rq_id, rqf_name, loc_code, rqf_type, rqf_width );
    end if;
  end if;

  if ( loc_code_old is null or loc_code_old = loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 0 ) then
      select localization_seq.nextval into loc_id from dual;

      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  elsif ( loc_code_old is not null and loc_code_old <> loc_code ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code_old );
    if ( counter = 1 ) then
      select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code_old );
      update localization set code = loc_code where id = loc_id;
      update r_query_field set title = loc_code where id = rqf_id;
    end if;
  end if;
  if ( loc_id is null ) then
    select count(1) into counter from localization t where lower ( t.code ) = lower ( loc_code );
    if ( counter = 1 ) then
      select t.id into loc_id from localization t where lower ( t.code ) = lower ( loc_code );
    else
      select localization_seq.nextval into loc_id from dual;

      insert into localization ( id, code, code_type )
      values ( loc_id, loc_code, 0 );
    end if;
  end if;

  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;

    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18n_msg );
    else
      update i18n_message set message = i18n_msg where language = lan_id and localization = loc_id;
    end if;

  end loop;
  close cur_lan;

  open cur_rep for select t.id from report t where t.r_query = rq_id;
  loop
    fetch cur_rep into rep_id;
    exit when cur_rep%NOTFOUND;

    select count(1) into counter from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
    if ( counter = 0 ) then
      if ( repf_pos_id is null ) then
        select max ( t.position ) + 1 into repf_pos_id from report_field t where t.report = rep_id;
        if ( repf_pos_id is null ) then
          repf_pos_id := 0;
        end if;
      else
        select count(1) into counter from report_field t where t.report = rep_id and position = repf_pos_id;
        if ( counter > 0 ) then
          --modificare le posizioni del corrente e dei successivi
          update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id;
        end if;
      end if;

      if ( rqf_ord_by = 1 ) then
        select max(t.order_by) + 1 into rqf_ord_pos from report_field t where t.report = rep_id;
        if ( rqf_ord_pos is null ) then
          rqf_ord_pos := 0;
        end if;
      else
        rqf_ord_by_clau := null;
      end if;

      insert into report_field ( id, report, r_query_field, localization, width, position, order_by, order_by_clause )
      values ( report_field_seq.nextval, rep_id, rqf_id, loc_id, rqf_width, repf_pos_id, rqf_ord_pos, rqf_ord_by_clau );
    elsif ( counter = 1 and repf_pos_id is not null ) then
      select t.position into repf_pos_id_old from report_field t where t.report = rep_id and t.r_query_field = rqf_id;
      --spostiamo il campo in una posizione speciale
      update report_field set position = -1 where report = rep_id and position = repf_pos_id_old;
      if ( repf_pos_id_old > repf_pos_id ) then
        update report_field set position = ( position + 1 ) where report = rep_id and position >= repf_pos_id and position <= repf_pos_id_old;
      else
        update report_field set position = ( position - 1 ) where report = rep_id and position >= repf_pos_id_old and position <= repf_pos_id;
      end if;
      --spostiamo il campo in una posizione finale
      update report_field set position = repf_pos_id where report = rep_id and position = -1;
    end if;

    update report_field set width = rqf_width where report = rep_id;
  end loop;
  close cur_rep;
  --QUERY FIELD 1: END

end;
/

commit;
