create or replace function inst_rep_add_vis
(
  r_id                 in number,
  rq_id                in number,
  rv_name              in varchar2,
  repv_vis_type        in number
)
return number is
  rv_id                number(16);
  rv_ent_id            number(16);
  rq_vis_pos           number(16);

  counter              number(16);
begin
  select count (1) into counter from r_visibility rv where lower ( rv.name ) = lower ( rv_name );
  if ( counter = 1 ) then
    select rv.id, rv.entity into rv_id, rv_ent_id from r_visibility rv where lower ( rv.name ) = lower ( rv_name );

    --QUERY VISIBILITY
    select count(1) into counter from r_query_visibility rqv where rqv.r_query = rq_id and rqv.r_visibility = rv_id;

    if ( counter = 0 ) then
      select max ( rqv.position ) + 1 into rq_vis_pos from r_query_visibility rqv where rqv.r_query = rq_id and rqv.r_visibility = rv_id;
      if ( rq_vis_pos is null ) then
        rq_vis_pos := 0;
      end if;
      insert into r_query_visibility ( id, r_query, r_visibility, position )
      values ( r_query_visibility_seq.nextval, rq_id, rv_id, rq_vis_pos );
    end if;

    --REPORT VISIBILITY
    select count(1) into counter from report_visibility rv where rv.report = r_id and rv.r_visibility = rv_id;

    if ( counter = 0 ) then
      insert into report_visibility ( id, report, entity, vis_type, r_visibility )
      values ( report_visibility_seq.nextval, r_id, rv_ent_id, repv_vis_type, rv_id );
    end if;
  end if;
  
  return 0;
end inst_rep_add_vis;
/

GRANT EXECUTE ON inst_rep_add_vis TO ideas_report;
