declare
  rv_ent_id   number(16);
  rv_ent_name varchar2(256) := 'System';
  rv_ent_sort number(16);

  rv_id       number(16);
  rv_name     varchar2(256) := 'AG-Core Hierarchy Scope';
  rv_desc     varchar2(256) := 'AG-Core Hierarchy Scope';

  counter     number(16);

  rv_data     clob;
begin
  rv_data := 'insert into #schema_tmp#.tmp_rep_organizational_unit
'||'select t.id from #pmschema#.organizational_unit t where t.hierarchy in ( $ )
'||'';

  select count(1) into counter from entity t where lower ( t.name ) = lower ( rv_ent_name );
  if ( counter = 0 ) then
    select ( max(id) + 1 ) into rv_ent_id from entity t where t.id < 100;
    select ( max(sort) + 1 ) into rv_ent_sort from entity t;
    
    insert into entity ( id, name, sort )
    values ( rv_ent_id, rv_ent_name, rv_ent_sort );
  else
    select t.id into rv_ent_id from entity t where lower ( t.name ) = lower ( rv_ent_name );
  end if;

  select count(1) into counter from r_visibility t where lower ( t.name ) = lower ( rv_name );
  if ( counter = 0 ) then
    select ( max(id) + 1 ) into rv_id from r_visibility t where t.id < 100;

    insert into r_visibility ( id, name, description, entity, product )
    values ( rv_id, rv_name, rv_desc, rv_ent_id, 1 );

    insert into r_visibility_data ( r_visibility, query )
    values ( rv_id, rv_data );
  else
    select t.id into rv_id from r_visibility t where lower ( t.name ) = lower ( rv_name );

    update r_visibility_data set query = rv_data where r_visibility = rv_id;
  end if;

end;
/

commit;
