declare
  counter              numeric(16);

  --report type
  rt_id                numeric(16);
  rt_name              varchar(256) := 'Status';
  rt_desc              varchar(512) := '';

  --report parent
  rp_id                numeric(16);
  rp_name              varchar(256) := '';

  r_id                 numeric(16);
  r_name_old           varchar(256) := 'Activities by user';
  r_name               varchar(256) := 'Activities by user';
  r_desc               varchar(512) := 'Business Activity - Users (who does the activities)';
  r_code               varchar(256) := null;
  r_i18n_mess          varchar(256) := null;
  --se 0 e' un report, se 1 e' un dashboard
  r_dashboard          numeric(1) := 0;

  r_loc_id             numeric(16);
  r_loc_code           varchar(256);

  r_rename             boolean := false;

  rq_id                numeric(16);
  rq_name_old          varchar(256) := 'Activities by user';
  rq_name              varchar(256) := 'Activities by user';
  rq_desc              varchar(512) := 'Business Activity - Users (who does the activities)';
  rqd                  clob;

  rq_rename            boolean := false;

  rv_name              varchar(256);
  repv_vis_type        numeric(2);

  rqf_type_def         varchar(256) := 'java.lang.String';
  rqf_width_def        numeric(16) := 300;

  rqf_name_old         varchar(256);
  rqf_name             varchar(256);
  rqf_type             varchar(256);
  rqf_width            numeric(16);
  rqf_ord_by           numeric(1);
  rqf_ord_by_clau      varchar(256);
  loc_code_old         varchar(256);
  loc_code             varchar(256);
  loc_rename           boolean;
  i18n_msg             varchar(256);
  repf_pos_id          numeric(16);
  repf_pos_id_old      numeric(16);

  --ra_id                numeric(16);
  --ra_name              varchar(256);
  --ra_value             varchar(256);

  --repfr_name_old       varchar(256);
  --repfr_name           varchar(256);
  --repfr_value          varchar(256);
  --repfr_l_code_old     varchar(256);
  --repfr_l_code         varchar(256);
  --repfr_i18n_msg       varchar(256);
  --repfr_vis            numeric(16);
  --repfr_mand           numeric(16);
  --repfr_type           numeric(16);
  --repfr_cust_name      varchar(256);
  --repfr_pos_id         numeric(16);
  --repfr_pos_id_old     numeric(16);

  cur_lan              sys_refcursor;
  lan_id               numeric(16);

  v_ret                numeric(16);
begin
  rqd := 'select distinct
'||'  t.name as ACTIVITY_NAME,
'||'  t.code as ACTIVITY_CODE,
'||'  t.description as ACTIVITY_DESC,
'||'  p.name as USER_NAME,
'||'  p.surname as USER_SURNAME,
'||'  p.email as USER_EMAIL,
'||'  p.dn as USER_DN,
'||'  p.cod_fisc as USER_SSN,
'||'  case
'||'    when p.sex=''0'' then ''Male''
'||'    when p.sex=''1'' then ''Female''
'||'  end as USER_GENDER,
'||'  tp.last_mod_time as CALC_DATE
'||'from
'||'  #pmschema#.environment env,
'||'  #pmschema#.task t,
'||'  #pmschema#.task_person tp,
'||'  #pmschema#.person p,
'||'  #pmschema#.group_person gp,
'||'  #schema#.tmp_rep_organizational_unit tmpou
'||'where
'||'  env.id = t.environment
'||'  and t.id = tp.task
'||'  and tp.person = p.id
'||'  and p.id = gp.person
'||'  and gp.organizational_unit = tmpou.id
'||'  and gp.hierarchy = 1
'||'  and env.working = 1
'||'';

  --sezione query
  if ( rq_name <> rq_name_old ) then
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name_old ) and t.product = 1;
    if ( counter = 1 ) then
      rq_rename := true;
    end if;
  end if;

  if ( rq_rename = true ) then
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name_old ) and t.product = 1;
  else
    select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name ) and t.product = 1;
  end if;
  if ( counter = 0 ) then
    select max(id) + 1 into rq_id from r_query t;

    insert into r_query ( id, name, description, product )
    values ( rq_id, rq_name, rq_desc, 1 );

    insert into r_query_data ( r_query, query )
    values ( rq_id, rqd );
  else
    if ( rq_rename = true ) then
      select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name_old ) and t.product = 1;
    else
      select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name ) and t.product = 1;
    end if;

    update r_query_data set query = rqd where r_query = rq_id;
  end if;

  --modifica il nome della query
  if ( rq_rename = true ) then
    update r_query set name = rq_name where id = rq_id;
  end if;

  --sezione report
  if ( r_name <> r_name_old ) then
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name_old ) and t.dashboard = r_dashboard and t.product = 1;
    if ( counter = 1 ) then
      r_rename := true;
    end if;
  end if;

  if ( r_rename = true ) then
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name_old ) and t.dashboard = r_dashboard and t.product = 1;
  else
    select count(1) into counter from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard and t.product = 1;
  end if;
  if ( counter = 0 ) then
    --localization code for report
    if ( r_loc_code is null ) then
      /*DBALT-BEGIN*/
      /*select dbms_random.random into r_loc_code from dual;*/
      /*PG*select trunc(random()*1000) into r_loc_code from generate_series(1,1000) limit 1;*PG*/
      select int((rand()-0.5) * 32768) into r_loc_code from dual;
      /*DBALT-END*/

      select count(1) into counter from localization t where lower ( t.code ) = lower ( r_loc_code );
      if ( counter = 0 ) then
        select localization_seq.nextval into r_loc_id from dual;

        insert into localization ( id, code, code_type )
        values ( r_loc_id, r_loc_code, 0 );
      end if;
    elsif ( r_loc_code is not null ) then
      select count(1) into counter from localization t where lower ( t.code ) = lower ( r_loc_code );
      if ( counter = 1 ) then
        select t.id into r_loc_id from localization t where lower ( t.code ) = lower ( r_loc_code );
      end if;
    end if;
    if ( r_loc_id is null ) then
      select t.id into r_loc_id from localization t where lower ( t.code ) = lower ( r_loc_code );
    end if;

    select max(id) + 1 into r_id from report t;

    if ( rt_name is not null or length ( rt_name ) > 0 ) then
      select count(1) into counter from report_type t where lower ( t.name ) = lower ( rt_name );
      if ( counter = 0 ) then
        select ( max(id) +1 ) into rt_id from report_type t;

        insert into report_type ( id, name, description )
        values ( rt_id, rt_name, rt_desc );
      else
        select t.id into rt_id from report_type t where lower ( t.name ) = lower ( rt_name );
      end if;
    end if;


    insert into report ( id, name, description, localization, r_query, status, report_type, code, product, parent, dashboard )
    values ( r_id, r_name, r_desc, r_loc_id, rq_id, 0, rt_id, r_code, 1, 1, r_dashboard );

    insert into report_attribute ( id, report, name, value )
    values ( report_attribute_seq.nextval, r_id, 'PRIORITY', '0' );
    if ( r_dashboard = 0 ) then
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'ORIENTATION', '1' );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'MAX_ROW', null );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'FORMAT', 'pdf' );
      insert into report_attribute ( id, report, name, value )
      values ( report_attribute_seq.nextval, r_id, 'FORMAT', 'xlsx' );
    elsif ( r_dashboard = 1 ) then
      null;
    end if;
  else
    --ORACLE BUG ON REPORT_LNAME_DASHBOARD_IDX INDEX
    --ORA-03113 end-of-file on communication channel
    --caused by
    --ORA-07445: trovata eccezione: dump della memoria [qcdlgcd()+70] [SIGSEGV] [ADDR:0x4] [PC:0xCEA8796] [Address not mapped to object] []
    if ( r_rename = true ) then
      select t.id, t.name into r_id, r_name_old from report t where lower ( t.name ) = lower ( r_name_old ) and t.dashboard = r_dashboard and t.product = 1;
    else
      select t.id, t.name into r_id, r_name from report t where lower ( t.name ) = lower ( r_name ) and t.dashboard = r_dashboard and t.product = 1;
    end if;

    select t.localization into r_loc_id from report t where t.id = r_id;
  end if;

  if ( r_i18n_mess is null or length ( r_i18n_mess ) = 0 ) then
    r_i18n_mess := r_name;
  end if;

  --modifica il nome del report
  if ( r_rename = true ) then
    update report set name = r_name where id = r_id;
    update i18n_message set message = r_i18n_mess where localization = ( select t.localization from report t where t.id = r_id );
  end if;

  --inserimento o modifica dei messaggi di localizzazione
  open cur_lan for select t.id from language t where t.language_status > 0;
  loop
    fetch cur_lan into lan_id;
    exit when cur_lan%NOTFOUND;

    select count(1) into counter from i18n_message t where t.language = lan_id and t.localization = r_loc_id;
    if ( counter = 0 ) then
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, r_loc_id, lan_id, r_i18n_mess );
    else
      update i18n_message set message = r_i18n_mess where language = lan_id and localization = r_loc_id;
    end if;

  end loop;
  close cur_lan;

  --report parent
  select count(1) into counter from (
    select distinct r.id from report r, localization l, i18n_message i18
    where r.localization = l.id and r.leaf = 0 and l.id = i18.localization
    and i18.message = rp_name and r.dashboard = r_dashboard ) t;
  if ( counter = 1 ) then
    select distinct r.id into rp_id from report r, localization l, i18n_message i18
    where r.localization = l.id and r.leaf = 0 and l.id = i18.localization
    and i18.message = rp_name and r.dashboard = r_dashboard;

    update report set parent = rp_id where id = r_id;
  end if;

  --QUERY FIELD 01: BEGIN
  rqf_name_old    := null;
  rqf_name        := 'ACTIVITY_NAME';
  rqf_type        := rqf_type_def;
  rqf_width       := rqf_width_def;
  rqf_ord_by      := 0;
  rqf_ord_by_clau := null;
  loc_code_old    := null;
  loc_code        := 'activity.name';
  loc_rename      := true;
  i18n_msg        := 'Activity Name';
  repf_pos_id_old := null;
  repf_pos_id     := null;

  v_ret := inst_rep_add_col ( rq_id, rqf_name_old, rqf_name, rqf_type, rqf_width, rqf_ord_by, rqf_ord_by_clau,
                              loc_code_old, loc_code, loc_rename, i18n_msg, repf_pos_id_old, repf_pos_id );

  --QUERY FIELD 02: BEGIN
  rqf_name_old    := null;
  rqf_name        := 'ACTIVITY_CODE';
  rqf_type        := rqf_type_def;
  rqf_width       := rqf_width_def;
  rqf_ord_by      := 0;
  rqf_ord_by_clau := null;
  loc_code_old    := null;
  loc_code        := 'activity.code';
  loc_rename      := true;
  i18n_msg        := 'Activity Code';
  repf_pos_id_old := null;
  repf_pos_id     := null;

  v_ret := inst_rep_add_col ( rq_id, rqf_name_old, rqf_name, rqf_type, rqf_width, rqf_ord_by, rqf_ord_by_clau,
                              loc_code_old, loc_code, loc_rename, i18n_msg, repf_pos_id_old, repf_pos_id );

  --QUERY FIELD 03: BEGIN
  rqf_name_old    := null;
  rqf_name        := 'ACTIVITY_DESC';
  rqf_type        := rqf_type_def;
  rqf_width       := rqf_width_def;
  rqf_ord_by      := 0;
  rqf_ord_by_clau := null;
  loc_code_old    := null;
  loc_code        := 'activity.desc';
  loc_rename      := true;
  i18n_msg        := 'Activity Descr.';
  repf_pos_id_old := null;
  repf_pos_id     := null;

  v_ret := inst_rep_add_col ( rq_id, rqf_name_old, rqf_name, rqf_type, rqf_width, rqf_ord_by, rqf_ord_by_clau,
                              loc_code_old, loc_code, loc_rename, i18n_msg, repf_pos_id_old, repf_pos_id );

  --QUERY FIELD 04: BEGIN
  rqf_name_old    := null;
  rqf_name        := 'USER_NAME';
  rqf_type        := rqf_type_def;
  rqf_width       := rqf_width_def;
  rqf_ord_by      := 0;
  rqf_ord_by_clau := null;
  loc_code_old    := null;
  loc_code        := 'user.name';
  loc_rename      := true;
  i18n_msg        := 'First Name';
  repf_pos_id_old := null;
  repf_pos_id     := null;

  v_ret := inst_rep_add_col ( rq_id, rqf_name_old, rqf_name, rqf_type, rqf_width, rqf_ord_by, rqf_ord_by_clau,
                              loc_code_old, loc_code, loc_rename, i18n_msg, repf_pos_id_old, repf_pos_id );

  --QUERY FIELD 05: BEGIN
  rqf_name_old    := null;
  rqf_name        := 'USER_SURNAME';
  rqf_type        := rqf_type_def;
  rqf_width       := rqf_width_def;
  rqf_ord_by      := 0;
  rqf_ord_by_clau := null;
  loc_code_old    := null;
  loc_code        := 'user.surname';
  loc_rename      := true;
  i18n_msg        := 'Last Name';
  repf_pos_id_old := null;
  repf_pos_id     := null;

  v_ret := inst_rep_add_col ( rq_id, rqf_name_old, rqf_name, rqf_type, rqf_width, rqf_ord_by, rqf_ord_by_clau,
                              loc_code_old, loc_code, loc_rename, i18n_msg, repf_pos_id_old, repf_pos_id );

  --QUERY FIELD 06: BEGIN
  rqf_name_old    := null;
  rqf_name        := 'USER_EMAIL';
  rqf_type        := rqf_type_def;
  rqf_width       := rqf_width_def;
  rqf_ord_by      := 0;
  rqf_ord_by_clau := null;
  loc_code_old    := null;
  loc_code        := 'user.email';
  loc_rename      := true;
  i18n_msg        := 'Email';
  repf_pos_id_old := null;
  repf_pos_id     := null;

  v_ret := inst_rep_add_col ( rq_id, rqf_name_old, rqf_name, rqf_type, rqf_width, rqf_ord_by, rqf_ord_by_clau,
                              loc_code_old, loc_code, loc_rename, i18n_msg, repf_pos_id_old, repf_pos_id );

  --QUERY FIELD 07: BEGIN
  rqf_name_old    := null;
  rqf_name        := 'USER_DN';
  rqf_type        := rqf_type_def;
  rqf_width       := rqf_width_def;
  rqf_ord_by      := 0;
  rqf_ord_by_clau := null;
  loc_code_old    := null;
  loc_code        := 'user.dn';
  loc_rename      := true;
  i18n_msg        := 'User DN';
  repf_pos_id_old := null;
  repf_pos_id     := null;

  v_ret := inst_rep_add_col ( rq_id, rqf_name_old, rqf_name, rqf_type, rqf_width, rqf_ord_by, rqf_ord_by_clau,
                              loc_code_old, loc_code, loc_rename, i18n_msg, repf_pos_id_old, repf_pos_id );

  --QUERY FIELD 08: BEGIN
  rqf_name_old    := null;
  rqf_name        := 'USER_SSN';
  rqf_type        := rqf_type_def;
  rqf_width       := rqf_width_def;
  rqf_ord_by      := 0;
  rqf_ord_by_clau := null;
  loc_code_old    := null;
  loc_code        := 'user.ssn';
  loc_rename      := true;
  i18n_msg        := 'SSN Code';
  repf_pos_id_old := null;
  repf_pos_id     := null;

  v_ret := inst_rep_add_col ( rq_id, rqf_name_old, rqf_name, rqf_type, rqf_width, rqf_ord_by, rqf_ord_by_clau,
                              loc_code_old, loc_code, loc_rename, i18n_msg, repf_pos_id_old, repf_pos_id );

  --QUERY FIELD 09: BEGIN
  rqf_name_old    := null;
  rqf_name        := 'USER_GENDER';
  rqf_type        := rqf_type_def;
  rqf_width       := rqf_width_def;
  rqf_ord_by      := 0;
  rqf_ord_by_clau := null;
  loc_code_old    := null;
  loc_code        := 'user.gender';
  loc_rename      := true;
  i18n_msg        := 'Gender';
  repf_pos_id_old := null;
  repf_pos_id     := null;

  v_ret := inst_rep_add_col ( rq_id, rqf_name_old, rqf_name, rqf_type, rqf_width, rqf_ord_by, rqf_ord_by_clau,
                              loc_code_old, loc_code, loc_rename, i18n_msg, repf_pos_id_old, repf_pos_id );

  --QUERY FIELD 10: BEGIN
  rqf_name_old    := null;
  rqf_name        := 'CALC_DATE';
  rqf_type        := 'java.util.Date';
  rqf_width       := rqf_width_def;
  rqf_ord_by      := 0;
  rqf_ord_by_clau := null;
  loc_code_old    := null;
  loc_code        := 'calc.date';
  loc_rename      := true;
  i18n_msg        := 'Calculation Date';
  repf_pos_id_old := null;
  repf_pos_id     := null;

  v_ret := inst_rep_add_col ( rq_id, rqf_name_old, rqf_name, rqf_type, rqf_width, rqf_ord_by, rqf_ord_by_clau,
                              loc_code_old, loc_code, loc_rename, i18n_msg, repf_pos_id_old, repf_pos_id );

  --QUERY VISIBILITY AND REPORT VISIBILITY 01: BEGIN
  rv_name := 'AG-Core Org. Unit - Hierarchy';
  repv_vis_type := 3;

  v_ret := inst_rep_add_vis ( r_id, rq_id, rv_name, repv_vis_type );

end;
/
commit;
