declare
  cf_id            number(16);
  cf_name          varchar2(256) := 'EventIN-operation';
  cf_desc          varchar2(256) := '';

  cf_data          clob;

  counter          number(16);
begin
  cf_data := 'select distinct
'||'  p.operation as KEY,
'||'  case
'||'    when p.operation = ''1'' then ''Create User''
'||'    when p.operation = ''2'' then ''Modify User''
'||'    when p.operation = ''3'' then ''Remove User''
'||'    when p.operation = ''9'' then ''Create OU''
'||'    when p.operation = ''10'' then ''Modify Organizational Unit''
'||'    when p.operation = ''11'' then ''Remove Organizational Unit''
'||'    when p.operation = ''12'' then ''Move Employee''
'||'    when p.operation = ''99'' then ''Event Disabled''
'||'    when p.operation = ''101'' then ''Create User (Scheduled)''
'||'    when p.operation = ''102'' then ''Modify User (Scheduled)''
'||'    when p.operation = ''103'' then ''Remove User (Scheduled)''
'||'    when p.operation = ''109'' then ''Create OU (Scheduled)''
'||'    when p.operation = ''110'' then ''Modify OU (Scheduled)''
'||'    when p.operation = ''111'' then ''Remove OU (Scheduled)''
'||'    when p.operation = ''112'' then ''Move Employee (Scheduled)''
'||'    else ''UNKNOWN''
'||'  end as NAME,
'||'  p.operation as DESCRIPTION
'||'from
'||'  #pmschema#.event_in p
'||'';

  select count(1) into counter from custom_filter t where lower ( t.name ) = lower ( cf_name );
  if ( counter = 0 ) then
    select ( max(id) + 1 ) into cf_id from custom_filter t where t.id < 100;
    
    insert into custom_filter ( id, name, description, product )
    values ( cf_id, cf_name, cf_desc, 1 );
  else
    select t.id into cf_id from custom_filter t where lower ( t.name ) = lower ( cf_name );
  end if;

  select count(1) into counter from custom_filter_data t where t.custom_filter = cf_id;
  if ( counter = 0 ) then
    insert into custom_filter_data ( custom_filter, query )
    values ( cf_id, cf_data );
  else
    update custom_filter_data set query = cf_data where custom_filter = cf_id;
  end if;

end;
/

commit;
