declare
  cf_id            number(16);
  cf_name          varchar2(256) := 'EventTarget-operation';
  cf_desc          varchar2(256) := '';

  cf_data          clob;

  counter          number(16);
begin
  cf_data := 'select distinct
'||'  p.operation as KEY,
'||'  case
'||'    when p.operation = ''1'' then ''Add Entitlement to User''
'||'    when p.operation = ''2'' then ''Remove Entitlement to User''
'||'    when p.operation = ''3'' then ''Reset Password''
'||'    when p.operation = ''6'' then ''Disable Account''
'||'    when p.operation = ''7'' then ''Enable Account''
'||'    when p.operation = ''10'' then ''Create Account''
'||'    when p.operation = ''11'' then ''Remove Account''
'||'    when p.operation = ''20'' then ''Add Entitlement''
'||'    when p.operation = ''21'' then ''Remove Entitlement''
'||'    when p.operation = ''22'' then ''Add Profile to IT-Roles''
'||'    when p.operation = ''23'' then ''Remove Profile to IT-Roles''
'||'    else ''UNKNOWN''
'||'  end as NAME,
'||'  p.operation as DESCRIPTION
'||'from
'||'  #pmschema#.event_target p
'||'';

  select count(1) into counter from custom_filter t where lower ( t.name ) = lower ( cf_name );
  if ( counter = 0 ) then
    select ( max(id) + 1 ) into cf_id from custom_filter t where t.id < 100;
    
    insert into custom_filter ( id, name, description, product )
    values ( cf_id, cf_name, cf_desc, 1 );
  else
    select t.id into cf_id from custom_filter t where lower ( t.name ) = lower ( cf_name );
  end if;

  select count(1) into counter from custom_filter_data t where t.custom_filter = cf_id;
  if ( counter = 0 ) then
    insert into custom_filter_data ( custom_filter, query )
    values ( cf_id, cf_data );
  else
    update custom_filter_data set query = cf_data where custom_filter = cf_id;
  end if;

end;
/

commit;
