declare
  rq_id            number(16);
  rq_name          varchar2(256) := 'ARCS - SAP authorization Risk overview';
  rq_desc          varchar2(512) := '';
  rqd              clob;

  counter          number(16);
begin
  rqd := 'select distinct app.name as SAP_SYSTEM_NAME,
'||'                ent.name as ENTITLEMENT_NAME,
'||'                ent.description as ENTITLEMENT_DESC,
'||'                case
'||'                  when ent.int_type = 1 then ''SAP Authorization''
'||'                  when ent.int_type = 2 and ri.family_id = 1 then ''SAP Role''
'||'                  when ent.int_type = 2 and ri.family_id = 2 then ''Collective Role''
'||'                  when ent.int_type = 2 and ri.family_id = 3 then ''Cluster Role''
'||'                  when ent.int_type = 3 then ''Business Role''
'||'                end as ENTITLEMENT_TYPE,
'||'                pro.name as SAP_AUTHORIZATION_NAME,
'||'                dom.name as DOMAIN_NAME,
'||'                dom.description as DOMAIN_DESC,
'||'                t.name as ACTIVITY_NAME,
'||'                t.description as ACTIVITY_DESC,
'||'                r.name as RISK_NAME,
'||'                rt.name as RISK_TYPE,
'||'                ri.risk_severity as SEVERITY
'||'  from
'||'    (
'||'      select
'||'        ri.environment, ri.entity, ri.entity_type, ri.domain, ri.rem_under,
'||'        ri.rem_ok, ri.rem_over, ri.random_code, ri.risk, ri.task, ri.entitlement,
'||'        ri.profile, ri.risk_severity, ri.ume_list, pr.application, entf.id as family_id, entf.name as family_name
'||'      from
'||'        #ccsschema_tmp#.tmp_report_incomp ri,
'||'        #ccsschema#.entitlement       pr,
'||'        #ccsschema#.entitlement       ent
'||'        left outer join #ccsschema#.entitlement_family   entf
'||'        on ent.family = entf.id
'||'      where ri.profile = pr.id and ri.entity = ent.id
'||'    ) ri,
'||'       #ccsschema_tmp#.tmp_report_entitlement tmp_ent,
'||'       #ccsschema#.entitlement         ent,
'||'       #ccsschema#.application         app,
'||'       #ccsschema#.entitlement         pro,
'||'       #ccsschema#.domain              dom,
'||'       #ccsschema#.risk                r,
'||'       #ccsschema#.task                t,
'||'       #ccsschema#.risk_type           rt
'||' where ri.random_code = ''#random_code#''
'||'   and ri.entity_type = 1
'||'   and ri.entity = ent.id
'||'   and ent.id = tmp_ent.id
'||'   and tmp_ent.application = app.id
'||'   and ri.profile = pro.id
'||'   and ri.environment = dom.environment
'||'   and dom.environment = r.environment
'||'   and r.environment = rt.environment
'||'   and rt.environment = t.environment
'||'   and ri.task = t.id
'||'   and ri.domain = dom.id
'||'   and ri.risk = r.id
'||'   and r.risk_type = rt.id
'||'   and ent.int_type = 1
'||'   and lower ( app.name ) = lower ( ''#sap_system_name#'' )
'||'';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;
