declare
  rq_id            numeric(16);
  rq_name          varchar(256) := 'SAP Authorization Definition';
  rq_desc          varchar(512) := '';
  rqd              clob;

  counter          numeric(16);
begin
  rqd := 'select a.name as SAP_SYSTEM_NAME,
'||'       p.name as SAP_AUTHORIZATION_NAME,
'||'       pt.attr1 as SAP_TRANSACTION_NAME,
'||'       case
'||'         when pg.condition = 0 then ''OR''
'||'         when pg.condition = 1 then ''AND''
'||'         else ''N/A''
'||'       end as SAP_RISK_COND,
'||'       pao.id SAP_AUTHOBJ_GROUP,
'||'       ao.name as SAP_AUTHOBJ_NAME,
'||'       case
'||'         when pao.condition = 0 then ''OR''
'||'         when pao.condition = 1 then ''AND''
'||'         else ''N/A''
'||'       end as SAP_AUTHOBJ_RISK_COND,
'||'       paof.id as SAP_FIELD_GROUP,
'||'       paof.attr1 as SAP_FIELD_NAME,
'||'       case
'||'         when paof.attr3 = ''0'' then ''Any From''
'||'         when paof.attr3 = ''1'' then ''None From''
'||'         when paof.attr3 = ''2'' then ''Any But''
'||'         when paof.attr3 = ''3'' then ''All Into''
'||'         else ''N/A''
'||'       end as SAP_FIELD_RISK_COND,
'||'       paofv.attr1 as SAP_FIELD_VALUE,
'||'       t.path || ''/'' || t.name as ACTIVITY_NAME,
'||'       ( t.id - cast ( ''#arcs_sod_code#'' as numeric ) ) as SOD_CODE,
'||'       case
'||'         when pao_cnt.cnt > 1 then ''CHECK ON THE CONSOLE''
'||'       end as console
'||'  from #ccsschema#.application         a,
'||'       #ccsschema#.entitlement         p,
'||'       #ccsschema#.profile_group       pg,
'||'       #ccsschema#.profile_group       pt,
'||'       #ccsschema#.profile_group       pao,
'||'       #ccsschema#.profile_group       paof,
'||'       #ccsschema#.profile_group       paofv,
'||'       (
'||'         select t.profile, t.auth_obj, count(1) as cnt from
'||'         (
'||'           select distinct pg.profile, cast ( pao.value as numeric ) as auth_obj
'||'             from #ccsschema#.profile_group pg,
'||'                  #ccsschema#.profile_group pt,
'||'                  #ccsschema#.profile_group pao
'||'            where pg.type = 5
'||'              and pt.type = 4
'||'              and pao.type = 3
'||'              and pg.id = pt.parent
'||'              and pt.id = pao.parent
'||'         ) t
'||'         group by t.profile, t.auth_obj
'||'       ) pao_cnt,
'||'       #ccsschema#.authobj          ao,
'||'       #ccsschema#.task_profile     tp,
'||'       #ccsschema#.task             t,
'||'       #ccsschema#.environment      e
'||' where a.id = p.application
'||'   and p.id = pg.profile
'||'   and pg.profile = pao_cnt.profile
'||'   and pg.id = pt.parent
'||'   and pt.id = pao.parent
'||'   and pao.id = paof.parent
'||'   and paof.id = paofv.parent
'||'   and cast ( pao.value as numeric ) = pao_cnt.auth_obj
'||'   and cast ( pao.value as numeric ) = ao.id
'||'   and p.application = ao.application
'||'   and p.id = tp.profile
'||'   and tp.environment = e.id
'||'   and e.working = 1
'||'   and tp.task = t.id
'||'   and tp.environment = t.environment
'||'   and lower ( a.name ) = lower ( ''#sap_system_name#'' )
'||'   and pg.type = 5
'||'   and pt.type = 4
'||'   and pao.type = 3
'||'   and paof.type = 2
'||'   and paofv.type = 1
'||'';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;
