declare
  rq_id            number(16);
  rq_name          varchar2(256) := 'Activities by group';
  rq_desc          varchar2(512) := 'Business Activity - Groups (where the activities are done)';
  rqd              clob;

  counter          number(16);
begin
  rqd := 'select distinct
'||'  t.name as ACTIVITY_NAME,
'||'  t.code as ACTIVITY_CODE,
'||'  t.description as ACTIVITY_DESC,
'||'  h.name as HIERARCHY,
'||'  ou.name as GROUP_NAME,
'||'  ou.code as GROUP_CODE,
'||'  ou.description as GROUP_DESC,
'||'  tg.last_mod_time as CALC_DATE
'||'from
'||'  #pmschema#.environment env,
'||'  #pmschema#.task t,
'||'  #pmschema#.task_group tg,
'||'  #pmschema#.organizational_unit ou,
'||'  #schema_tmp#.tmp_rep_hierarchy tmph,
'||'  #pmschema#.hierarchy h
'||'where
'||'  env.id = t.environment
'||'  and t.id = tg.task
'||'  and tg.organizational_unit = ou.id
'||'  and ou.hierarchy = h.id
'||'  and tg.hierarchy = ou.hierarchy
'||'  and ou.hierarchy = tmph.id
'||'  and tmph.id = h.id
'||'  and env.working = 1
'||'';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;
