declare
  rq_id            numeric(16);
  rq_name          varchar(256) := 'Activities by user';
  rq_desc          varchar(512) := 'Business Activity - Users (who does the activities)';
  rqd              clob;

  counter          numeric(16);
begin
  rqd := 'select distinct
'||'  t.name as ACTIVITY_NAME,
'||'  t.code as ACTIVITY_CODE,
'||'  t.description as ACTIVITY_DESC,
'||'  p.name as USER_NAME,
'||'  p.surname as USER_SURNAME,
'||'  p.email as USER_EMAIL,
'||'  p.dn as USER_DN,
'||'  p.cod_fisc as USER_SSN,
'||'  case
'||'    when p.sex=''0'' then ''Male''
'||'    when p.sex=''1'' then ''Female''
'||'  end as USER_GENDER,
'||'  tp.last_mod_time as CALC_DATE
'||'from
'||'  #pmschema#.environment env,
'||'  #pmschema#.task t,
'||'  #pmschema#.task_person tp,
'||'  #pmschema#.person p,
'||'  #pmschema#.group_person gp,
'||'  #schema_tmp#.tmp_rep_organizational_unit tmpou
'||'where
'||'  env.id = t.environment
'||'  and t.id = tp.task
'||'  and tp.person = p.id
'||'  and p.id = gp.person
'||'  and gp.organizational_unit = tmpou.id
'||'  and gp.hierarchy = 1
'||'  and env.working = 1
'||'';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;
