declare
  rq_id            numeric(16);
  rq_name          varchar(256) := 'Activities by entitlement';
  rq_desc          varchar(512) := 'Business Activity - Entitlements (how an activity can be done)';
  rqd              clob;

  counter          numeric(16);
begin
  rqd := 'select distinct
'||'  t.name as ACTIVITY_NAME,
'||'  t.code as ACTIVITY_CODE,
'||'  t.description as ACTIVITY_DESC,
'||'  e.name as ENTITLEMENT_NAME,
'||'  e.code as ENTITLEMENT_CODE,
'||'  e.description as ENTITLEMENT_DESC,
'||'  case
'||'    when e.ext_type = 4 then ''External Role''
'||'    when e.ext_type = 3 then ''Permission''
'||'    when e.int_type = 2 then ''IT Role''
'||'    when e.int_type = 3 then ''Business Role''
'||'  end as ENTITLEMENT_TYPE,
'||'  a.name as APPLICATION_NAME,
'||'  a.description as APPLICATION_DESC,
'||'  ft.name as PROFILE_TYPE_NAME,
'||'  te.last_mod_time as CALC_DATE
'||'from
'||'  #pmschema#.environment env,
'||'  #pmschema#.task t,
'||'  #pmschema#.task_entitlement te,
'||'  #pmschema#.entitlement_flat_hier efh,
'||'  #schema_tmp#.tmp_rep_application tmpa,
'||'  #pmschema#.entitlement e
'||'  left outer join #pmschema#.application a on a.id = e.application
'||'  left outer join #pmschema#.profile_type ft on ft.id = e.profile_type and a.id = ft.application
'||'where
'||'  env.id = t.environment
'||'  and t.id = te.task
'||'  and te.entitlement = efh.parent
'||'  and efh.parent = e.id
'||'  and efh.child_application = tmpa.id
'||'  and env.working = 1
'||'';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;
