--add batch localization for all languages
declare
  cur_loc      sys_refcursor;
  cur_lan      sys_refcursor;
  
  loc_id       number(16);
  i18_mess     varchar2(4000);
  
  lan_id       number(16); 
begin
  open cur_loc for
    select t.id, m.message from localization t, i18n_message m
    where t.code like 'batch.%' and t.id = m.localization
    group by t.id, m.message having count(1) <> ( select count(1) from language );
  loop
    fetch cur_loc into loc_id, i18_mess;
    exit when cur_loc%NOTFOUND;
    
    open cur_lan for
      select id from language
      minus
      select t.language as id from i18n_message t where t.localization = loc_id;
    loop
      fetch cur_lan into lan_id;
      exit when cur_lan%NOTFOUND;
      insert into i18n_message ( id, localization, language, message )
      values ( i18n_message_seq.nextval, loc_id, lan_id, i18_mess );
    end loop;
    close cur_lan;
  end loop;
  close cur_loc;
end;
/
commit;

--unused i18n_messages
declare
  counter        number(16);
begin
  select count(1) into counter from
  (
    select t.id, t.message from i18n_message t
    minus
    select t.id, t.message from (
      select m.id, m.message from report r, localization l, i18n_message m
      where r.localization = l.id and l.id = m.localization
      union
      select m.id, m.message from report r, report_field rf, localization l, i18n_message m
      where r.id = rf.report and rf.localization = l.id and l.id = m.localization
      union
      select m.id, m.message from report_filter r, localization l, i18n_message m
      where r.localization = l.id and l.id = m.localization
    ) t
  ) t;

  if ( counter > 0 ) then
    delete from i18n_message where id in
    (
      select t.id from
      (
        select t.id, t.message from i18n_message t
        minus
        select t.id, t.message from (
          select m.id, m.message from report r, localization l, i18n_message m
          where r.localization = l.id and l.id = m.localization
          union
          select m.id, m.message from report r, report_field rf, localization l, i18n_message m
          where r.id = rf.report and rf.localization = l.id and l.id = m.localization
          union
          select m.id, m.message from report_filter r, localization l, i18n_message m
          where r.localization = l.id and l.id = m.localization
        ) t
      ) t
    );
  end if;
end;
/
commit;

--unused localization
declare
  counter        number(16);
begin
  select count(1) into counter from
  (
    select t.id, t.code from localization t
    minus
    select t.id, t.code from (
      select l.id, l.code from report r, dashboard_field df, localization l
      where r.id = df.report and df.localization = l.id
      union
      select l.id, l.code from report r, localization l
      where r.localization = l.id
      union
      select l.id, l.code from report r, report_field rf, localization l
      where r.id = rf.report and rf.localization = l.id
      union
      select l.id, l.code from report_filter r, localization l
      where r.localization = l.id
    ) t
  ) t;

  if ( counter > 0 ) then
    delete from localization where id in
    (
      select t.id from
      (
        select t.id, t.code from localization t
        minus
        select t.id, t.code from (
          select l.id, l.code from report r, dashboard_field df, localization l
          where r.id = df.report and df.localization = l.id
          union
          select l.id, l.code from report r, localization l
          where r.localization = l.id
          union
          select l.id, l.code from report r, report_field rf, localization l
          where r.id = rf.report and rf.localization = l.id
          union
          select l.id, l.code from report_filter r, localization l
          where r.localization = l.id
        ) t
      ) t
    );
  end if;
end;
/
commit;
