--ADD A COLUMN TO A TABLE
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'IB_TARGETS';
  tab_col_name      varchar2(30) := 'ISHRFEED';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tab_columns t where t.owner = curr_user and t.table_name = tab_name and t.column_name = tab_col_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'ALTER TABLE IB_TARGETS
ADD ISHRFEED CHAR(1)';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on


--ADD A CHECK KEY
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'IB_TARGETS';
  tab_chk_name       varchar2(30) := 'IB_TARGETS_ISHRFEED_CHK';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_constraints t where t.owner = curr_user and t.table_name = tab_name and t.constraint_name = tab_chk_name and t.constraint_type = 'C';
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'ALTER TABLE IB_TARGETS
  ADD CONSTRAINT IB_TARGETS_ISHRFEED_CHK
  CHECK (ISHRFEED IN (''0'',''1''))
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on
