CREATE TABLE IB_TARGET_PROFILE
(
  NAME                           VARCHAR(256)        NOT NULL,
  DESCRIPTION                    VARCHAR(1024),
  PROVIDER_TYPE                  VARCHAR(50)         NOT NULL,
  PROVIDER_CONFIG                CLOB(1M)
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

CREATE TABLE IB_TARGET_RESOURCE_SCHEMA_EXT
(
  URN                            VARCHAR(256)        NOT NULL,
  NAME                           VARCHAR(100),
  PROFILE_NAME                   VARCHAR(256)        NOT NULL,
  RESOURCETYPE                   VARCHAR(256)        NOT NULL,
  DEFINITION                     CLOB(1M),
  ATTRIBUTEMAP                   CLOB(1M)
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

CREATE TABLE IB_TARGET_RESOURCE_TYPE
(
  PROFILE_NAME                   VARCHAR(256)        NOT NULL,
  ID                             VARCHAR(256)        NOT NULL,
  ENDPOINT                       VARCHAR(256)        NOT NULL,
  CATEGORY                       VARCHAR(50)         NOT NULL,
  DEFINITION                     CLOB(1M)
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE IB_TARGET_PROFILE ADD
  CONSTRAINT IB_TARGET_PROFILE_PK
 PRIMARY KEY (NAME);
CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE IB_TARGET_PROFILE' );

ALTER TABLE IB_TARGET_RESOURCE_SCHEMA_EXT ADD
  CONSTRAINT IB_TRGT_RSRCE_SCHEMA_EXT_PK
 PRIMARY KEY (URN);
CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE IB_TARGET_RESOURCE_SCHEMA_EXT' );

ALTER TABLE IB_TARGET_RESOURCE_TYPE ADD
  CONSTRAINT IB_TARGET_RESOURCE_TYPE_PK
 PRIMARY KEY (ID);
CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE IB_TARGET_RESOURCE_TYPE' );

CREATE INDEX RESOURCE_TYPE_IDX ON IB_TARGET_RESOURCE_TYPE
(PROFILE_NAME);

CREATE INDEX SCHEMA_IDX ON IB_TARGET_RESOURCE_SCHEMA_EXT
(PROFILE_NAME);

CREATE INDEX SCHEMA_NAME_IDX ON IB_TARGET_RESOURCE_SCHEMA_EXT
(NAME);
