CREATE TABLE IB_TARGET_PROFILE
(
  NAME                           VARCHAR2(256)       NOT NULL,
  DESCRIPTION                    VARCHAR2(1024),
  PROVIDER_TYPE                  VARCHAR2(50)        NOT NULL,
  PROVIDER_CONFIG                CLOB
)
TABLESPACE &DATA_TABLESPACE
;

CREATE TABLE IB_TARGET_RESOURCE_SCHEMA_EXT
(
  URN                            VARCHAR2(256)       NOT NULL,
  NAME                           VARCHAR2(100),
  PROFILE_NAME                   VARCHAR2(256)       NOT NULL,
  RESOURCETYPE                   VARCHAR2(256)       NOT NULL,
  DEFINITION CLOB,
  ATTRIBUTEMAP CLOB
)
TABLESPACE &DATA_TABLESPACE
;

CREATE TABLE IB_TARGET_RESOURCE_TYPE
(
  PROFILE_NAME                   VARCHAR2(256)       NOT NULL,
  ID                             VARCHAR2(256)       NOT NULL,
  ENDPOINT                       VARCHAR2(256)       NOT NULL,
  CATEGORY                       VARCHAR2(50)        NOT NULL,
  DEFINITION                     CLOB
)
TABLESPACE &DATA_TABLESPACE
;

ALTER TABLE IB_TARGET_PROFILE ADD (
  CONSTRAINT IB_TARGET_PROFILE_PK
 PRIMARY KEY
 (NAME)
  USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS);
  
ALTER TABLE IB_TARGET_RESOURCE_SCHEMA_EXT ADD (
  CONSTRAINT IB_TRGT_RSRCE_SCHEMA_EXT_PK
 PRIMARY KEY
 (URN)
  USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS);  
  
ALTER TABLE IB_TARGET_RESOURCE_TYPE ADD (
  CONSTRAINT IB_TARGET_RESOURCE_TYPE_PK
 PRIMARY KEY
 (ID)
  USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS);  
  
CREATE INDEX RESOURCE_TYPE_IDX ON IB_TARGET_RESOURCE_TYPE
(PROFILE_NAME)
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

CREATE INDEX SCHEMA_IDX ON IB_TARGET_RESOURCE_SCHEMA_EXT
(PROFILE_NAME)
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

CREATE INDEX SCHEMA_NAME_IDX ON IB_TARGET_RESOURCE_SCHEMA_EXT
(NAME)
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;
