DROP TABLE IB_ACCOUNT_DELTAS;

CREATE TABLE IB_ACCOUNT_DELTAS
(
  ID                             BIGINT              GENERATED ALWAYS AS IDENTITY(START WITH 1 INCREMENT BY 1 NOCACHE) NOT NULL,
  CLIENTID                       VARCHAR(256)        NOT NULL,
  TARGETID                       VARCHAR(256)        NOT NULL,
  ACCOUNTID                      VARCHAR(256)        NOT NULL,
  OPERATIONTYPE                  VARCHAR(50)         NOT NULL,
  CREATEDTIME                    TIMESTAMP(6)        DEFAULT CURRENT_TIMESTAMP,
  DELTA_JSON                     BLOB(2G),
  REQUESTID                      VARCHAR(256)
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE IB_ACCOUNT_DELTAS ADD
  CONSTRAINT IB_ACCOUNT_DELTAS_PK
 PRIMARY KEY (ID);
CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE IB_ACCOUNT_DELTAS' );

ALTER TABLE IB_ACCOUNT_DELTAS ADD
  CONSTRAINT IB_ACCOUNT_DEL_IB_TARGETS_FK
 FOREIGN KEY (TARGETID)
 REFERENCES IB_TARGETS (TARGETID)
;

ALTER TABLE IB_ACCOUNT_DELTAS ADD
  CONSTRAINT IB_ACCOUNT_DEL_IB_USERS_FK
 FOREIGN KEY (CLIENTID)
 REFERENCES IB_USERS (USERID)
;

CREATE INDEX ACCOUNT_IDX ON IB_ACCOUNT_DELTAS
(CLIENTID, TARGETID, ACCOUNTID, OPERATIONTYPE);

COMMENT ON COLUMN IB_ACCOUNT_DELTAS.ID IS
'DBMS_AUTO_SEQ: #START# 1 | #INCREMENT# 1 | #CACHE# NO | #CYCLE# NO | ';
