CREATE TABLE IB_TARGET_PROFILE
(
  NAME                           VARCHAR2(256 BYTE)       NOT NULL,
  DESCRIPTION                    VARCHAR2(1024 BYTE),
  PROVIDER_TYPE                  VARCHAR2(50 BYTE)        NOT NULL,
  PROVIDER_CONFIG                CLOB
)
TABLESPACE &DATA_TABLESPACE
  LOB (PROVIDER_CONFIG) STORE AS
  (
    TABLESPACE   &LOB_TABLESPACE
    ENABLE       STORAGE IN ROW
    CHUNK        8192
    NOCACHE
    INDEX IB_TAR_PR_PROVIDER_CONFIG_IDX
    (
      TABLESPACE &LOB_TABLESPACE
    )
  )
;

ALTER TABLE IB_TARGET_PROFILE ADD (
  CONSTRAINT IB_TARGET_PROFILE_PK
 PRIMARY KEY
 (NAME)
  USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS);

comment on column IB_TARGET_PROFILE.PROVIDER_CONFIG
  is 'DB2_CLOB_SIZE: 1M';
