--CREATE A TABLE AND ITS CONSTRAINTS
set verify off
set serveroutput on
declare
  curr_user         varchar2(30);
  
  tab_name          varchar2(30) := 'IB_TARGET_PROFILE';
  dml_def           varchar2(4000);
  
  counter           number(16);
begin
  select trim ( user ) into curr_user from dual;
  select count(1) into counter from all_tables t where t.owner = curr_user and t.table_name = tab_name;
  if ( counter = 1 ) then
    return;
  end if;

  dml_def :=
'CREATE TABLE IB_TARGET_PROFILE
(
  NAME                           VARCHAR2(256 BYTE)       NOT NULL,
  DESCRIPTION                    VARCHAR2(1024 BYTE),
  PROVIDER_TYPE                  VARCHAR2(50 BYTE)        NOT NULL,
  PROVIDER_CONFIG                CLOB
)
TABLESPACE &DATA_TABLESPACE
  LOB (PROVIDER_CONFIG) STORE AS
  (
    TABLESPACE   &LOB_TABLESPACE
    ENABLE       STORAGE IN ROW
    CHUNK        8192
    NOCACHE
    INDEX IB_TAR_PR_PROVIDER_CONFIG_IDX
    (
      TABLESPACE &LOB_TABLESPACE
    )
  )
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

  dml_def :=
'ALTER TABLE IB_TARGET_PROFILE ADD (
  CONSTRAINT IB_TARGET_PROFILE_PK
 PRIMARY KEY
 (NAME)
  USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS)
';

  if ( '&ECHO' = 'ON' ) then
    dbms_output.put_line ( dml_def );
  end if;
  execute immediate ( dml_def );

end;
/
set serveroutput off
set verify on

comment on column IB_TARGET_PROFILE.PROVIDER_CONFIG
  is 'DB2_CLOB_SIZE: 1M';
