CREATE TABLE IB_TARGET_RESOURCE_SCHEMA_EXT
(
  URN                            VARCHAR2(256 BYTE)       NOT NULL,
  NAME                           VARCHAR2(100 BYTE),
  PROFILE_NAME                   VARCHAR2(256 BYTE)       NOT NULL,
  RESOURCETYPE                   VARCHAR2(256 BYTE)       NOT NULL,
  DEFINITION                     CLOB,
  ATTRIBUTEMAP                   CLOB
)
TABLESPACE &DATA_TABLESPACE
  LOB (ATTRIBUTEMAP) STORE AS
  (
    TABLESPACE   &LOB_TABLESPACE
    ENABLE       STORAGE IN ROW
    CHUNK        8192
    NOCACHE
    INDEX IB_TAR_RES_EX_ATTRIBUTEMAP_IDX
    (
      TABLESPACE &LOB_TABLESPACE
    )
  )
  LOB (DEFINITION) STORE AS
  (
    TABLESPACE   &LOB_TABLESPACE
    ENABLE       STORAGE IN ROW
    CHUNK        8192
    NOCACHE
    INDEX IB_TAR_RES_EX_DEFINITION_IDX
    (
      TABLESPACE &LOB_TABLESPACE
    )
  )
;

ALTER TABLE IB_TARGET_RESOURCE_SCHEMA_EXT ADD (
  CONSTRAINT IB_TRGT_RSRCE_SCHEMA_EXT_PK
 PRIMARY KEY
 (URN)
  USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS);

comment on column IB_TARGET_RESOURCE_SCHEMA_EXT.ATTRIBUTEMAP
  is 'DB2_CLOB_SIZE: 1M';

comment on column IB_TARGET_RESOURCE_SCHEMA_EXT.DEFINITION
  is 'DB2_CLOB_SIZE: 1M';

CREATE INDEX SCHEMA_IDX ON IB_TARGET_RESOURCE_SCHEMA_EXT
(PROFILE_NAME)
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

CREATE INDEX SCHEMA_NAME_IDX ON IB_TARGET_RESOURCE_SCHEMA_EXT
(NAME)
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;
