CREATE TABLE IB_TARGET_RESOURCE_SCHEMA_EXT
(
  URN                            VARCHAR(256)        NOT NULL,
  NAME                           VARCHAR(100),
  PROFILE_NAME                   VARCHAR(256)        NOT NULL,
  RESOURCETYPE                   VARCHAR(256)        NOT NULL,
  DEFINITION                     CLOB(1M),
  ATTRIBUTEMAP                   CLOB(1M)
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE IB_TARGET_RESOURCE_SCHEMA_EXT ADD
  CONSTRAINT IB_TRGT_RSRCE_SCHEMA_EXT_PK
 PRIMARY KEY (URN);
CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE IB_TARGET_RESOURCE_SCHEMA_EXT' );

comment on column IB_TARGET_RESOURCE_SCHEMA_EXT.ATTRIBUTEMAP
  is 'DB2_CLOB_SIZE: 1M';

comment on column IB_TARGET_RESOURCE_SCHEMA_EXT.DEFINITION
  is 'DB2_CLOB_SIZE: 1M';

CREATE INDEX SCHEMA_IDX ON IB_TARGET_RESOURCE_SCHEMA_EXT
(PROFILE_NAME);

CREATE INDEX SCHEMA_NAME_IDX ON IB_TARGET_RESOURCE_SCHEMA_EXT
(NAME);

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE IB_TARGET_RESOURCE_SCHEMA_EXT' );
