CREATE TABLE IB_TARGET_RESOURCE_TYPE
(
  PROFILE_NAME                   VARCHAR(256)        NOT NULL,
  ID                             VARCHAR(256)        NOT NULL,
  ENDPOINT                       VARCHAR(256)        NOT NULL,
  CATEGORY                       VARCHAR(50)         NOT NULL,
  DEFINITION                     CLOB(1M)
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE IB_TARGET_RESOURCE_TYPE ADD
  CONSTRAINT IB_TARGET_RESOURCE_TYPE_PK
 PRIMARY KEY (ID);
CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE IB_TARGET_RESOURCE_TYPE' );

comment on column IB_TARGET_RESOURCE_TYPE.DEFINITION
  is 'DB2_CLOB_SIZE: 1M';

CREATE INDEX RESOURCE_TYPE_IDX ON IB_TARGET_RESOURCE_TYPE
(PROFILE_NAME);

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE IB_TARGET_RESOURCE_TYPE' );
