CREATE TABLE IB_TARGET_RESOURCE_TYPE
(
  PROFILE_NAME                   VARCHAR2(256)       NOT NULL,
  ID                             VARCHAR2(256)       NOT NULL,
  ENDPOINT                       VARCHAR2(256)       NOT NULL,
  CATEGORY                       VARCHAR2(50)        NOT NULL,
  DEFINITION                     CLOB
)
TABLESPACE &DATA_TABLESPACE
  LOB (DEFINITION) STORE AS
  (
    TABLESPACE   &LOB_TABLESPACE
    ENABLE       STORAGE IN ROW
    CHUNK        8192
    NOCACHE
    INDEX IB_TAR_RES_T_DEFINITION_IDX
    (
      TABLESPACE &LOB_TABLESPACE
    )
  )
;

ALTER TABLE IB_TARGET_RESOURCE_TYPE ADD (
  CONSTRAINT IB_TARGET_RESOURCE_TYPE_PK
 PRIMARY KEY
 (ID)
  USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS);

comment on column IB_TARGET_RESOURCE_TYPE.DEFINITION
  is 'DB2_CLOB_SIZE: 1M';

CREATE INDEX RESOURCE_TYPE_IDX ON IB_TARGET_RESOURCE_TYPE
(PROFILE_NAME)
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;
