declare
  sk_id         number(16)    := 50;
  sk_name       varchar2(256) := 'Internal';
  sk_desc       varchar2(256) := '';

  counter       number(16);
begin
  select count(1) into counter from scheduler t where t.id = sk_id;
  if ( counter = 0 ) then
    insert into scheduler ( id, name, description )
    values ( sk_id, sk_name, sk_desc );
  else
    update scheduler set name = sk_name, description = sk_desc where id = sk_id;
  end if;
end;
/
commit;

declare
  sk_id         number(16);
  sk_name       varchar2(256) := 'Internal';
  
  sk_prop_id    number(16);
  sk_prop_name  varchar2(256) := 'org.quartz.scheduler.instanceName';
  sk_prop_value varchar2(256) := 'AGC';

  counter       number(16);
begin
  select count(1) into counter from scheduler t where lower ( t.name ) = lower ( sk_name );
  if ( counter = 0 ) then
    return;
  else
    select t.id into sk_id from scheduler t where lower ( t.name ) = lower ( sk_name );
  end if;

  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( sk_prop_name );
  if ( counter = 0 ) then
    select max(id)+1 into sk_prop_id from scheduler_prop; 

    insert into scheduler_prop ( id, scheduler, name, value )
    values ( sk_prop_id, sk_id, sk_prop_name, sk_prop_value );
  else 
    update scheduler_prop set value = sk_prop_value where scheduler = sk_id and lower ( name ) = lower ( sk_prop_name );
  end if;
end;
/
commit;

declare
  sk_id         number(16);
  sk_name       varchar2(256) := 'Internal';
  
  sk_prop_id    number(16);
  sk_prop_name  varchar2(256) := 'org.quartz.scheduler.instanceId';
  sk_prop_value varchar2(256) := 'AUTO';

  counter       number(16);
begin
  select count(1) into counter from scheduler t where lower ( t.name ) = lower ( sk_name );
  if ( counter = 0 ) then
    return;
  else
    select t.id into sk_id from scheduler t where lower ( t.name ) = lower ( sk_name );
  end if;

  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( sk_prop_name );
  if ( counter = 0 ) then
    select max(id)+1 into sk_prop_id from scheduler_prop; 

    insert into scheduler_prop ( id, scheduler, name, value )
    values ( sk_prop_id, sk_id, sk_prop_name, sk_prop_value );
  else 
    update scheduler_prop set value = sk_prop_value where scheduler = sk_id and lower ( name ) = lower ( sk_prop_name );
  end if;
end;
/
commit;

declare
  sk_id         number(16);
  sk_name       varchar2(256) := 'Internal';
  
  sk_prop_id    number(16);
  sk_prop_name  varchar2(256) := 'org.quartz.threadPool.class';
  sk_prop_value varchar2(256) := 'org.quartz.simpl.SimpleThreadPool';

  counter       number(16);
begin
  select count(1) into counter from scheduler t where lower ( t.name ) = lower ( sk_name );
  if ( counter = 0 ) then
    return;
  else
    select t.id into sk_id from scheduler t where lower ( t.name ) = lower ( sk_name );
  end if;

  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( sk_prop_name );
  if ( counter = 0 ) then
    select max(id)+1 into sk_prop_id from scheduler_prop; 

    insert into scheduler_prop ( id, scheduler, name, value )
    values ( sk_prop_id, sk_id, sk_prop_name, sk_prop_value );
  else 
    update scheduler_prop set value = sk_prop_value where scheduler = sk_id and lower ( name ) = lower ( sk_prop_name );
  end if;
end;
/
commit;

declare
  sk_id         number(16);
  sk_name       varchar2(256) := 'Internal';
  
  sk_prop_id    number(16);
  sk_prop_name  varchar2(256) := 'org.quartz.threadPool.threadCount';
  sk_prop_value varchar2(256) := '100';

  counter       number(16);
begin
  select count(1) into counter from scheduler t where lower ( t.name ) = lower ( sk_name );
  if ( counter = 0 ) then
    return;
  else
    select t.id into sk_id from scheduler t where lower ( t.name ) = lower ( sk_name );
  end if;

  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( sk_prop_name );
  if ( counter = 0 ) then
    select max(id)+1 into sk_prop_id from scheduler_prop; 

    insert into scheduler_prop ( id, scheduler, name, value )
    values ( sk_prop_id, sk_id, sk_prop_name, sk_prop_value );
  else 
    update scheduler_prop set value = sk_prop_value where scheduler = sk_id and lower ( name ) = lower ( sk_prop_name );
  end if;
end;
/
commit;

declare
  sk_id         number(16);
  sk_name       varchar2(256) := 'Internal';
  
  sk_prop_id    number(16);
  sk_prop_name  varchar2(256) := 'org.quartz.threadPool.threadPriority';
  sk_prop_value varchar2(256) := '5';

  counter       number(16);
begin
  select count(1) into counter from scheduler t where lower ( t.name ) = lower ( sk_name );
  if ( counter = 0 ) then
    return;
  else
    select t.id into sk_id from scheduler t where lower ( t.name ) = lower ( sk_name );
  end if;

  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( sk_prop_name );
  if ( counter = 0 ) then
    select max(id)+1 into sk_prop_id from scheduler_prop; 

    insert into scheduler_prop ( id, scheduler, name, value )
    values ( sk_prop_id, sk_id, sk_prop_name, sk_prop_value );
  else 
    update scheduler_prop set value = sk_prop_value where scheduler = sk_id and lower ( name ) = lower ( sk_prop_name );
  end if;
end;
/
commit;

declare
  sk_id         number(16);
  sk_name       varchar2(256) := 'Internal';
  
  sk_prop_id    number(16);
  sk_prop_name  varchar2(256) := 'org.quartz.jobStore.misfireThreshold';
  sk_prop_value varchar2(256) := '60000';

  counter       number(16);
begin
  select count(1) into counter from scheduler t where lower ( t.name ) = lower ( sk_name );
  if ( counter = 0 ) then
    return;
  else
    select t.id into sk_id from scheduler t where lower ( t.name ) = lower ( sk_name );
  end if;

  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( sk_prop_name );
  if ( counter = 0 ) then
    select max(id)+1 into sk_prop_id from scheduler_prop; 

    insert into scheduler_prop ( id, scheduler, name, value )
    values ( sk_prop_id, sk_id, sk_prop_name, sk_prop_value );
  else 
    update scheduler_prop set value = sk_prop_value where scheduler = sk_id and lower ( name ) = lower ( sk_prop_name );
  end if;
end;
/
commit;

declare
  sk_id         number(16);
  sk_name       varchar2(256) := 'Internal';
  
  sk_prop_id    number(16);
  sk_prop_name  varchar2(256) := 'org.quartz.jobStore.class';
  sk_prop_value varchar2(256) := 'org.quartz.impl.jdbcjobstore.JobStoreTX';

  counter       number(16);
begin
  select count(1) into counter from scheduler t where lower ( t.name ) = lower ( sk_name );
  if ( counter = 0 ) then
    return;
  else
    select t.id into sk_id from scheduler t where lower ( t.name ) = lower ( sk_name );
  end if;

  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( sk_prop_name );
  if ( counter = 0 ) then
    select max(id)+1 into sk_prop_id from scheduler_prop; 

    insert into scheduler_prop ( id, scheduler, name, value )
    values ( sk_prop_id, sk_id, sk_prop_name, sk_prop_value );
  else 
    update scheduler_prop set value = sk_prop_value where scheduler = sk_id and lower ( name ) = lower ( sk_prop_name );
  end if;
end;
/
commit;

declare
  sk_id         number(16);
  sk_name       varchar2(256) := 'Internal';
  
  sk_prop_id    number(16);
  sk_prop_name  varchar2(256) := 'org.quartz.jobStore.driverDelegateClass';
  sk_prop_value varchar2(256) := 'org.quartz.impl.jdbcjobstore.StdJDBCDelegate';

  counter       number(16);
begin
  select count(1) into counter from scheduler t where lower ( t.name ) = lower ( sk_name );
  if ( counter = 0 ) then
    return;
  else
    select t.id into sk_id from scheduler t where lower ( t.name ) = lower ( sk_name );
  end if;

  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( sk_prop_name );
  if ( counter = 0 ) then
    select max(id)+1 into sk_prop_id from scheduler_prop; 

    insert into scheduler_prop ( id, scheduler, name, value )
    values ( sk_prop_id, sk_id, sk_prop_name, sk_prop_value );
  else 
    update scheduler_prop set value = sk_prop_value where scheduler = sk_id and lower ( name ) = lower ( sk_prop_name );
  end if;
end;
/
commit;

declare
  sk_id         number(16);
  sk_name       varchar2(256) := 'Internal';
  
  sk_prop_id    number(16);
  sk_prop_name  varchar2(256) := 'org.quartz.jobStore.useProperties';
  sk_prop_value varchar2(256) := 'false';

  counter       number(16);
begin
  select count(1) into counter from scheduler t where lower ( t.name ) = lower ( sk_name );
  if ( counter = 0 ) then
    return;
  else
    select t.id into sk_id from scheduler t where lower ( t.name ) = lower ( sk_name );
  end if;

  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( sk_prop_name );
  if ( counter = 0 ) then
    select max(id)+1 into sk_prop_id from scheduler_prop; 

    insert into scheduler_prop ( id, scheduler, name, value )
    values ( sk_prop_id, sk_id, sk_prop_name, sk_prop_value );
  else 
    update scheduler_prop set value = sk_prop_value where scheduler = sk_id and lower ( name ) = lower ( sk_prop_name );
  end if;
end;
/
commit;

declare
  sk_id         number(16);
  sk_name       varchar2(256) := 'Internal';
  
  sk_prop_id    number(16);
  sk_prop_name  varchar2(256) := 'org.quartz.jobStore.tablePrefix';
  sk_prop_value varchar2(256) := 'QRZ7_';

  counter       number(16);
begin
  select count(1) into counter from scheduler t where lower ( t.name ) = lower ( sk_name );
  if ( counter = 0 ) then
    return;
  else
    select t.id into sk_id from scheduler t where lower ( t.name ) = lower ( sk_name );
  end if;

  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( sk_prop_name );
  if ( counter = 0 ) then
    select max(id)+1 into sk_prop_id from scheduler_prop; 

    insert into scheduler_prop ( id, scheduler, name, value )
    values ( sk_prop_id, sk_id, sk_prop_name, sk_prop_value );
  else 
    update scheduler_prop set value = sk_prop_value where scheduler = sk_id and lower ( name ) = lower ( sk_prop_name );
  end if;
end;
/
commit;

declare
  sk_id         number(16);
  sk_name       varchar2(256) := 'Internal';
  
  sk_prop_id    number(16);
  sk_prop_name  varchar2(256) := 'org.quartz.jobStore.isClustered';
  sk_prop_value varchar2(256) := 'true';

  counter       number(16);
begin
  select count(1) into counter from scheduler t where lower ( t.name ) = lower ( sk_name );
  if ( counter = 0 ) then
    return;
  else
    select t.id into sk_id from scheduler t where lower ( t.name ) = lower ( sk_name );
  end if;

  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( sk_prop_name );
  if ( counter = 0 ) then
    select max(id)+1 into sk_prop_id from scheduler_prop; 

    insert into scheduler_prop ( id, scheduler, name, value )
    values ( sk_prop_id, sk_id, sk_prop_name, sk_prop_value );
  else 
    update scheduler_prop set value = sk_prop_value where scheduler = sk_id and lower ( name ) = lower ( sk_prop_name );
  end if;
end;
/
commit;

declare
  sk_id         number(16);
  sk_name       varchar2(256) := 'Internal';
  
  sk_prop_id    number(16);
  sk_prop_name  varchar2(256) := 'org.quartz.jobStore.clusterCheckinInterval';
  sk_prop_value varchar2(256) := '20000';

  counter       number(16);
begin
  select count(1) into counter from scheduler t where lower ( t.name ) = lower ( sk_name );
  if ( counter = 0 ) then
    return;
  else
    select t.id into sk_id from scheduler t where lower ( t.name ) = lower ( sk_name );
  end if;

  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( sk_prop_name );
  if ( counter = 0 ) then
    select max(id)+1 into sk_prop_id from scheduler_prop; 

    insert into scheduler_prop ( id, scheduler, name, value )
    values ( sk_prop_id, sk_id, sk_prop_name, sk_prop_value );
  else 
    update scheduler_prop set value = sk_prop_value where scheduler = sk_id and lower ( name ) = lower ( sk_prop_name );
  end if;
end;
/
commit;

declare
  sk_id         number(16);
  sk_name       varchar2(256) := 'Internal';
  
  sk_prop_id    number(16);
  sk_prop_name  varchar2(256) := 'org.quartz.jobStore.dataSource';
  sk_prop_value varchar2(256) := 'one';

  counter       number(16);
begin
  select count(1) into counter from scheduler t where lower ( t.name ) = lower ( sk_name );
  if ( counter = 0 ) then
    return;
  else
    select t.id into sk_id from scheduler t where lower ( t.name ) = lower ( sk_name );
  end if;

  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( sk_prop_name );
  if ( counter = 0 ) then
    select max(id)+1 into sk_prop_id from scheduler_prop; 

    insert into scheduler_prop ( id, scheduler, name, value )
    values ( sk_prop_id, sk_id, sk_prop_name, sk_prop_value );
  else 
    update scheduler_prop set value = sk_prop_value where scheduler = sk_id and lower ( name ) = lower ( sk_prop_name );
  end if;
end;
/
commit;

declare
  sk_id         number(16);
  sk_name       varchar2(256) := 'Internal';
  
  sk_prop_id    number(16);
  sk_prop_name  varchar2(256) := 'org.quartz.dataSource.one.jndiURL';
  sk_prop_value varchar2(256) := 'QUARTZ';

  counter       number(16);
begin
  select count(1) into counter from scheduler t where lower ( t.name ) = lower ( sk_name );
  if ( counter = 0 ) then
    return;
  else
    select t.id into sk_id from scheduler t where lower ( t.name ) = lower ( sk_name );
  end if;

  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( sk_prop_name );
  if ( counter = 0 ) then
    select max(id)+1 into sk_prop_id from scheduler_prop; 

    insert into scheduler_prop ( id, scheduler, name, value )
    values ( sk_prop_id, sk_id, sk_prop_name, sk_prop_value );
  else 
    update scheduler_prop set value = sk_prop_value where scheduler = sk_id and lower ( name ) = lower ( sk_prop_name );
  end if;
end;
/
commit;

declare
  sk_id         number(16);
  sk_name       varchar2(256) := 'Internal';
  
  sk_prop_id    number(16);
  sk_prop_name  varchar2(256) := 'org.quartz.dataSource.one.driver';
  sk_prop_value varchar2(256) := 'oracle.jdbc.driver.OracleDriver';

  counter       number(16);
begin
  select count(1) into counter from scheduler t where lower ( t.name ) = lower ( sk_name );
  if ( counter = 0 ) then
    return;
  else
    select t.id into sk_id from scheduler t where lower ( t.name ) = lower ( sk_name );
  end if;

  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( sk_prop_name );
  if ( counter = 0 ) then
    select max(id)+1 into sk_prop_id from scheduler_prop; 

    insert into scheduler_prop ( id, scheduler, name, value )
    values ( sk_prop_id, sk_id, sk_prop_name, sk_prop_value );
  else 
    update scheduler_prop set value = sk_prop_value where scheduler = sk_id and lower ( name ) = lower ( sk_prop_name );
  end if;
end;
/
commit;

