declare
  BREAK_LINE           constant varchar2(100):='#%#% ';
  
  cur_col              sys_refcursor;
  
  DUMMY_OP_TYPE        varchar2(30) := '##OPERATION_TYPE##';
  DUMMY_ENT_TYPE       varchar2(30) := '##ENTITY_TYPE##';
  DUMMY_TAB_NAME       varchar2(30) := '##TABLE_NAME##';
  DUMMY_COL_NAME       varchar2(30) := '##COLUMN_NAME##';
  DUMMY_COL_NAME_TXT   varchar2(30) := '##COLUMN_NAME_TXT##';
  DUMMY_COL_NAME_NEW   varchar2(30) := '##COLUMN_NAME_NEW##';
  DUMMY_COL_NAME_OLD   varchar2(30) := '##COLUMN_NAME_OLD##';
  
  tab_name             varchar2(30) := 'ENTITLEMENT';
  col_name             varchar2(100);
  col_type             varchar2(30);
  OPERATION_UPDATE     varchar2(3) := '1';
  OPERATION_INSERT     varchar2(3) := '2';
  OPERATION_DELETE     varchar2(3) := '3';
  OPERATION_VERSION    varchar2(3) := '10';
  
  ENT_TYPE_ENTITLEMENT number(1) := 1;
  
  trg_body             clob;
  
  trg_head             varchar2(1025);

  trg_tail             varchar2(1025) :=
'end TRG_' || DUMMY_TAB_NAME || '_HISTORY;
/';

  ddl_ins            varchar2(1025) :=
'      insert into history
         ( id, operation, ent_type, ent_id, ent_name, ent_desc,
           old_val, new_val, field, revision, note )
      values
         ( history_seq.nextval, ' || DUMMY_OP_TYPE || ', ' || DUMMY_ENT_TYPE || ', :new.id, :new.name, :new.description,
           ' || DUMMY_COL_NAME_OLD || ', ' || DUMMY_COL_NAME_NEW || ', ''' || DUMMY_COL_NAME_TXT || ''', var_revision, code_oper );
';
  ddl_text              varchar2(1025);
  ddl_text_pg           varchar2(1025);
  
  num_error             number(16);

  PG_BEGIN              constant varchar2(20) := '/*PG-BEGIN*/';
  PG_END                constant varchar2(20) := '/*PG-END*/';
  COMM_OPEN             constant varchar2(20) := '/*';
  COMM_CLOSE            constant varchar2(20) := '*/';
  pg_replace            boolean := false;

  --Funzione che stampa sull'output del DBMS una stringa (o un clob) composto da pi testo
  --con caratteri di "a capo".
  --Se vi sono COMUNQUE righe pi lunghe di 255 caratteri (tra un "a capo" e l'altro), esse
  --vengono spezzate e all'inizio di ogni riga viene messa una escape sequence, in modo da
  --poterla cercare e sostituire agevolmente
  --
  --ES: riga > 255 caratteri -->  [250 caratteri] parola1 parola2 ecc.
  --
  --risultato della stampa   -->  [250 caratteri] paro
  --                              [ESCAPE_SEQ.] la1 parola2
  function put_XL_line(in_string in clob, numError in number)
    return number
  is
    DUMMY        constant varchar2(10) := BREAK_LINE;
    MAX_LEN      constant number(3)    := 255;
    MAX_LEN_ERR  constant number(3)    := MAX_LEN - length(DUMMY);
    CR_NL        constant char(1)      := chr(10);

    work_str     clob;
    short_line   varchar2(258);
    first_row    boolean               := true;

    work_str_len number(16) := 0;
    offset       number(16) := 0;
    next_CR_NL   number(16) := 0;
    row_offset   number(16) := 0;
    num_error    number(16) := 0;

  begin
    num_error := numError;
    --aggiungiamo un carattere di "a capo" solo se non  presente come ultimo carattere
    --della stringa da stampare
    if(substr(in_string, length(in_string), 1) = CR_NL) then
      work_str := in_string;
    else
      work_str := in_string||CR_NL;
    end if;
    
    work_str_len := length(work_str);

    offset := 1;
      
    while offset <= work_str_len
    loop
      --cerchiamo la prima occorrenza del carattere di "a capo" a partire dall'indice offset
      --che  il risultato dell'ultima ricerca di carattere di "a capo"
      next_CR_NL := instr(substr(work_str, offset, work_str_len), CR_NL);
      
      --se la lunghezza della riga  uguale a 1
      if( next_CR_NL = 1 ) then
        dbms_output.put(chr(10));
      --se la lunghezza della riga  minore di MAX_LEN stampiamo la riga
      elsif( next_CR_NL < MAX_LEN ) then
        short_line := substr(work_str, offset, next_CR_NL - length(CR_NL));
        dbms_output.put_line(short_line);
      --se la lunghezza della riga  maggiore di MAX_LEN  necessario spezzarla
      else
        num_error := num_error + 1;
        row_offset := 0;
        first_row := true;
        
        --finch l'indice della riga non  maggiore (o uguale) alla lunghezza della riga
        while row_offset < next_CR_NL 
        loop
          --la parte di riga da stampare  ancora pi lunga rispetto a MAX_LEN_ERR
          --nel caso sia la prima riga questa condizione  comunque verificata perch
          --pi restrittiva rispetto al solo MAX_LEN (MAX_LEN_ERR < MAX_LEN)
          if( (row_offset + MAX_LEN_ERR) < next_CR_NL) then
            --se  la prima riga essa non deve contenere il DUMMY all'inizio della stessa e deve
            --essere lunga MAX_LEN
            if( first_row ) then
              short_line := substr(work_str, offset + row_offset, MAX_LEN);
              row_offset := row_offset + MAX_LEN;
            --se  una riga successiva deve contenere il DUMMY all'inizio della stessa e deve
            --essere lunga MAX_LEN_ERR
            else
              short_line := substr(work_str, offset + row_offset, MAX_LEN_ERR);
              row_offset := row_offset + MAX_LEN_ERR;
            end if;
          --la parte di riga da stampare  ancora pi corta rispetto a MAX_LEN_ERR
          --quindi questa  l'ultimo pezzo di riga da stampare
          else
            short_line := substr(work_str, offset + row_offset, next_CR_NL - length(CR_NL) - row_offset);
            row_offset := next_CR_NL;
          end if;
          
          --solo alla prima riga NON si aggiunge il DUMMY
          if( first_row ) then
            first_row := false;
          --dalla seconda riga in poi si aggiunge il DUMMY
          else
            short_line := DUMMY||short_line;        
          end if;

          dbms_output.put_line(short_line);
        end loop;
        
      end if;
      --si aggiorna la posizione di partenza nella ricerca del carattere di "a capo" a quella dell'ultimo trovato
      offset := offset + next_CR_NL;
      
    end loop;
    
    --nel caso in cui l'ultima riga sia un "a capo" aggiungiamo un "a capo" poich esso si perde nella ricerca
    if(substr(in_string, length(in_string), 1) = CR_NL) then
      dbms_output.put(CR_NL);
    end if;

    return num_error;
    
    --tale errore non si dovrebbe MAI verificare
    exception when others then
      dbms_output.put_line('########################################## Errore paginazione');
      dbms_output.put_line('########################################## Errore paginazione');
      dbms_output.put_line('########################################## Errore paginazione');
      return -1;     
  end put_XL_line;
  
  function upd_ddl_script
  (
    pg_replace       boolean,
    col_name         varchar2,
    col_type         varchar2,
    ddl_text         varchar2,
    ddl_text_pg      varchar2,
    ddl_ins          varchar2,
    operation_type   varchar2,
    trg_body         clob
  )
  return clob is
    upd_pg_replace        boolean;
    upd_col_name          varchar2(100);
    upd_col_type          varchar2(30);
    upd_ddl_text          varchar2(1025);
    upd_ddl_text_pg       varchar2(1025);
    upd_ddl_ins           varchar2(1025);
    upd_operation_type    varchar2(3);
    upd_trg_body          clob;
  begin
    upd_pg_replace       := pg_replace;

    upd_col_name         := col_name;
    upd_col_type         := col_type;
    upd_ddl_text         := ddl_text;
    upd_ddl_text_pg      := ddl_text_pg;
    upd_ddl_ins          := ddl_ins;
    upd_operation_type   := operation_type;
    upd_trg_body         := trg_body;

    upd_pg_replace := false;
    upd_col_name := lower ( upd_col_name );

    if ( lower ( upd_col_name ) = lower ( 'EXCEPTION' ) ) then
      upd_pg_replace := true;
    end if;

    upd_ddl_text := '';
    if ( upd_pg_replace ) then
      upd_ddl_text := '    ' || PG_BEGIN || '
';
    end if;

    upd_ddl_text := upd_ddl_text || '    if ( ( :old.' || DUMMY_COL_NAME || ' is null and :new.' || DUMMY_COL_NAME || ' is not null ) or ( :old.' || DUMMY_COL_NAME || ' is not null and :new.' || DUMMY_COL_NAME || ' is null ) or ( :old.' || DUMMY_COL_NAME || ' <> :new.' || DUMMY_COL_NAME || ' ) ) then
';
    upd_ddl_text := upd_ddl_text || upd_ddl_ins;
    upd_ddl_text := replace ( upd_ddl_text, DUMMY_OP_TYPE, upd_operation_type );
    upd_ddl_text := replace ( upd_ddl_text, DUMMY_ENT_TYPE, ENT_TYPE_ENTITLEMENT );
    if ( upd_col_type = ( 'DATE' ) ) then
      upd_ddl_text := replace ( upd_ddl_text, DUMMY_COL_NAME_OLD, 'to_char ( ' || lower ( ':old.'||upd_col_name ) || ', ''DD/MM/YYYY HH24:MI:SS'' ) ');
      upd_ddl_text := replace ( upd_ddl_text, DUMMY_COL_NAME_NEW, 'to_char ( ' || lower ( ':new.'||upd_col_name ) || ', ''DD/MM/YYYY HH24:MI:SS'' ) ');
    elsif ( upd_col_type = ( 'TIMESTAMP' ) ) then
      upd_ddl_text := replace ( upd_ddl_text, DUMMY_COL_NAME_OLD, 'to_char ( ' || lower ( ':old.'||upd_col_name ) || ', ''DD/MM/YYYY HH24:MI:SS.FFFFFF'' ) ');
      upd_ddl_text := replace ( upd_ddl_text, DUMMY_COL_NAME_NEW, 'to_char ( ' || lower ( ':new.'||upd_col_name ) || ', ''DD/MM/YYYY HH24:MI:SS.FFFFFF'' ) ');
    else
      upd_ddl_text := replace ( upd_ddl_text, DUMMY_COL_NAME_OLD, lower ( ':old.'||upd_col_name ) );
      upd_ddl_text := replace ( upd_ddl_text, DUMMY_COL_NAME_NEW, lower ( ':new.'||upd_col_name ) );
    end if;
    upd_ddl_text := replace ( upd_ddl_text, DUMMY_COL_NAME, lower ( upd_col_name ) );
    upd_ddl_text := replace ( upd_ddl_text, DUMMY_COL_NAME_TXT, upper ( upd_col_name ) );

    upd_ddl_text := upd_ddl_text || '    end if;
';
    upd_ddl_text_pg := '';
    if ( upd_pg_replace ) then
      upd_col_name := '"'||upd_col_name||'"';
      upd_ddl_text_pg := '    '||COMM_OPEN||'if ( ( :old.' || DUMMY_COL_NAME || ' is null and :new.' || DUMMY_COL_NAME || ' is not null ) or ( :old.' || DUMMY_COL_NAME || ' is not null and :new.' || DUMMY_COL_NAME || ' is null ) or ( :old.' || DUMMY_COL_NAME || ' <> :new.' || DUMMY_COL_NAME || ' ) ) then
';
      upd_ddl_text_pg := upd_ddl_text_pg || upd_ddl_ins;
      upd_ddl_text_pg := replace ( upd_ddl_text_pg, DUMMY_OP_TYPE, upd_operation_type );
      upd_ddl_text_pg := replace ( upd_ddl_text_pg, DUMMY_ENT_TYPE, ENT_TYPE_ENTITLEMENT );
      if ( upd_col_type = ( 'DATE' ) ) then
        upd_ddl_text_pg := replace ( upd_ddl_text_pg, DUMMY_COL_NAME_OLD, 'to_char ( ' || ':old.'||upd_col_name || ', ''DD/MM/YYYY HH24:MI:SS'' ) ');
        upd_ddl_text_pg := replace ( upd_ddl_text_pg, DUMMY_COL_NAME_NEW, 'to_char ( ' || ':new.'||upd_col_name || ', ''DD/MM/YYYY HH24:MI:SS'' ) ');
      elsif ( upd_col_type = ( 'TIMESTAMP' ) ) then
        upd_ddl_text_pg := replace ( upd_ddl_text_pg, DUMMY_COL_NAME_OLD, 'to_char ( ' || ':old.'||upd_col_name || ', ''DD/MM/YYYY HH24:MI:SS.FFFFFF'' ) ');
        upd_ddl_text_pg := replace ( upd_ddl_text_pg, DUMMY_COL_NAME_NEW, 'to_char ( ' || ':new.'||upd_col_name || ', ''DD/MM/YYYY HH24:MI:SS.FFFFFF'' ) ');
      else
        upd_ddl_text_pg := replace ( upd_ddl_text_pg, DUMMY_COL_NAME_OLD, ':old.'||upd_col_name );
        upd_ddl_text_pg := replace ( upd_ddl_text_pg, DUMMY_COL_NAME_NEW, ':new.'||upd_col_name );
      end if;
      upd_ddl_text_pg := replace ( upd_ddl_text_pg, DUMMY_COL_NAME, upd_col_name );
      upd_ddl_text_pg := replace ( upd_ddl_text_pg, DUMMY_COL_NAME_TXT, replace ( upper ( upd_col_name ), '"', '') );

      upd_ddl_text_pg := upd_ddl_text_pg || '    end if;' || COMM_CLOSE || '
    ' || PG_END || '
';
    end if;

    upd_trg_body := upd_trg_body || upd_ddl_text || upd_ddl_text_pg;

    return upd_trg_body;

  end upd_ddl_script;


begin
  trg_head := 'create or replace trigger TRG_'|| DUMMY_TAB_NAME ||'_HISTORY
  after insert or update or delete on ' || lower ( tab_name ) || '
  for each row
declare
  counter               number(16);
  code_oper             varchar2(256);
  var_revision          number(16);
begin
';
  if ( tab_name = 'ENTITLEMENT' ) then
    trg_head := trg_head || '  --HISTORY WITH MULTI LANGUAGE NOT SUPPORTED
  select count(1) into counter from agc_language t where t.status > 0;

  if ( counter > 0 ) then
    return;
  end if;
';
  elsif ( tab_name = 'I18N_ENTITY' ) then
    trg_head := trg_head || '  if ( inserting or updating ) then
    if ( :new.entitlement is null ) then 
      return;
    end if;
  elsif ( deleting ) then
    if ( :new.entitlement is null ) then 
      return;
    end if;
  end if;
';
  end if;

  trg_head := trg_head || '
  select count(1) into counter from tmp_codoperation;

  if ( counter = 0 ) then
    RAISE_APPLICATION_ERROR ( -20200, ''NO OPERATION CODE FOUND IN TMP_CODOPERATION TABLE'');
  elsif ( counter = 1 ) then
    select code into code_oper from tmp_codoperation;
  elsif  ( counter > 1 ) then
    RAISE_APPLICATION_ERROR ( -20201, ''TOO MANY OPERATION CODE FOUND IN TMP_CODOPERATION TABLE'');
  end if;

';

  trg_body := replace ( trg_head, DUMMY_TAB_NAME, tab_name );
  trg_body := trg_body || '  if ( upper ( code_oper ) = ''REVERTING''  ) then
    return;
';

  if ( tab_name = 'ENTITLEMENT' ) then
    trg_body := trg_body || '  elsif ( inserting or updating ) then
    if ( :new.int_type = 0 ) then
      return;
    end if;
  elsif ( deleting ) then
    if ( :old.int_type = 0 ) then
      return;
    end if;
';
  end if;
  trg_body := trg_body || '  end if;

';  

  trg_body := trg_body || '  if ( inserting or updating ) then
';

  if ( tab_name = 'ENTITLEMENT' ) then
    trg_body := trg_body || '    var_revision := :new.revision;';
  elsif ( tab_name = 'I18N_ENTITY' ) then
    trg_body := trg_body || '    var_revision := ''null'';';
  end if;

  trg_body := trg_body || '
  elsif ( deleting ) then
';

  if ( tab_name = 'ENTITLEMENT' ) then
    trg_body := trg_body || '    var_revision := :old.revision;';
  elsif ( tab_name = 'I18N_ENTITY' ) then
    trg_body := trg_body || '    var_revision := ''null'';';
  end if;

  trg_body := trg_body || '
  end if;

';

  col_name := 'id';
  
  if ( tab_name <> 'ENTITLEMENT' ) then
    ddl_ins := replace ( ddl_ins, ':new.revision', 'null' );
  end if;
  
  --if inserting
  trg_body := trg_body || '  if ( inserting ) then
';
  ddl_text := ddl_ins;
  ddl_text := replace ( ddl_text, DUMMY_OP_TYPE, OPERATION_INSERT );
  ddl_text := replace ( ddl_text, DUMMY_ENT_TYPE, ENT_TYPE_ENTITLEMENT );
  ddl_text := replace ( ddl_text, '    ', '  ' );
  ddl_text := replace ( ddl_text, DUMMY_COL_NAME_OLD, 'null' );
  ddl_text := replace ( ddl_text, DUMMY_COL_NAME_NEW, 'null' );
  ddl_text := replace ( ddl_text, DUMMY_COL_NAME, 'null' );
  ddl_text := replace ( ddl_text, ''''||DUMMY_COL_NAME_TXT||'''', 'null' );

  trg_body := trg_body || ddl_text;
  trg_body := trg_body || '  end if;

';

  --if updating cycle
  trg_body := trg_body || '  if ( updating ) then
';
  open cur_col for
    select t.column_name, t.data_type from user_tab_cols t
    where t.table_name = tab_name
    and t.virtual_column = 'NO'
    and t.column_name in ( 'REVISION' )
    --and t.column_name = 'EXCEPTION'
    order by t.segment_column_id;
  loop
    fetch cur_col into col_name, col_type;
    exit when cur_col%NOTFOUND;
    
    trg_body := upd_ddl_script ( pg_replace, col_name, col_type, ddl_text, ddl_text_pg, ddl_ins, OPERATION_VERSION, trg_body );
    
  end loop;
  close cur_col;

  open cur_col for
    select t.column_name, t.data_type from user_tab_cols t
    where t.table_name = tab_name
    and t.virtual_column = 'NO'
    and t.column_name not in ( 'LAST_MOD_TIME', 'LAST_MOD_USER', 'REVISION', 'REVISION_DATE', 'REVISION_COMMENT' )
    --and t.column_name = 'EXCEPTION'
    order by t.segment_column_id;
  loop
    fetch cur_col into col_name, col_type;
    exit when cur_col%NOTFOUND;
    
    trg_body := upd_ddl_script ( pg_replace, col_name, col_type, ddl_text, ddl_text_pg, ddl_ins, OPERATION_UPDATE, trg_body );
    
  end loop;
  close cur_col;

  trg_body := trg_body || '  end if;

';

  col_name := 'id';
  --if deleting
  trg_body := trg_body || '  if ( deleting ) then
';
  ddl_text := ddl_ins;
  ddl_text := replace ( ddl_text, DUMMY_OP_TYPE, OPERATION_DELETE );
  ddl_text := replace ( ddl_text, DUMMY_ENT_TYPE, ENT_TYPE_ENTITLEMENT );
  ddl_text := replace ( ddl_text, '    ', '  ' );
  ddl_text := replace ( ddl_text, DUMMY_COL_NAME_OLD, 'null' );
  ddl_text := replace ( ddl_text, DUMMY_COL_NAME_NEW, 'null' );
  ddl_text := replace ( ddl_text, DUMMY_COL_NAME, 'null' );
  ddl_text := replace ( ddl_text, ''''||DUMMY_COL_NAME_TXT||'''', 'null' );
  ddl_text := replace ( ddl_text, ':new.', ':old.' );

  trg_body := trg_body || ddl_text;
  trg_body := trg_body || '  end if;

';

  trg_body := trg_body || replace ( trg_tail, DUMMY_TAB_NAME, tab_name );

  num_error := put_XL_line ( trg_body, num_error );
end;
/
