CREATE TABLE CHANGELOG
(
  ID                             NUMBER(16)         NOT NULL,
  PWDMANAGEMENT                  NUMBER(16),
  STATE                          NUMBER(16)         DEFAULT 0,
  COD_OPERATION                  VARCHAR2(128),
  ATTR2                          VARCHAR2(256),
  ATTR3                          VARCHAR2(256),
  ATTR4                          VARCHAR2(256),
  ATTR5                          VARCHAR2(256),
  LAST_MOD_USER                  VARCHAR2(128),
  LAST_MOD_TIME                  TIMESTAMP(6)       DEFAULT systimestamp,
  JSONATTRS                      BLOB
)
  LOB (JSONATTRS) STORE AS
  (
    TABLESPACE   &LOB_TABLESPACE
    ENABLE       STORAGE IN ROW
    CHUNK        8192
    NOCACHE
    INDEX CHANGELOG_JSONATTRS_IDX
    (
      TABLESPACE &LOB_TABLESPACE
    )
  )
TABLESPACE &DATA_TABLESPACE
;

ALTER TABLE CHANGELOG
  ADD CONSTRAINT CHANGELOG_PK PRIMARY KEY (ID)
  USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

ALTER TABLE CHANGELOG
 ADD CONSTRAINT CHANGELOG_PWDMANAGEMENT_FK
 FOREIGN KEY (PWDMANAGEMENT)
 REFERENCES PWDMANAGEMENT (ID)
 ON DELETE CASCADE;

GRANT ALL ON CHANGELOG TO IDEAS;
GRANT ALL ON CHANGELOG TO IDEAS_CONNECTOR;

CREATE SEQUENCE CHANGELOG_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER;

GRANT ALL ON CHANGELOG_SEQ TO IDEAS;
GRANT ALL ON CHANGELOG_SEQ TO IDEAS_CONNECTOR;
