CREATE TABLE CHANGELOG
(
  ID                             NUMERIC(16)         NOT NULL,
  PWDMANAGEMENT                  NUMERIC(16),
  STATE                          NUMERIC(16)         DEFAULT 0,
  COD_OPERATION                  VARCHAR(128),
  ATTR2                          VARCHAR(256),
  ATTR3                          VARCHAR(256),
  ATTR4                          VARCHAR(256),
  ATTR5                          VARCHAR(256),
  LAST_MOD_USER                  VARCHAR(128),
  LAST_MOD_TIME                  TIMESTAMP(6)        DEFAULT CURRENT_TIMESTAMP,
  JSONATTRS                      BLOB(4K)
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE CHANGELOG
  ADD CONSTRAINT CHANGELOG_PK
  PRIMARY KEY (ID);

ALTER TABLE CHANGELOG
 ADD CONSTRAINT CHANGELOG_PWDMANAGEMENT_FK
 FOREIGN KEY (PWDMANAGEMENT)
 REFERENCES PWDMANAGEMENT (ID)
 ON DELETE CASCADE;

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE CHANGELOG' );

GRANT ALL ON CHANGELOG TO IGA;
GRANT ALL ON CHANGELOG TO IGACONN;

CREATE SEQUENCE CHANGELOG_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

GRANT USAGE ON SEQUENCE CHANGELOG_SEQ TO IDEAS;
GRANT USAGE ON SEQUENCE CHANGELOG_SEQ TO IDEAS_CONNECTOR;
