declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE TABLE CHANGELOG
  (
    ID                             NUMBER(16)         NOT NULL,
    PWDMANAGEMENT                  NUMBER(16),
    STATE                          NUMBER(16)         DEFAULT 0,
    COD_OPERATION                  VARCHAR2(128),
    ATTR2                          VARCHAR2(256),
    ATTR3                          VARCHAR2(256),
    ATTR4                          VARCHAR2(256),
    ATTR5                          VARCHAR2(256),
    LAST_MOD_USER                  VARCHAR2(128),
    LAST_MOD_TIME                  TIMESTAMP(6)       DEFAULT systimestamp,
    JSONATTRS                      BLOB
  )
  LOB (JSONATTRS) STORE AS
  (
    TABLESPACE   &LOB_TABLESPACE
    ENABLE       STORAGE IN ROW
    CHUNK        8192
    NOCACHE
    INDEX CHANGELOG_JSONATTRS_IDX
    (
      TABLESPACE &LOB_TABLESPACE
    )
  )
  TABLESPACE &DATA_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE CHANGELOG
    ADD CONSTRAINT CHANGELOG_PK PRIMARY KEY (ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02275); -- such a referential constraint already exists in the table

begin
  stat := '
  ALTER TABLE CHANGELOG
   ADD CONSTRAINT CHANGELOG_PWDMANAGEMENT_FK
   FOREIGN KEY (PWDMANAGEMENT)
   REFERENCES PWDMANAGEMENT (ID)
   ON DELETE CASCADE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON CHANGELOG TO IDEAS;
GRANT ALL ON CHANGELOG TO IDEAS_CONNECTOR;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE CHANGELOG_SEQ
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999999999999
    NOCACHE
    NOCYCLE
    NOORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON CHANGELOG_SEQ TO IDEAS;
GRANT ALL ON CHANGELOG_SEQ TO IDEAS_CONNECTOR;
