declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE CHANGELOG
  (
    ID                             NUMERIC(16)         NOT NULL,
    PWDMANAGEMENT                  NUMERIC(16),
    STATE                          NUMERIC(16)         DEFAULT 0,
    COD_OPERATION                  VARCHAR(128),
    ATTR2                          VARCHAR(256),
    ATTR3                          VARCHAR(256),
    ATTR4                          VARCHAR(256),
    ATTR5                          VARCHAR(256),
    LAST_MOD_USER                  VARCHAR(128),
    LAST_MOD_TIME                  TIMESTAMP(6)        DEFAULT CURRENT_TIMESTAMP,
    JSONATTRS                      BLOB(4K)
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  LONG IN &LOB_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
  ALTER TABLE CHANGELOG
    ADD CONSTRAINT CHANGELOG_PK
    PRIMARY KEY (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  ALTER TABLE CHANGELOG
    ADD CONSTRAINT CHANGELOG_PWDMANAGEMENT_FK
    FOREIGN KEY (PWDMANAGEMENT)
    REFERENCES PWDMANAGEMENT (ID)
    ON DELETE CASCADE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE CHANGELOG' );

GRANT ALL ON CHANGELOG TO IGA;
GRANT ALL ON CHANGELOG TO IGACONN;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE SEQUENCE CHANGELOG_SEQ
    AS NUMERIC(18)
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999
    NO CACHE
    NO CYCLE
    NO ORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT USAGE ON SEQUENCE CHANGELOG_SEQ TO IGA;
GRANT USAGE ON SEQUENCE CHANGELOG_SEQ TO IGACONN;
