CREATE OR REPLACE TRIGGER TRG_USER_EVENT_ERC_SERVICE
  AFTER UPDATE OR DELETE ON USER_EVENT_ERC
  FOR EACH ROW
declare
  per_prof_status      number(16);
  counter              number(16);
  upd_per_pro_serv     boolean := true;
begin
  if ( updating and ( :new.status is null OR ( :new.status = :old.status ) OR :new.event_out is null ) ) then
    return;
  end if;

  if ( deleting and ( :old.status is null OR :old.event_out is null ) ) then
    return;
  end if;

  if ( updating ) then
    update event_out set erc_status = :new.status, trace = :new.trace where id = :new.event_out;

    --se non esiste l'entry su person_profile_service, la tabella person_profile_service non si allinea, ma la feedback si
    select count(1) into counter from person_profile_service t where t.ext_id = :new.event_out;
    if ( counter = 0 ) then
      upd_per_pro_serv := false;
    end if;

    if ( :new.status = 1 ) then
      if ( :new.operation = 12 ) then
        per_prof_status  := 2;
        --assegnazione right su target: OK
        if ( upd_per_pro_serv = true ) then
          update person_profile_service set status = per_prof_status, verify_date = sysdate
          where ext_id = :new.event_out;
        end if;
      elsif ( :new.operation = 13 ) then
        --rimozione right su target: OK
        if ( upd_per_pro_serv = true ) then
          delete from person_profile_service where ext_id = :new.event_out;
        end if;
      end if;
    end if;

    if ( :new.status >= 2 ) then
      if ( :new.operation = 12 ) then
        --assegnazione right su target: KO
        per_prof_status  := 3;
      elsif ( :new.operation = 13 ) then
        --rimozione right su target: KO
        per_prof_status  := 13;
      end if;
      if ( upd_per_pro_serv = true ) then
        update person_profile_service set status = per_prof_status, verify_date = sysdate
        where ext_id = :new.event_out;
      end if;
    end if;

  elsif ( deleting ) then
    update event_out set erc_status = :old.status, trace = :old.trace where id = :old.event_out;

    --se non esiste l'entry su person_profile_service, usciamo dal trigger, la tabella person_profile_service non si allinea
    select count(1) into counter from person_profile_service t where t.ext_id = :old.event_out;
    if ( counter = 0 ) then
      upd_per_pro_serv := false;
    end if;

    if ( :old.status = 1 ) then
      if ( :old.operation = 12 ) then
        per_prof_status  := 2;
        --assegnazione right su target: OK
        if ( upd_per_pro_serv = true ) then
          update person_profile_service set status = per_prof_status, verify_date = sysdate
          where ext_id = :old.event_out;
        end if;
      elsif ( :old.operation = 2 ) then
        --rimozione right su target: OK
        if ( upd_per_pro_serv = true ) then
          delete from person_profile_service where ext_id = :old.event_out;
        end if;
      end if;
    end if;

  end if;

end TRG_USER_EVENT_ERC_SERVICE;
/
