CREATE TABLE HR_ACCOUNT_PHOLDER
(
  ID                             NUMERIC(16)         NOT NULL,
  PLACEHOLDER                    VARCHAR(2000),
  PWDCFG                         NUMERIC(16)         NOT NULL,
  PWDCFG_ATTR_KEY                NUMERIC(16)         NOT NULL
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE HR_ACCOUNT_PHOLDER
  ADD CONSTRAINT HR_ACCOUNT_PHOLDER_PK
  PRIMARY KEY (ID);

ALTER TABLE HR_ACCOUNT_PHOLDER
 ADD CONSTRAINT HAPH_PWDCFG_FK
 FOREIGN KEY (PWDCFG)
 REFERENCES PWDCFG (ID)
 ON DELETE CASCADE;

ALTER TABLE HR_ACCOUNT_PHOLDER
 ADD CONSTRAINT HAPH_PWDCFG_ATTR_KEY_FK
 FOREIGN KEY (PWDCFG_ATTR_KEY)
 REFERENCES PWDCFG_ATTR_KEY (ID)
 ON DELETE CASCADE;

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE HR_ACCOUNT_PHOLDER' );

GRANT ALL ON HR_ACCOUNT_PHOLDER TO IGA;

CREATE SEQUENCE HR_ACCOUNT_PHOLDER_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

GRANT USAGE ON SEQUENCE HR_ACCOUNT_PHOLDER_SEQ TO IGA;
