declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE TABLE HR_ACCOUNT_PHOLDER
  (
    ID                             NUMBER(16)         NOT NULL,
    PLACEHOLDER                    VARCHAR2(2000),
    PWDCFG                         NUMBER(16)         NOT NULL,
    PWDCFG_ATTR_KEY                NUMBER(16)         NOT NULL
  )
  TABLESPACE &DATA_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE HR_ACCOUNT_PHOLDER
    ADD CONSTRAINT HR_ACCOUNT_PHOLDER_PK PRIMARY KEY (ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02275); -- such a referential constraint already exists in the table

begin
  stat := '
  ALTER TABLE HR_ACCOUNT_PHOLDER
   ADD CONSTRAINT HAPH_PWDCFG_FK
   FOREIGN KEY (PWDCFG)
   REFERENCES PWDCFG (ID)
   ON DELETE CASCADE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02275); -- such a referential constraint already exists in the table

begin
  stat := '
  ALTER TABLE HR_ACCOUNT_PHOLDER
   ADD CONSTRAINT HAPH_PWDCFG_ATTR_KEY_FK
   FOREIGN KEY (PWDCFG_ATTR_KEY)
   REFERENCES PWDCFG_ATTR_KEY (ID)
   ON DELETE CASCADE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON HR_ACCOUNT_PHOLDER TO IDEAS;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE HR_ACCOUNT_PHOLDER_SEQ
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999999999999
    NOCACHE
    NOCYCLE
    NOORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON HR_ACCOUNT_PHOLDER_SEQ TO IDEAS;
