declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE HR_ACCOUNT_PHOLDER
  (
    ID                             NUMERIC(16)         NOT NULL,
    PLACEHOLDER                    VARCHAR(2000),
    PWDCFG                         NUMERIC(16)         NOT NULL,
    PWDCFG_ATTR_KEY                NUMERIC(16)         NOT NULL
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  LONG IN &LOB_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
  ALTER TABLE HR_ACCOUNT_PHOLDER
    ADD CONSTRAINT HR_ACCOUNT_PHOLDER_PK
    PRIMARY KEY (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  ALTER TABLE HR_ACCOUNT_PHOLDER
   ADD CONSTRAINT HAPH_PWDCFG_FK
   FOREIGN KEY (PWDCFG)
   REFERENCES PWDCFG (ID)
   ON DELETE CASCADE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  ALTER TABLE HR_ACCOUNT_PHOLDER
   ADD CONSTRAINT HAPH_PWDCFG_ATTR_KEY_FK
   FOREIGN KEY (PWDCFG_ATTR_KEY)
   REFERENCES PWDCFG_ATTR_KEY (ID)
   ON DELETE CASCADE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE HR_ACCOUNT_PHOLDER' );

GRANT ALL ON HR_ACCOUNT_PHOLDER TO IGA;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE SEQUENCE HR_ACCOUNT_PHOLDER_SEQ
    AS NUMERIC(18)
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999
    NO CACHE
    NO CYCLE
    NO ORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT USAGE ON SEQUENCE HR_ACCOUNT_PHOLDER_SEQ TO IGA;
