CREATE TABLE HR_PHOLDER_CHANGES
(
  ID                             NUMBER(16)         NOT NULL,
  OBJ                            CLOB,
  PERSON                         NUMBER(16)         NOT NULL,
  DISPATCHER_ID                  NUMBER(16),
  LAST_MOD_TIME                  TIMESTAMP(6)       DEFAULT systimestamp
)
  LOB (OBJ) STORE AS
  (
    TABLESPACE   &LOB_TABLESPACE
    ENABLE       STORAGE IN ROW
    CHUNK        8192
    NOCACHE
    INDEX HR_PHOLDER_CHANGES_OBJ_IDX
    (
      TABLESPACE &LOB_TABLESPACE
    )
  )
TABLESPACE &DATA_TABLESPACE
;

ALTER TABLE HR_PHOLDER_CHANGES
  ADD CONSTRAINT HR_PHOLDER_CHANGES_PK PRIMARY KEY (ID)
  USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

ALTER TABLE HR_PHOLDER_CHANGES
 ADD CONSTRAINT HPC_PERSON_FK
 FOREIGN KEY (PERSON)
 REFERENCES PERSON (ID)
 ON DELETE CASCADE;

GRANT ALL ON HR_PHOLDER_CHANGES TO IDEAS;

CREATE SEQUENCE HR_PHOLDER_CHANGES_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER;

GRANT ALL ON HR_PHOLDER_CHANGES_SEQ TO IDEAS;
