CREATE TABLE HR_PHOLDER_CHANGES
(
  ID                             NUMERIC(16)         NOT NULL,
  OBJ                            CLOB(1M),
  PERSON                         NUMERIC(16)         NOT NULL,
  DISPATCHER_ID                  NUMERIC(16),
  LAST_MOD_TIME                  DATE                DEFAULT CURRENT_DATE
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE HR_PHOLDER_CHANGES
  ADD CONSTRAINT HR_PHOLDER_CHANGES_PK
  PRIMARY KEY (ID);

ALTER TABLE HR_PHOLDER_CHANGES
 ADD CONSTRAINT HPC_PERSON_FK
 FOREIGN KEY (PERSON)
 REFERENCES PERSON (ID)
 ON DELETE CASCADE;

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE HR_PHOLDER_CHANGES' );

GRANT ALL ON HR_PHOLDER_CHANGES TO IGA;

CREATE SEQUENCE HR_PHOLDER_CHANGES_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

GRANT USAGE ON SEQUENCE HR_PHOLDER_CHANGES_SEQ TO IGA;
