CREATE TABLE HR_PHOLDER_VALUES
(
  ID                             NUMERIC(16)         NOT NULL,
  HASH                           VARCHAR(128),
  OBJ                            CLOB(1M),
  PERSON                         NUMERIC(16)         NOT NULL,
  LAST_MOD_TIME                  DATE                DEFAULT CURRENT_DATE
)
IN &DATA_TABLESPACE
INDEX IN &INDEX_TABLESPACE
LONG IN &LOB_TABLESPACE
;

ALTER TABLE HR_PHOLDER_VALUES
  ADD CONSTRAINT HR_PHOLDER_VALUES_PK
  PRIMARY KEY (ID);

ALTER TABLE HR_PHOLDER_VALUES
 ADD CONSTRAINT HPV_PERSON_FK
 FOREIGN KEY (PERSON)
 REFERENCES PERSON (ID)
 ON DELETE CASCADE;

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE HR_PHOLDER_VALUES' );

GRANT ALL ON HR_PHOLDER_VALUES TO IGA;

CREATE SEQUENCE HR_PHOLDER_VALUES_SEQ
  AS NUMERIC(18)
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999
  NO CACHE
  NO CYCLE
  NO ORDER;

GRANT USAGE ON SEQUENCE HR_PHOLDER_VALUES_SEQ TO IGA;
