declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE TABLE HR_PHOLDER_VALUES
  (
    ID                             NUMERIC(16)         NOT NULL,
    HASH                           VARCHAR(128),
    OBJ                            CLOB,
    PERSON                         NUMERIC(16)         NOT NULL,
    LAST_MOD_TIME                  TIMESTAMP(6)        DEFAULT systimestamp
  )
    LOB (OBJ) STORE AS
    (
      TABLESPACE   &LOB_TABLESPACE
      ENABLE       STORAGE IN ROW
      CHUNK        8192
      NOCACHE
      INDEX HR_PHOLDER_VALUES_OBJ_IDX
      (
        TABLESPACE &LOB_TABLESPACE
      )
    )
  TABLESPACE &DATA_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE HR_PHOLDER_VALUES
    ADD CONSTRAINT HR_PHOLDER_VALUES_PK PRIMARY KEY (ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02275); -- such a referential constraint already exists in the table

begin
  stat := '
  ALTER TABLE HR_PHOLDER_VALUES
   ADD CONSTRAINT HPV_PERSON_FK
   FOREIGN KEY (PERSON)
   REFERENCES PERSON (ID)
   ON DELETE CASCADE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON HR_PHOLDER_VALUES TO IDEAS;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE HR_PHOLDER_VALUES_SEQ
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999999999999
    NOCACHE
    NOCYCLE
    NOORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON HR_PHOLDER_VALUES_SEQ TO IDEAS;
