CREATE OR REPLACE TRIGGER TRG_PERSON_SERVICE_TO_EVENTPM
  AFTER INSERT OR DELETE ON PERSON_SERVICE
  FOR EACH ROW
declare
  counter         numeric(16);

  code_oper       varchar(128);
  oper            numeric(5);

  prof_name       varchar(256);

  serv_attr_name  varchar(256);
  serv_attr_value varchar(256);

  per_id          numeric(16);
  profile_id      numeric(16);

begin

  if ( inserting ) then
    oper            := 12;
    per_id          := :new.person;
    profile_id      := :new.profile;
    serv_attr_name  := :new.name;
    serv_attr_value := :new.value;
    prof_name       := :new.profile_name;
  elsif ( deleting ) then
    if ( :old.attr1 = 'noEventOUT' ) then
      return;
    end if;
    oper            := 13;
    per_id          := :old.person;
    profile_id      := :old.profile;
    serv_attr_name  := :old.name;
    serv_attr_value := :old.value;
    prof_name       := :old.profile_name;
  end if;

  code_oper := 'pm_[trg_person_service_to_eventpm] not defined';

  select count(1) into counter from tmp_codoperation;

  if ( counter = 0 ) then
    RAISE_APPLICATION_ERROR ( -20200, 'NO OPERATION CODE FOUND IN TMP_CODOPERATION TABLE');
  elsif ( counter = 1 ) then
    select code into code_oper from tmp_codoperation;
  elsif  ( counter > 1 ) then
    RAISE_APPLICATION_ERROR ( -20201, 'TOO MANY OPERATION CODE FOUND IN TMP_CODOPERATION TABLE');
  end if;

  insert into eventpm
    (id,
     person,
     cod_operation,
     operation,
     entity,
     attr1,
     attr2,
     attr4)
  values
    (eventpm_seq.nextval,
     per_id,
     code_oper,
     oper,
     profile_id,
     serv_attr_name,
     serv_attr_value,
     prof_name);

end TRG_PERSON_SERVICE_TO_EVENTPM;
/
