CREATE OR REPLACE function inst_report_update_ent
(
  rep_schema in varchar2,
  app_name in varchar2,
  ft_name in varchar2
)
return number is
  cur_report     sys_refcursor;

  rep_name_query varchar2(256) := 'select id, name from '|| rep_schema ||'.report where id > 1 and dashboard = #DASH_VALUE# and status >= 0 order by name asc';
  counter        number(16);
  rep_id         number(16);
  rep_name       varchar2(256);

  app_id         number(16);
  pt_id          number(16);

begin
  app_id := inst_create_app ( null, app_name, null, 'Ideas' );

  pt_id  := inst_create_profile_type ( null, ft_name, null, app_id );

  if ( ft_name = 'report' ) then
    rep_name_query := replace ( rep_name_query, '#DASH_VALUE#', '0' );
  elsif ( ft_name = 'dashboard' ) then
    rep_name_query := replace ( rep_name_query, '#DASH_VALUE#', '1' );
  end if;

  /*PG-BEGIN*/
  open cur_report for rep_name_query;
  /*open cur_report for execute rep_name_query;*/
  /*PG-END*/
  loop
    fetch cur_report into rep_id, rep_name;
    exit when cur_report%NOTFOUND;

    select count(1) into counter from entitlement e
    where lower ( e.name ) like lower ( rep_name )
    and e.application = app_id and e.profile_type = pt_id;
    if ( counter > 0 ) then
      execute immediate ( 'update entitlement set attr5 = ''' || rep_id
                           || ''' where name = ''' || replace (  rep_name, '''', '''''' )
                           || ''' and application = '|| app_id
                           || ' and profile_type = ' || pt_id );

      execute immediate ( 'update ' || rep_schema ||'.report '
                           || 'set status = 2 where id = ' || rep_id );
    end if;
  end loop;

  return -1;
end inst_report_update_ent;
/
