declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-01430); -- column being added already exists in table

begin
  stat := '
  ALTER TABLE CLASS_NAME
    ADD IS_ACCOUNT NUMBER(1) DEFAULT 0
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-01430); -- column being added already exists in table

begin
  stat := '
  ALTER TABLE CLASS_NAME
    ADD IS_USER NUMBER(1) DEFAULT 0
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-01430); -- column being added already exists in table

begin
  stat := '
  ALTER TABLE CLASS_NAME
    ADD PROFILE_REF VARCHAR2(128)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

update class_name set is_user = 1, is_account = 1;
commit;

DROP INDEX CLASS_NAME_LVALUE_IDX;

DROP INDEX CLASS_NAME_VALUE_IDX;

CREATE INDEX CLASS_NAME_LVALUE_IDX ON CLASS_NAME (LOWER(VALUE))
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;

CREATE INDEX CLASS_NAME_VALUE_IDX ON CLASS_NAME (VALUE)
NOLOGGING
NOPARALLEL
TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS;
