declare
  counter         numeric(16);
  drv_type_id     numeric(16);
  drv_type_name   varchar(64) := 'Identity Brokerage';

  cname_id        numeric(16);
  cname_pref      varchar(256) := 'PosixSolarisProfile';
  cname_name      varchar(256) := 'POSIX Solaris profile';
  cname_value     varchar(256) := 'com.crossideas.ideasconnector.drivers.ib.TargetBrokerageDriver';

begin

  -- Checking driver type existence: if it does not exist, exit
  select count(1) into counter from driver_type dt where lower ( dt.name ) = lower ( drv_type_name );
  if ( counter = 1 ) then
    select dt.id into drv_type_id from driver_type dt where lower ( dt.name ) = lower ( drv_type_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO DRIVER TYPE FOUND!');
  end if;

  select count(1) into counter from class_name cn where lower ( cn.profile_ref ) = lower ( cname_pref );
  if ( counter = 1 ) then
    update class_name cn set value = cname_value, description = '', is_account = 1, is_user = 0, name = cname_name, type = drv_type_id
	where lower ( cn.profile_ref ) = lower ( cname_pref );
  else
    select class_name_seq.nextval into cname_id from dual;
	insert into class_name ( id, type, name, value, description, is_account, is_user, profile_ref )
	values ( cname_id, drv_type_id, cname_name, cname_value, '', 1, 0, cname_pref );
  end if;

end;
/
commit;
