declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-01430); -- column being added already exists in table

begin
  stat := '
  ALTER TABLE DRIVER
    ADD CLASS_NAME NUMBER(16)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

update driver d set class_name = (
  select cn.id from class_name cn where d.class = cn.value
);

commit;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02275); -- such a referential constraint already exists in the table

begin
  stat := '
  ALTER TABLE DRIVER ADD (
   CONSTRAINT DRIVER_CLASS_NAME_FK
   FOREIGN KEY (CLASS_NAME)
   REFERENCES CLASS_NAME (ID)
   ON DELETE SET NULL
  )
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/
