declare
  counter         numeric(16);
  drv_type_id     numeric(16);
  drv_type_name   varchar(64) := 'Governance';

  cname_id        numeric(16);
  cname_name      varchar(256) := 'Governance';
  cname_value     varchar(256) := 'com.crossideas.ideasconnector.drivers.governance.GovernanceDriver';

begin

  -- Checking driver type existence: if it does not exist, exit
  select count(1) into counter from driver_type dt where lower ( dt.name ) = lower ( drv_type_name );
  if ( counter = 1 ) then
    select dt.id into drv_type_id from driver_type dt where lower ( dt.name ) = lower ( drv_type_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO DRIVER TYPE FOUND!');
  end if;

  select count(1) into counter from class_name cn where lower ( cn.name ) = lower ( cname_name ) and cn.type = drv_type_id;
  if ( counter = 1 ) then
    update class_name cn set value = cname_value, is_account = 1, is_user = 1, is_system = 1, is_default = 1
	where lower ( cn.name ) = lower ( cname_name ) and cn.type = drv_type_id;
  else
    select class_name_seq.nextval into cname_id from dual;
	insert into class_name ( id, type, name, value, is_account, is_user, is_system, is_default )
	values ( cname_id, drv_type_id, cname_name, cname_value, 1, 1, 1, 1 );
  end if;

end;
/
commit;
