declare
  counter            number(16);
  drv_type_id        number(16);
  drv_type_name      varchar2(64) := 'Governance';

  cname_id           number(16);
  cname_name         varchar2(256) := 'Governance';
  cname_value        varchar2(256) := 'com.crossideas.ideasconnector.drivers.governance.GovernanceDriver';

  driver_id          number(16);
  driver_name        varchar2(64) := 'Governance';
  driver_value       varchar2(256) := 'Governance';
  driver_description varchar2(512) := 'Internal IGI driver';

begin

  -- Checking driver type existence: if it does not exist, exit
  select count(1) into counter from driver_type dt where lower ( dt.name ) = lower ( drv_type_name );
  if ( counter = 1 ) then
    select dt.id into drv_type_id from driver_type dt where lower ( dt.name ) = lower ( drv_type_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO DRIVER TYPE FOUND!');
  end if;

  select count(1) into counter from class_name cn where lower ( cn.name ) = lower ( cname_name ) and cn.type = drv_type_id;
  if ( counter = 1 ) then
    select cn.id into cname_id from class_name cn where lower ( cn.name ) = lower ( cname_name ) and cn.type = drv_type_id;
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO CLASS NAME FOUND!');
  end if;

  select count(1) into counter from driver d where lower ( d.name ) = lower ( driver_name );
  if ( counter = 1 ) then
    update driver d set value = driver_value, description = driver_description, class_name = cname_id, driver_type = drv_type_id, state = 1
    where lower ( d.name ) = lower ( driver_name );
  else
    select driver_seq.nextval into driver_id from dual;
	insert into driver ( id, name, value, description, class_name, driver_type, state )
	values ( driver_id, driver_name, driver_value, driver_description, cname_id, drv_type_id, 1 );
  end if;

end;
/
commit;
