#!/bin/bash

UPGRADE_SCRIPT=$PWD

cd $UPGRADE_SCRIPT/AccessGovernanceCoreBackend
$SQLPLUS_CMD iga_admin/$SCHEMA_PWD@$ORACLE_SERVER @agc_pre_req_upgrade_75_to_76.sql
$SQLPLUS_CMD iga_core/$SCHEMA_PWD@$ORACLE_SERVER @agc_pre_req_upgrade_75_to_76.sql
$SQLPLUS_CMD ccs_core/$SCHEMA_PWD@$ORACLE_SERVER @arc4s_pre_req_upgrade_75_to_76.sql

cd $UPGRADE_SCRIPT/Localization
$SQLPLUS_CMD iga_admin/$SCHEMA_PWD@$ORACLE_SERVER @agc_localization_upgrade_11_to_12.sql
$SQLPLUS_CMD iga_core/$SCHEMA_PWD@$ORACLE_SERVER @agc_localization_upgrade_11_to_12.sql
$SQLPLUS_CMD ccs_core/$SCHEMA_PWD@$ORACLE_SERVER @arc4s_localization_upgrade_11_to_12.sql

cd $UPGRADE_SCRIPT/AccessGovernanceCoreBackend
$SQLPLUS_CMD iga_admin/$SCHEMA_PWD@$ORACLE_SERVER @agc_upgrade_75_to_76.sql
$SQLPLUS_CMD iga_core/$SCHEMA_PWD@$ORACLE_SERVER @agc_upgrade_75_to_76.sql
$SQLPLUS_CMD ccs_core/$SCHEMA_PWD@$ORACLE_SERVER @arc4s_upgrade_75_to_76.sql

cd $UPGRADE_SCRIPT/AccessRequestsBackend
$SQLPLUS_CMD iga_admin/$SCHEMA_PWD@$ORACLE_SERVER @arm_upgrade_15_to_16.sql
$SQLPLUS_CMD iga_core/$SCHEMA_PWD@$ORACLE_SERVER @arm_upgrade_15_to_16.sql

cd $UPGRADE_SCRIPT/AccessOptimizerBackend
$SQLPLUS_CMD aa_admin/$SCHEMA_PWD@$ORACLE_SERVER @aa_upgrade_55_to_56.sql
$SQLPLUS_CMD aa_core/$SCHEMA_PWD@$ORACLE_SERVER @aa_upgrade_55_to_56.sql

cd $UPGRADE_SCRIPT/AccessRiskControlsForSAPBackend
$SQLPLUS_CMD ccs_core/$SCHEMA_PWD@$ORACLE_SERVER @arc4s_upgrade_45_to_46.sql

cd $UPGRADE_SCRIPT/DeskBackend
$SQLPLUS_CMD iga_service/$SCHEMA_PWD@$ORACLE_SERVER @desk_upgrade_25_to_26.sql

cd $UPGRADE_SCRIPT/EmailBackend
$SQLPLUS_CMD iga_admin/$SCHEMA_PWD@$ORACLE_SERVER @es_upgrade_25_to_26.sql
$SQLPLUS_CMD iga_core/$SCHEMA_PWD@$ORACLE_SERVER @es_upgrade_25_to_26.sql

cd $UPGRADE_SCRIPT/EnterpriseConnectorsBackend
$SQLPLUS_CMD iga_admin/$SCHEMA_PWD@$ORACLE_SERVER @ec_upgrade_35_to_36.sql
$SQLPLUS_CMD iga_core/$SCHEMA_PWD@$ORACLE_SERVER @ec_upgrade_35_to_36.sql

cd $UPGRADE_SCRIPT/JobBackend
$SQLPLUS_CMD aa_admin/$SCHEMA_PWD@$ORACLE_SERVER @job_upgrade_25_to_26_on_AA.sql
$SQLPLUS_CMD aa_core/$SCHEMA_PWD@$ORACLE_SERVER @job_upgrade_25_to_26_on_AA.sql
$SQLPLUS_CMD iga_admin/$SCHEMA_PWD@$ORACLE_SERVER @job_upgrade_25_to_26_on_AGC.sql
$SQLPLUS_CMD iga_core/$SCHEMA_PWD@$ORACLE_SERVER @job_upgrade_25_to_26_on_AGC.sql
$SQLPLUS_CMD ccs_core/$SCHEMA_PWD@$ORACLE_SERVER @job_upgrade_25_to_26_on_ARC4S.sql
$SQLPLUS_CMD iga_report_admin/$SCHEMA_PWD@$ORACLE_SERVER @job_upgrade_25_to_26_on_REPORT.sql
$SQLPLUS_CMD iga_report_core/$SCHEMA_PWD@$ORACLE_SERVER @job_upgrade_25_to_26_on_REPORT.sql

cd $UPGRADE_SCRIPT/ReportBackend
$SQLPLUS_CMD iga_report_admin/$SCHEMA_PWD@$ORACLE_SERVER @rd_upgrade_25_to_26.sql
$SQLPLUS_CMD iga_report_core/$SCHEMA_PWD@$ORACLE_SERVER @rd_upgrade_25_to_26.sql

cd $UPGRADE_SCRIPT/RuleEngineBackend
$SQLPLUS_CMD iga_admin/$SCHEMA_PWD@$ORACLE_SERVER @re_upgrade_25_to_26.sql
$SQLPLUS_CMD iga_core/$SCHEMA_PWD@$ORACLE_SERVER @re_upgrade_25_to_26.sql
$SQLPLUS_CMD ccs_core/$SCHEMA_PWD@$ORACLE_SERVER @re_upgrade_25_to_26.sql

cd $UPGRADE_SCRIPT/TaskPlannerBackend
$SQLPLUS_CMD iga_quartz/$SCHEMA_PWD@$ORACLE_SERVER @quartz_upgrade.sql
$SQLPLUS_CMD iga_service/$SCHEMA_PWD@$ORACLE_SERVER @sk_upgrade_25_to_26.sql

cd $UPGRADE_SCRIPT/AuditHelper
$SQLPLUS_CMD iga_service/$SCHEMA_PWD@$ORACLE_SERVER @account_upgrade_35_to_36.sql

cd $UPGRADE_SCRIPT/SIB_IB_ILC
$SQLPLUS_CMD itimuser/$SCHEMA_PWD@$ORACLE_SERVER @IB_ILC_upgrade.sql
$SQLPLUS_CMD itiml000/$SCHEMA_PWD@$ORACLE_SERVER @SIB_upgrade.sql

cd $UPGRADE_SCRIPT/AccessGovernanceCoreBackend
$SQLPLUS_CMD iga_admin/$SCHEMA_PWD@$ORACLE_SERVER @report_assignment.sql
$SQLPLUS_CMD iga_core/$SCHEMA_PWD@$ORACLE_SERVER @report_assignment.sql

cd $UPGRADE_SCRIPT/ReportBackend
$SQLPLUS_CMD iga_report_admin/$SCHEMA_PWD@$ORACLE_SERVER @revoke_from_agc.sql
$SQLPLUS_CMD iga_report_core/$SCHEMA_PWD@$ORACLE_SERVER @revoke_from_agc.sql

cd $UPGRADE_SCRIPT/IdeasModule
$SQLPLUS_CMD aa_admin/$SCHEMA_PWD@$ORACLE_SERVER @ideas_module_upgrade.sql
$SQLPLUS_CMD aa_core/$SCHEMA_PWD@$ORACLE_SERVER @ideas_module_upgrade.sql
$SQLPLUS_CMD iga_admin/$SCHEMA_PWD@$ORACLE_SERVER @ideas_module_upgrade.sql
$SQLPLUS_CMD iga_core/$SCHEMA_PWD@$ORACLE_SERVER @ideas_module_upgrade.sql
$SQLPLUS_CMD ccs_core/$SCHEMA_PWD@$ORACLE_SERVER @ideas_module_upgrade.sql
$SQLPLUS_CMD iga_report_admin/$SCHEMA_PWD@$ORACLE_SERVER @ideas_module_upgrade.sql
$SQLPLUS_CMD iga_report_core/$SCHEMA_PWD@$ORACLE_SERVER @ideas_module_upgrade.sql

cd $UPGRADE_SCRIPT
