#!/bin/bash

if [ -z "$DB2_SERVER" ]; then
  export DB2_SERVER=[DB2_FULLY_QUALIFIED_SERVER_NAME]
fi

if [ -z "$SCHEMA_PWD" ]; then
  export SCHEMA_PWD=ideas
fi

if [ -z "$DB2_HOME" ]; then
  export DB2_HOME=/home/db2inst1/sqllib
fi

if [ -z "$CLPPLUS_CMD" ]; then
  export CLPPLUS_CMD=$DB2_HOME/bin/clpplus
fi

UPGRADE_SCRIPT=$(cd $(dirname $0) && pwd)
CURRENT_DIR=$PWD

cd $UPGRADE_SCRIPT/AccessGovernanceCoreBackend
$CLPPLUS_CMD -nw igaadm/$SCHEMA_PWD@$DB2_SERVER @va_app_perm.sql
$CLPPLUS_CMD -nw igaadm/$SCHEMA_PWD@$DB2_SERVER @agc_upgrade_76_to_77.sql
$CLPPLUS_CMD -nw igacore/$SCHEMA_PWD@$DB2_SERVER @agc_upgrade_76_to_77.sql
$CLPPLUS_CMD -nw ccscore/$SCHEMA_PWD@$DB2_SERVER @arc4s_upgrade_76_to_77.sql

cd $UPGRADE_SCRIPT/AccessRequestsBackend
$CLPPLUS_CMD -nw igaadm/$SCHEMA_PWD@$DB2_SERVER @arm_upgrade_16_to_17.sql
$CLPPLUS_CMD -nw igacore/$SCHEMA_PWD@$DB2_SERVER @arm_upgrade_16_to_17.sql

cd $UPGRADE_SCRIPT/DeskBackend
$CLPPLUS_CMD -nw igaserv/$SCHEMA_PWD@$DB2_SERVER @desk_upgrade_26_to_27.sql

cd $UPGRADE_SCRIPT/ReportBackend
$CLPPLUS_CMD -nw repadm/$SCHEMA_PWD@$DB2_SERVER @rd_upgrade_26_to_27.sql
$CLPPLUS_CMD -nw repcore/$SCHEMA_PWD@$DB2_SERVER @rd_upgrade_26_to_27.sql

cd $UPGRADE_SCRIPT/TaskPlannerBackend
$CLPPLUS_CMD -nw igaserv/$SCHEMA_PWD@$DB2_SERVER @sk_upgrade_26_to_27.sql

cd $UPGRADE_SCRIPT/AccessGovernanceCoreBackend
$CLPPLUS_CMD -nw igaadm/$SCHEMA_PWD@$DB2_SERVER @report_assignment.sql
$CLPPLUS_CMD -nw igacore/$SCHEMA_PWD@$DB2_SERVER @report_assignment.sql

cd $UPGRADE_SCRIPT/ReportBackend
$CLPPLUS_CMD -nw repadm/$SCHEMA_PWD@$DB2_SERVER @revoke_from_agc.sql
$CLPPLUS_CMD -nw repcore/$SCHEMA_PWD@$DB2_SERVER @revoke_from_agc.sql

cd $UPGRADE_SCRIPT/Survey
$CLPPLUS_CMD -nw igacore/$SCHEMA_PWD@$DB2_SERVER @survey.sql

cd $CURRENT_DIR
