#!/bin/bash

if [ -z "$ORACLE_SERVER" ]; then
  export ORACLE_SERVER=ORACLE_SERVER_TNS_NAME
fi

if [ -z "$SCHEMA_PWD" ]; then
  export SCHEMA_PWD=ideas
fi

if [ -z "$ORACLE_BASE" ]; then
  export ORACLE_BASE=/home/oracle
fi

if [ -z "$ORACLE_HOME" ]; then
  export ORACLE_HOME=$ORACLE_BASE/app/oracle/product/12.1.0/dbhome_1
fi

if [ -z "$SQLPLUS_CMD" ]; then
  export SQLPLUS_CMD=$ORACLE_HOME/bin/sqlplus
fi

UPGRADE_SCRIPT=$(cd $(dirname $0) && pwd)
CURRENT_DIR=$PWD

cd $UPGRADE_SCRIPT/AccessGovernanceCoreBackend
$SQLPLUS_CMD iga_admin/$SCHEMA_PWD@$ORACLE_SERVER @va_app_perm.sql
$SQLPLUS_CMD iga_admin/$SCHEMA_PWD@$ORACLE_SERVER @agc_upgrade_76_to_77.sql
$SQLPLUS_CMD iga_core/$SCHEMA_PWD@$ORACLE_SERVER @agc_upgrade_76_to_77.sql
$SQLPLUS_CMD ccs_core/$SCHEMA_PWD@$ORACLE_SERVER @arc4s_upgrade_76_to_77.sql

cd $UPGRADE_SCRIPT/AccessRequestsBackend
$SQLPLUS_CMD iga_admin/$SCHEMA_PWD@$ORACLE_SERVER @arm_upgrade_16_to_17.sql
$SQLPLUS_CMD iga_core/$SCHEMA_PWD@$ORACLE_SERVER @arm_upgrade_16_to_17.sql

cd $UPGRADE_SCRIPT/DeskBackend
$SQLPLUS_CMD iga_service/$SCHEMA_PWD@$ORACLE_SERVER @desk_upgrade_26_to_27.sql

cd $UPGRADE_SCRIPT/ReportBackend
$SQLPLUS_CMD iga_report_admin/$SCHEMA_PWD@$ORACLE_SERVER @rd_upgrade_26_to_27.sql
$SQLPLUS_CMD iga_report_core/$SCHEMA_PWD@$ORACLE_SERVER @rd_upgrade_26_to_27.sql

cd $UPGRADE_SCRIPT/TaskPlannerBackend
$SQLPLUS_CMD iga_service/$SCHEMA_PWD@$ORACLE_SERVER @sk_upgrade_26_to_27.sql

cd $UPGRADE_SCRIPT/AccessGovernanceCoreBackend
$SQLPLUS_CMD iga_admin/$SCHEMA_PWD@$ORACLE_SERVER @report_assignment.sql
$SQLPLUS_CMD iga_core/$SCHEMA_PWD@$ORACLE_SERVER @report_assignment.sql

cd $UPGRADE_SCRIPT/ReportBackend
$SQLPLUS_CMD iga_report_admin/$SCHEMA_PWD@$ORACLE_SERVER @revoke_from_agc.sql
$SQLPLUS_CMD iga_report_core/$SCHEMA_PWD@$ORACLE_SERVER @revoke_from_agc.sql

cd $UPGRADE_SCRIPT/Survey
$SQLPLUS_CMD iga_core/$SCHEMA_PWD@$ORACLE_SERVER @survey.sql

cd $CURRENT_DIR
