#!/bin/bash

export ORACLE_SERVER=ORACLE_SERVER_TNS_NAME
export SCHEMA_PWD=ideas

if [ -z "$ORACLE_BASE" ]; then
  export ORACLE_BASE=/home/oracle
fi

if [ -z "$ORACLE_HOME" ]; then
  export ORACLE_HOME=$ORACLE_BASE/app/oracle/product/12.1.0/dbhome_1
fi

if [ -z "$SQLPLUS_CMD" ]; then
  export SQLPLUS_CMD=$ORACLE_HOME/bin/sqlplus
fi

UPGRADE_SCRIPT=$(cd $(dirname $0) && pwd)
CURRENT_DIR=$PWD

cd $UPGRADE_SCRIPT/_PREV_REL/migration_522
echo "*** STEP1: upgrading to 5.2.2 level ***"
echo "Current directory: $PWD"
./oracle_update.sh

if [ $? -eq 0 ]; then

  cd $UPGRADE_SCRIPT/_PREV_REL/migration_523
  echo "*** STEP2: upgrading to 5.2.3 level ***"
  echo "Current directory: $PWD"
  ./oracle_update.sh

  if [ $? -eq 0 ]; then

    cd $UPGRADE_SCRIPT
    echo "*** STEP3: upgrading to 5.2.4 level ***"
    echo "Current directory: $PWD"
    ./oracle_update.sh

  fi

fi

cd $CURRENT_DIR
